{*****************************************************
  Prosthetic Delayed Order Report - GUI    ver 1.3.59   June 25,2003
  Office of Information Field Office
  Department of Veterans Affairs
  Hines,Illinois

  Developers: Helen Corkwell, Sam Spencer, Ken Nelson
  Description: GUI to view, calculate, and print the status of consults
  Requires: RMPR*3.0*59, RMPR*3*136

*******************************************************}

unit PROS_DOR_Consult;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Fmcntrls, Diaccess, Fmcmpnts, Trpcb,DiTypLib, Grids, MyGrids,
  SortGrid, ComCtrls, Buttons, MFunStr, SRGrad, ESBDates, Rpcconf1,// Psock,
  {NMsmtp,} ExtCtrls, FileCtrl, ShellAPI, NumEdit, Menus, CurrEdit, Registry,
  Printers, ProgBar, AppEvnts;


type
  TfrmConsult = class(TForm)
    btnRefresh: TBitBtn;
    grdConsult: TSortGrid;
    btnViewRequest: TBitBtn;
    edtUserID: TEdit;
    btnViewCPRS: TBitBtn;
    btnClose: TBitBtn;
    lblMainBanner: TLabel;
    lblSite: TLabel;
    lblStartSSN: TLabel;
    lblEndSSN: TLabel;
    cbxSiteSelection: TFMComboBoxLookUp;
    edtStartSSN: TEdit;
    edtEndSSN: TEdit;
    btnDisplay: TBitBtn;
    lblBegDate: TLabel;
    dtpkrBegDate: TDateTimePicker;
    lblStatus: TLabel;
    chkOpen: TCheckBox;
    chkPending: TCheckBox;
    chkCancelled: TCheckBox;
    chkClosed: TCheckBox;
    dbsListerSite: TFMLister;
    dbsFinderSite: TFMFinder;
    btnView2319: TBitBtn;
    btnExcel: TBitBtn;
    chkAllSites: TCheckBox;
    lblTotalDelayed: TLabel;
    btnViewCalcDetail: TBitBtn;
    lblPercentDelayed: TLabel;
    btnPendingCalc: TBitBtn;
    mnuDOR: TMainMenu;
    mnuItemFile: TMenuItem;
    mnuItemSelectAndDisplay: TMenuItem;
    mnuItemView: TMenuItem;
    mnuItemHelp: TMenuItem;
    mnuItemExcel: TMenuItem;
    mnuItemView2319: TMenuItem;
    mnuItemViewCPRS: TMenuItem;
    mnuItemViewRequest: TMenuItem;
    mnuItemViewDOR: TMenuItem;
    mnuItemViewPendingCalc: TMenuItem;
    mnuItemViewSeperator: TMenuItem;
    mnuItemSelectSite: TMenuItem;
    mnuItemBegDate: TMenuItem;
    mnuItemSelectStatus: TMenuItem;
    mnuItemSelectStartingSSN: TMenuItem;
    mnuItemSelectEndingSSN: TMenuItem;
    mnuItemDisplay: TMenuItem;
    mnuItemSelectSeperator1: TMenuItem;
    mnuItemSelectSeperator: TMenuItem;
    mnuItemClose: TMenuItem;
    mnuItemOpen: TMenuItem;
    mnuItemPending: TMenuItem;
    mnuItemCancelled: TMenuItem;
    mnuItemClosed: TMenuItem;
    mnuItemFileSeperator1: TMenuItem;
    stsbrConsult: TStatusBar;
    imgGradient: TSRGradient;
    lblTotalRecords: TLabel;
    btnPrint: TBitBtn;
    dlgPrint: TPrintDialog;
    edtTotalRecords: TCurrencyEdit;
    edtTotalDelayed: TCurrencyEdit;
    mnuItemPrint: TMenuItem;
    numItemHelpContents: TMenuItem;
    mnuItemHelpSeperator1: TMenuItem;
    mnuSection508: TMenuItem;
    mnuItemHelpSeperator2: TMenuItem;
    edtPercentDelayed: TCurrencyEdit;
    mnuItemPrintRequestGrid: TMenuItem;
    mnuItemPrintCalculationDetail: TMenuItem;
    mnuItemPrintPendingGrid: TMenuItem;
    mnuItemSendRequest: TMenuItem;
    mnuItemSendPending: TMenuItem;
    mnuItemClear: TMenuItem;
    mnuItemRefresh: TMenuItem;
    mnuItemFileSeperator2: TMenuItem;
    btnClear: TBitBtn;
    mnuItemAbout: TMenuItem;
    pnlProgressBar: TPanel;
    appDOR: TApplicationEvents;
    svdlgDOR: TSaveDialog;
    lblExcelPath: TLabel;
    opndlgDOR: TOpenDialog;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure btnRefreshClick(Sender: TObject);
    procedure grdConsultDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure grdConsultClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DisplayHint(Sender: TObject);
    procedure btnViewCPRSClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure CheckSec508;
    procedure grdConsultGetSortStyle(Sender: TObject; Col: Integer;
      var SortStyle: TSortStyle);
    procedure grdConsultGetCellFormat(Sender: TObject; Col, Row: Integer;
      State: TGridDrawState; var FormatOptions: TFormatOptions;
      var CheckBox, Combobox, Ellipsis: Boolean);
    procedure edtStartSSNKeyPress(Sender: TObject; var Key: Char);
    procedure edtEndSSNKeyPress(Sender: TObject; var Key: Char);
    procedure btnViewRequestClick(Sender: TObject);
    procedure edtStartSSNExit(Sender: TObject);
    procedure edtEndSSNExit(Sender: TObject);
    procedure dtpkrBegDateChange(Sender: TObject);
    procedure cbxSiteSelectionExit(Sender: TObject);
    procedure btnView2319Click(Sender: TObject);
    procedure chkAllSitesClick(Sender: TObject);
    procedure cbxSiteSelectionDropDown(Sender: TObject);
    procedure btnExcelClick(Sender: TObject);
    procedure btnViewCalcDetailClick(Sender: TObject);
    procedure edtStartSSNClick(Sender: TObject);
    procedure edtEndSSNClick(Sender: TObject);
    procedure dtpkrBegDateCloseUp(Sender: TObject);
    procedure mnuItemOpenClick(Sender: TObject);
    procedure mnuItemBegDateClick(Sender: TObject);
    procedure mnuItemDisplayClick(Sender: TObject);
    procedure mnuItemSelectStartingSSNClick(Sender: TObject);
    procedure mnuItemSelectEndingSSNClick(Sender: TObject);
    procedure btnPendingCalcClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure mnuItemClearClick(Sender: TObject);
    procedure mnuItemCloseClick(Sender: TObject);
    procedure mnuItemSelectSiteClick(Sender: TObject);
    procedure mnuItemView2319Click(Sender: TObject);
    procedure mnuItemViewCPRSClick(Sender: TObject);
    procedure mnuItemViewRequestClick(Sender: TObject);
    procedure mnuItemViewDORClick(Sender: TObject);
    procedure mnuItemViewPendingCalcClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuItemPendingClick(Sender: TObject);
    procedure mnuItemCancelledClick(Sender: TObject);
    procedure mnuItemClosedClick(Sender: TObject);
    procedure mnuItemSelectStatusClick(Sender: TObject);
    procedure mnuItemAboutClick(Sender: TObject);
    procedure mnuSection508Click(Sender: TObject);
    procedure mnuItemPrintRequestGridClick(Sender: TObject);
    procedure mnuItemPrintCalculationDetailClick(Sender: TObject);
    procedure mnuItemPrintPendingGridClick(Sender: TObject);
    procedure mnuItemSendRequestClick(Sender: TObject);
    procedure mnuItemSendPendingClick(Sender: TObject);
    procedure grdConsultDblClick(Sender: TObject);
    procedure mnuItemRefreshClick(Sender: TObject);
    procedure grdConsultRowSelected(Sender: TObject);
    procedure cbxSiteSelectionEnter(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure numItemHelpContentsClick(Sender: TObject);
    procedure appDORMessage(var Msg: tagMSG;
      var Handled: Boolean);


  private
    ExcelFile : String; //added RMPR*136
       { Private declarations }
//    procedure WMWindowPosChanging(var Msg : TMessage) ;
//               message WM_WINDOWPOSCHANGING ;

  public
      { Public declarations }
  end;

var
  frmConsult: TfrmConsult;
  fDate1, fDate2, SelP : integer;
  sDate1, sDate2, PrnHeader, PatName, PatSSN, PatID,
  IEN442, IEN668, IEN666, IFCAPNum, UserID, SiteID, StartSSN,
  EndSSN, ConsultStatus, DORStartDate, Sec508, OP,PE,CA,CL : String;


implementation


uses
  PROS_DOR_CalcDetail, PROS_DOR_PendingCalc, Pros_Menu, PROS_DOR_ViewReq,
  PROS_DOR_ViewCPRS, PROS_DOR_View2319, PROS_Menu_About;


{$R *.DFM}

procedure TfrmConsult.CheckSec508; //Checks the SEC508 registry Key
var
  reg : TRegistry;
begin
   reg := TRegistry.Create;
   reg.rootkey := HKEY_LOCAL_MACHINE;
   reg.OpenKey('\SOFTWARE\VISTA\PROS\DelayedOrderReport',False);
   Sec508 := reg.ReadString('Sec508');  //Assign result to global
   reg.Free;
end;


//procedure TfrmConsult.WMWindowPosChanging(var Msg : TMessage) ;
//begin       { do not allow user to move or resize the window }
//     with PWindowPos(Msg.LParam)^ do
//        Flags := Flags or SWP_NOMOVE or SWP_NOSIZE ;
//end;


procedure TfrmConsult.DisplayHint(Sender: TObject);
begin
  stsbrConsult.SimpleText := Application.Hint; //For Sec508
end;


procedure DeleteFiles(sMask, sPath: string);
var
  SearchRec: TSearchRec;
  Found: Integer;
begin
  sPath := (sPath);
  Found := SysUtils.FindFirst(sPath + sMask, faAnyFile, SearchRec); 
  try
    while (Found = 0) do
    begin
      if not (SearchRec.Attr and faDirectory > 0) then
        SysUtils.DeleteFile(sPath + SearchRec.Name);
      Found := 1;//SysUtils.FindNext(SearchRec);
    end;
  finally
    SysUtils.FindClose(SearchRec);
  end;
end; // Usage:  DeleteFiles('*.txt', 'c:\myfiles');

//********

procedure TfrmConsult.grdConsultDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
    i : integer;
begin
  with grdConsult do
  begin
  // Draw the Bands with alternating colors

     if ARow mod 2 = 0 then
        Canvas.Brush.Color := $CFFFFF    //light yellow
       else
        Canvas.Brush.Color := $FFFFFF;   //white


  // Don't change color for first Column, first row
    if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace
    else
    begin
      case ACol of


        1: for i := 0 to grdConsult.RowCount do //Sets cell color
            begin
            if (ARow = i) and (Cells[1,i] = 'OPEN') then
             begin
               Canvas.Font.Color := clBlue;
               Canvas.Font.Style := [fsBold]
             end;
            end;

      4: Canvas.Font.Color := clBlack;


        6: for i := 0 to grdConsult.RowCount do //Sets cell color
            begin
             if Cells[6,i] <> '' then
             begin
            if (ARow = i) and (StrToInt(Cells[6,i]) > 0) then  //First level
             begin
               Canvas.Font.Color := clBlack;
               Canvas.Font.Style := [fsBold];
               //Canvas.Brush.Color := clYellow;
             end;
          end;
         end;

        7: for i := 0 to grdConsult.RowCount do //Sets cell color
            begin
             if Cells[7,i] <> '' then
             begin
            if (ARow = i) and (StrToInt(Cells[7,i]) > 0) then
             begin
               Canvas.Font.Color := clYellow;
               Canvas.Font.Style := [fsBold];
               Canvas.Brush.Color := clRed;
             end;
            end;
          end;

        8: for i := 0 to grdConsult.RowCount do  //Sets cell color
            begin
             if Cells[8,i] <> '' then
             begin
            if (ARow = i) and (StrToInt(Cells[8,i]) > 0) then //Second level
             begin
               Canvas.Font.Color := clYellow;
               Canvas.Font.Style := [fsBold];
               Canvas.Brush.Color := clRed;
             end;
            end;
          end;

        9: for i := 0 to grdConsult.RowCount do //Sets cell color
            begin
             if Cells[9,i] <> '' then
             begin
            if (ARow = i) and (StrToInt(Cells[9,i]) > 0) then //Second level
             begin
               Canvas.Font.Color := clYellow;
               Canvas.Font.Style := [fsBold];
               Canvas.Brush.Color := clRed;
             end;
            end;
          end;

        10: for i := 0 to grdConsult.RowCount do //Sets cell color
            begin
             if Cells[10,i] <> '' then
             begin
            if (ARow = i) and (StrToInt(Cells[10,i]) > 0) then //Second level
             begin
               Canvas.Font.Color := clYellow;
               Canvas.Font.Style := [fsBold];
               Canvas.Brush.Color := clRed;
             end;
           end;
        end;
     end;


// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;
  end;

//Final draw of grid
      Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
      Canvas.FrameRect(Rect);

    end;
  end;
end;


procedure TfrmConsult.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);                           //Hot keys for shortcuts
begin
//if (ssAlt in Shift) and (chr(Key) = '1') then frmMenu.btnDetailDisplay.Click;
//if (ssAlt in Shift) and (chr(Key) in ['R','r']) then btnRefresh.Click;
//IF (ssAlt in Shift) and (chr(Key) in ['V','v']) then btnView2319.Click;
end;

procedure TfrmConsult.btnRefreshClick(Sender: TObject);
//Put filtered data in grid
var
  i,j : integer;
  OP,PE,CA,CL : string;
  ani: TAnimationThread;
  r: TRect;

begin
if SiteID = '' then ShowMessage('Please select a SITE . . .')
  else begin
     if Trunc(Date) - Trunc(dtpkrBegDate.Date) < 0 then
      ShowMessage('Please enter an EARLIER date')
  else begin
     if not((chkOpen.Checked) or (chkPending.Checked) or
            (chkCancelled.Checked) or (chkClosed.Checked)) then
      ShowMessage('Please select a STATUS')
  else begin
   if (StrToInt(edtStartSSN.Text)) > (StrToInt (edtEndSSN.Text)) then
       ShowMessage('SSN Error: Starting must be lower than Ending')  //Check range


  else begin

  dtpkrBegDateChange(Sender);

  btnClear.Click; //Clear the grid first

  frmCalcDetail.edtCalcTotalOfSubTotal.Value  := 0; //Clear Totals/Variables
  frmCalcDetail.edtCalcPendingTotal.Value  := 0;
  frmCalcDetail.edtSubTotal0_5.Value  := 0;
  frmCalcDetail.edtSubTotal6_9.Value  := 0;
  frmCalcDetail.edtSubTotalTotal.Value  := 0;
  frmCalcDetail.edtSubTotal10_29.Value  := 0;
  frmCalcDetail.edtSubTotal30_89.Value  := 0;
  frmCalcDetail.edtSubTotal90.Value  := 0;
  frmCalcDetail.edtConsults0_5.Value  := 0;
  frmCalcDetail.edtConsults6_9.Value := 0;
  frmCalcDetail.edtConsults10_29.Value := 0;
  frmCalcDetail.edtConsults30_89.Value := 0;
  frmCalcDetail.edtConsults90.Value := 0;
  frmCalcDetail.edtManuals0_5.Value := 0;
  frmCalcDetail.edtManuals6_9.Value := 0;
  frmCalcDetail.edtManuals10_29.Value := 0;
  frmCalcDetail.edtManuals30_89.Value := 0;
  frmCalcDetail.edtManuals90.Value := 0;
  frmCalcDetail.edtConsultsTotal.Value := 0;
  frmCalcDetail.edtManualsTotal.Value := 0;
  frmCalcDetail.edtTotalDelayedTotal.Value := 0;
  frmCalcDetail.edtCalcTotalDelayedTotal.Value := 0;

  frmCalcDetail.edtTotalDelayed6_9.Value := 0;
  frmCalcDetail.edtTotalDelayed10_29.Value := 0;
  frmCalcDetail.edtTotalDelayed30_89.Value := 0;
  frmCalcDetail.edtTotalDelayed90.Value := 0;

  frmCalcDetail.edtPending0_5.Value := 0;
  frmCalcDetail.edtPending6_9.Value := 0;
  frmCalcDetail.edtPending10_29.Value := 0;
  frmCalcDetail.edtPending30_89.Value := 0;
  frmCalcDetail.edtPending90.Value := 0;
  frmCalcDetail.edtPendingTotal.Value := 0;
  frmCalcDetail.edtCalcResult.Value := 0;
  frmCalcDetail.edtCalcPercentDelayed.Value := 0;

  frmPendingCalc.edt1stAction0_5.Value := 0;
  frmPendingCalc.edt1stAction6_9.Value := 0;
  frmPendingCalc.edt1stAction10_29.Value := 0;
  frmPendingCalc.edt1stAction30_89.Value := 0;
  frmPendingCalc.edt1stAction90.Value := 0;
  frmPendingCalc.edt1stActionTotal.Value  := 0;

       edtTotalDelayed.Value := 0;
       edtTotalRecords.Value := 0;
     edtPercentDelayed.Text  := '00.00';

  OP := '';
  PE := '';
  CA := '';
  CL := '';

  frmMenu.brkrRPC.CreateContext('RMPR GUI DOR');
  frmMenu.brkrRPC.RemoteProcedure := 'XWB GET VARIABLE VALUE';
  frmMenu.brkrRPC.Param[0].Value := 'DUZ';
  frmMenu.brkrRPC.Param[0].PType := reference;

  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;


  edtUserId.Text := frmMenu.brkrRPC.Results[0];
  UserID   := frmMenu.brkrRPC.Results[0];

  StartSSN := edtStartSSN.Text;
  EndSSN   := edtEndSSN.Text;
//  SiteID  * Set in OnExit of cbxSiteID * ;

  if chkOpen.Checked then OP := 'O';
  if chkPending.Checked then PE := 'P';
  if chkCancelled.Checked then CA := 'X';
  if chkClosed.Checked then CL := 'C';
  ConsultStatus := OP+PE+CA+CL;

    btnDisplay.Caption := 'Searching';
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR DOR';
    frmMenu.brkrRPC.Param[1].Value := UserID;
    frmMenu.brkrRPC.Param[1].Ptype := literal;
    frmMenu.brkrRPC.Param[2].Value := StartSSN;
    frmMenu.brkrRPC.Param[2].Ptype := literal;
    frmMenu.brkrRPC.Param[3].Value := EndSSN;
    frmMenu.brkrRPC.Param[3].Ptype := literal;
    frmMenu.brkrRPC.Param[4].Value := SiteID;
    frmMenu.brkrRPC.Param[4].Ptype := literal;
    frmMenu.brkrRPC.Param[5].Value := ConsultStatus;
    frmMenu.brkrRPC.Param[5].Ptype := literal;
    frmMenu.brkrRPC.Param[6].Value := DORStartDate;
    frmMenu.brkrRPC.Param[6].Ptype := literal;
    frmMenu.brkrRPC.Param[7].Value := 'D';     //DOR - blocks PA site checking
    frmMenu.brkrRPC.Param[7].PType := literal; //and allows DOR to run alone
    frmMenu.brkrRPC.RPCTimeLimit := 600; //Set recv timeout

 TRY
  begin
  pnlProgressBar.Visible := true;
  r := pnlProgressBar.clientrect;
  InflateRect( r, - pnlProgressBar.bevelwidth, - pnlProgressBar.bevelwidth );

  //Start progress bar in thread
  ani := TanimationThread.Create( pnlProgressBar, r, pnlProgressBar.color, clFuchsia, 25 );

  Application.ProcessMessages;
      frmMenu.brkrRPC.Call;//Sleep( 1000 );  {replace with query.Open or such}

  //Stop progress bar
  pnlProgressBar.Visible := False;
  ani.Terminate;
  end;
 Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;

    btnDisplay.Caption := '&Display';
 edtTotalRecords.Value := frmMenu.brkrRPC.Results.Count -4; //Display Recv Total

 j := 1; //Sets starting row number for PENDING grid, then AutoInc

 for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do
  begin //Getting data from the Broker Call
   if Piece(frmMenu.brkrRPC.Results[i],'^',18) = '' then //check for null/0/1/2/3
         begin //null so results have record data
          grdConsult.Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',8); //Delayed
          grdConsult.Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',14);//Status
          grdConsult.Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',5); //Type
          grdConsult.Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',16);//Station
          grdConsult.Cells[4,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1); //Create Date
          grdConsult.Cells[5,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',7); //1st Action Date
          grdConsult.Cells[6,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',9); //0-5
          grdConsult.Cells[7,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',10);//6-9
          grdConsult.Cells[8,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',11);//10-29
          grdConsult.Cells[9,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',12);//30-89
          grdConsult.Cells[10,i+1]:= Piece(frmMenu.brkrRPC.Results[i],'^',13);//90+
          grdConsult.Cells[11,i+1]:= Piece(frmMenu.brkrRPC.Results[i],'^',17);//Linked
          grdConsult.Cells[12,i+1]:= Piece(frmMenu.brkrRPC.Results[i],'^',6);//Descr
          grdConsult.Cells[13,i+1]:= Piece(frmMenu.brkrRPC.Results[i],'^',2);//Patient
          grdConsult.Cells[14,i+1]:= Piece(frmMenu.brkrRPC.Results[i],'^',4);//SSN
          grdConsult.Cells[15,i+1]:= Piece(frmMenu.brkrRPC.Results[i],'^',15);//IEN668
          grdConsult.Cells[16,i+1]:= Piece(frmMenu.brkrRPC.Results[i],'^',24);//Pt IEN


 // Goes only to the Pending Calculation Grid
 if (Piece(frmMenu.brkrRPC.Results[i],'^',14)) = 'PENDING' then
  begin
    frmPendingCalc.grdPendingCalc.Cells[0,j] := Piece(frmMenu.brkrRPC.Results[i],'^',16);//Station
    frmPendingCalc.grdPendingCalc.Cells[1,j] := Piece(frmMenu.brkrRPC.Results[i],'^',1);//Create Date
    frmPendingCalc.grdPendingCalc.Cells[2,j] := Piece(frmMenu.brkrRPC.Results[i],'^',7);//1st Action Date
    frmPendingCalc.grdPendingCalc.Cells[3,j] := Piece(frmMenu.brkrRPC.Results[i],'^',19);//0-5
    frmPendingCalc.grdPendingCalc.Cells[4,j] := Piece(frmMenu.brkrRPC.Results[i],'^',20);//6-9
    frmPendingCalc.grdPendingCalc.Cells[5,j] := Piece(frmMenu.brkrRPC.Results[i],'^',21);//10-29
    frmPendingCalc.grdPendingCalc.Cells[6,j] := Piece(frmMenu.brkrRPC.Results[i],'^',22);//29-89
    frmPendingCalc.grdPendingCalc.Cells[7,j] := Piece(frmMenu.brkrRPC.Results[i],'^',23);//90+
    frmPendingCalc.grdPendingCalc.Cells[8,j] := Piece(frmMenu.brkrRPC.Results[i],'^',6);//Desc
    frmPendingCalc.grdPendingCalc.Cells[9,j] := Piece(frmMenu.brkrRPC.Results[i],'^',2);//Patient
    frmPendingCalc.grdPendingCalc.Cells[10,j]:= Piece(frmMenu.brkrRPC.Results[i],'^',4);//SSN
    frmPendingCalc.grdPendingCalc.Cells[11,j]:= Piece(frmMenu.brkrRPC.Results[i],'^',15);//IEN668
    inc (j);
   end; //Fill of PENDING CALC grid

   if j > 2 then  frmPendingCalc.grdPendingCalc.RowCount := j
     else frmPendingCalc.grdPendingCalc.RowCount := 2;        //Sets grid row size

  end; //Filling the grids

   if Piece(frmMenu.brkrRPC.Results[i],'^',18) = '0' then //MANUAL TOTALS
    begin //0 so results have only totals for MANUAL
    frmCalcDetail.edtManuals0_5.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',9));  //Total 0-5
    frmCalcDetail.edtManuals6_9.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',10)); //Total 6-9
    frmCalcDetail.edtManuals10_29.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',11)); //Total 10-29
    frmCalcDetail.edtManuals30_89.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',12)); //Total 30-89
    frmCalcDetail.edtManuals90.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',13)); //Total 90+
    end;

   if Piece(frmMenu.brkrRPC.Results[i],'^',18) = '1' then //CONSULT TOTALS
    begin //1 so results have only totals for CONSULTS
    frmCalcDetail.edtConsults0_5.Value  := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',9));  //Total 0-5
    frmCalcDetail.edtConsults6_9.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',10)); //Total 6-9
    frmCalcDetail.edtConsults10_29.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',11)); //Total 10-29
    frmCalcDetail.edtConsults30_89.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',12)); //Total 30-89
    frmCalcDetail.edtConsults90.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',13)); //Total 90+
    end;

   if Piece(frmMenu.brkrRPC.Results[i],'^',18) = '2' then //Previous Pending TOTALS
    begin //2 so results have only totals for Previous Pending
    frmPendingCalc.edt1stAction0_5.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',9));  //Total 0-5
    frmPendingCalc.edt1stAction6_9.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',10)); //Total 6-9
    frmPendingCalc.edt1stAction10_29.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',11)); //Total 10-29
    frmPendingCalc.edt1stAction30_89.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',12)); //Total 30-89
    frmPendingCalc.edt1stAction90.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',13)); //Total 90+
    end;

   if Piece(frmMenu.brkrRPC.Results[i],'^',18) = '3' then //Calc TOTALS
    begin //3 so results have only totals
    frmCalcDetail.edtPending0_5.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',9));  //Total 0-5
    frmCalcDetail.edtPending6_9.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',10)); //Total 6-9
    frmCalcDetail.edtPending10_29.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',11)); //Total 10-29
    frmCalcDetail.edtPending30_89.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',12)); //Total 30-89
    frmCalcDetail.edtPending90.Value := StrToInt(Piece(frmMenu.brkrRPC.Results[i],'^',13)); //Total 90+
    end;

 end; //Getting the data from Broker Call


 if frmMenu.brkrRPC.Results.Count > 4 then //Checks for null results
 begin
         //** The value for most other app is "brkrRPC.Results.Count +1"
         //** This app RESULTS[i] has Three EXTRA records for totals
         //** The value for this app must be "brkrRPC.Results.Count -3"
  grdConsult.RowCount := frmMenu.brkrRPC.Results.Count -3;//Sizes grid to match results


 // * * * Calculate the Totals

 frmCalcDetail.edtManualsTotal.Value   := frmCalcDetail.edtManuals0_5.Value + frmCalcDetail.edtManuals6_9.Value
                                        + frmCalcDetail.edtManuals10_29.Value + frmCalcDetail.edtManuals30_89.Value
                                        + frmCalcDetail.edtManuals90.Value;
 frmCalcDetail.edtConsultsTotal.Value  := frmCalcDetail.edtConsults0_5.Value + frmCalcDetail.edtConsults6_9.Value
                                        + frmCalcDetail.edtConsults10_29.Value + frmCalcDetail.edtConsults30_89.Value
                                        + frmCalcDetail.edtConsults90.Value;
 frmCalcDetail.edtSubTotalTotal.Value  := frmCalcDetail.edtManualsTotal.Value + frmCalcDetail.edtConsultsTotal.Value;

 frmCalcDetail.edtCalcTotalOfSubTotal.Value  := frmCalcDetail.edtSubTotalTotal.Value;

 frmCalcDetail.edtSubTotal0_5.Value    := frmCalcDetail.edtConsults0_5.Value + frmCalcDetail.edtManuals0_5.Value;
 frmCalcDetail.edtSubTotal6_9.Value    := frmCalcDetail.edtConsults6_9.Value + frmCalcDetail.edtManuals6_9.Value;
 frmCalcDetail.edtSubTotal10_29.Value  := frmCalcDetail.edtConsults10_29.Value + frmCalcDetail.edtManuals10_29.Value;
 frmCalcDetail.edtSubTotal30_89.Value  := frmCalcDetail.edtConsults30_89.Value + frmCalcDetail.edtManuals30_89.Value;
 frmCalcDetail.edtSubTotal90.Value     := frmCalcDetail.edtConsults90.Value + frmCalcDetail.edtManuals90.Value;

 frmCalcDetail.edtTotalDelayed0_5.Value   := frmCalcDetail.edtSubTotal0_5.Value - frmCalcDetail.edtPending0_5.Value;
 frmCalcDetail.edtTotalDelayed6_9.Value   := frmCalcDetail.edtSubTotal6_9.Value - frmCalcDetail.edtPending6_9.Value;
 frmCalcDetail.edtTotalDelayed10_29.Value := frmCalcDetail.edtSubTotal10_29.Value - frmCalcDetail.edtPending10_29.Value;
 frmCalcDetail.edtTotalDelayed30_89.Value := frmCalcDetail.edtSubTotal30_89.Value - frmCalcDetail.edtPending30_89.Value;
 frmCalcDetail.edtTotalDelayed90.Value    := frmCalcDetail.edtSubTotal90.Value - frmCalcDetail.edtPending90.Value;

 frmCalcDetail.edtTotalDelayedTotal.Value := frmCalcDetail.edtTotalDelayed6_9.Value + frmCalcDetail.edtTotalDelayed10_29.Value
                + frmCalcDetail.edtTotalDelayed30_89.Value + frmCalcDetail.edtTotalDelayed90.Value;

                    edtTotalDelayed.Value := frmCalcDetail.edtTotalDelayedTotal.Value;

 frmCalcDetail.edtCalcTotalDelayedTotal.Value := frmCalcDetail.edtTotalDelayedTotal.Value;

          frmCalcDetail.edtPendingTotal.Value := frmCalcDetail.edtPending0_5.Value + frmCalcDetail.edtPending6_9.Value
                + frmCalcDetail.edtPending10_29.Value + frmCalcDetail.edtPending30_89.Value
                + frmCalcDetail.edtPending90.Value;

 frmPendingCalc.edt1stActionTotal.Value := frmPendingCalc.edt1stAction0_5.Value + frmPendingCalc.edt1stAction6_9.Value
                + frmPendingCalc.edt1stAction10_29.Value + frmPendingCalc.edt1stAction30_89.Value
                + frmPendingCalc.edt1stAction90.Value;


 frmCalcDetail.edtCalcPendingTotal.Value := frmCalcDetail.edtPendingTotal.Value;

 frmCalcDetail.edtCalcResult.Value := frmCalcDetail.edtSubTotalTotal.Value - frmCalcDetail.edtPendingTotal.Value;


  frmCalcDetail.lblPending.Caption := 'Minus PENDING before '+
                     DateToStr(dtpkrBegDate.Date)+' : And the Create to 1st Action Date is ->';

 frmPendingCalc.lblActionToToday.Caption := 'Total PENDING from the 1st Action Date to Today''s Date is ->';

 frmCalcDetail.lblCalcPending.Caption := 'Minus the TOTAL PENDING before '+
                     DateToStr(dtpkrBegDate.Date);


// * * * * * Main Delayed Order Calculation * * * * * * //
          // Check for value before doing calculation
  if (frmCalcDetail.edtTotalDelayedTotal.Value > 0) and (frmCalcDetail.edtCalcResult.Value > 0) then
      frmCalcDetail.edtCalcPercentDelayed.Value := (frmCalcDetail.edtTotalDelayedTotal.Value) / (frmCalcDetail.edtCalcResult.Value) * 100;
// * * * * * * * * * * * * * * * * * * * * * * * * * * //

      edtPercentDelayed.Value := frmCalcDetail.edtCalcPercentDelayed.Value;

  end     //check for data return before doing the calcs
 else
     begin
      for i :=1 to 21 do   //Clear the grid
      grdConsult.Rows[i].Text := '';
      grdConsult.Row := 1;
      grdConsult.Cells[0,1] :='';
      grdConsult.RowCount := 2; //2 to show grid when no result records
     end;

    end; //Check SSN range
   end; //Check Status
  end; //Check Date
 end;//Check of site

  PatName := grdConsult.Cells[13,1]; //Set default to 1st record
  PatSSN  := grdConsult.Cells[14,1];
  IEN668  := grdConsult.Cells[15,1];

 PrnHeader := 'Source:'+frmMenu.brkrRPC.Server+' - '+SiteID+'   Start Date:'+Date2Str(dtpkrBegDate.Date)+
              '   Status:'+ConsultStatus+'   SSN:'+StartSSN+'-'+EndSSN;
end;

procedure TfrmConsult.grdConsultClick(Sender: TObject);
begin
  PatName := grdConsult.Cells[13,grdConsult.Row]; //For display in other forms
  PatSSN  := grdConsult.Cells[14,grdConsult.Row];
  IEN668  := grdConsult.Cells[15,grdConsult.Row]; //For display in other forms
end;

procedure TfrmConsult.FormActivate(Sender: TObject);
begin
     Application.HelpFile := 'PROS_DOR_HELPFILE.HLP'; //Needed here
     Application.OnHint := DisplayHint;  //Displays hints in Status Bar
     frmMenu.brkrRPC.CreateContext('RMPR GUI DOR');
     frmConsult.Caption := 'Delayed Order Report . . . You are logged onto '+frmMenu.brkrRPC.Server;
     dtpkrBegDate.Date := Date;       //force today's date
     DORStartDate := DateToStr(Date); //Set default Starting Date

with grdConsult do      // Set column headers
 begin
      Cells[0,0] := 'Dlyd';
      Cells[1,0] := 'Status';
      Cells[2,0] := 'Type';
      Cells[3,0] := 'Station';
      Cells[4,0] := 'Create';
      Cells[5,0] := '1st Action';
      Cells[6,0] := '0~5';    //Tilde needed to fix export to Excel error
      Cells[7,0] := '6~9';
      Cells[8,0] := '10~29';
      Cells[9,0] := '30~89';
      Cells[10,0] := '90+';
      Cells[11,0] := 'Lnk';
      Cells[12,0] := 'Description';
      Cells[13,0] := 'Patient';
      Cells[14,0] := 'SSN';
      Cells[15,0] := 'IEN 668';
      Cells[16,0] := 'Pt IEN';
  end;

  PatName := frmConsult.grdConsult.Cells[13,grdConsult.Row]; //For display in other forms
  PatSSN  := frmConsult.grdConsult.Cells[14,grdConsult.Row];
  IEN668  := frmConsult.grdConsult.Cells[15,grdConsult.Row]; //Refresh Pt IEN

end;

procedure TfrmConsult.FormCreate(Sender: TObject);
begin

CheckSec508;
   if Sec508 = '1' then    //if registry entry is 1 then change colors
   begin
     imgGradient.EndColor   := clWhite;   //Change colors
     imgGradient.StartColor := clWhite;
     lblMainBanner.Color := clWhite;
     lblMainBanner.Font.Color := clBlack;
     lblSite.Color := clWhite;
     lblSite.Font.Color := clBlack;
     chkAllSites.Color := clWhite;
     chkAllSites.Font.Color := clBlack;
     lblBegDate.Color := clWhite;
     lblBegDate.Font.Color := clBlack;
     lblStatus.Color := clWhite;
     lblStatus.Font.Color := clBlack;
     chkOpen.Color := clWhite;
     chkOpen.Font.Color := clBlack;
     chkPending.Color := clWhite;
     chkPending.Font.Color := clBlack;
     chkCancelled.Color := clWhite;
     chkCancelled.Font.Color := clBlack;
     chkClosed.Color := clWhite;
     chkClosed.Font.Color := clBlack;
     lblStartSSN.Color := clWhite;
     lblStartSSN.Font.Color := clBlack;
     lblEndSSN.Color := clWhite;
     lblEndSSN.Font.Color := clBlack;
   end;  // End of Section 508



end;

procedure TfrmConsult.btnViewCPRSClick(Sender: TObject);
begin
if IEN668 <> '' then
  begin
  Application.CreateForm(TfrmViewCPRS, frmViewCPRS);  
  frmViewCPRS.edtVarIEN668.Text  := IEN668; //sends IEN668 to View2319
  frmViewCPRS.ShowModal;
  end
else ShowMessage('Please select a PATIENT/RECORD to view');
end;

procedure TfrmConsult.btnCloseClick(Sender: TObject);
begin
Close;
end;


procedure TfrmConsult.grdConsultGetSortStyle(Sender: TObject; Col: Integer;
  var SortStyle: TSortStyle);
begin
if Col=4 then SortStyle := ssDateTime; //Sort Create as date
//if Col=5 then SortStyle := ssDateTime; //Sort Stop as date  //Can't use here
if Col=6 then SortStyle := ssNumeric; //Sort 0-5 as a number
if Col=7 then SortStyle := ssNumeric; //Sort 6-9 as a number
if Col=8 then SortStyle := ssNumeric; //Sort 10-29 as a number
if Col=9 then SortStyle := ssNumeric; //Sort 30-89 as a number
if Col=10 then SortStyle := ssNumeric; //Sort 90+ as a number
if Col=11 then SortStyle := ssNumeric; //Sort LINK as number
end;

procedure TfrmConsult.grdConsultGetCellFormat(Sender: TObject; Col,
  Row: Integer; State: TGridDrawState; var FormatOptions: TFormatOptions;
  var CheckBox, Combobox, Ellipsis: Boolean);
begin
  if (Col = 6) and (Row > 0) then
   formatoptions.AlignmentHorz := taCenter; //Center Delayed
  if (Col = 7) and (Row > 0) then
   formatoptions.AlignmentHorz := taRightJustify; //Right justify the days
  if (Col = 8) and (Row > 0) then
   formatoptions.AlignmentHorz := taRightJustify; //Right justify the days
end;

procedure TfrmConsult.edtStartSSNKeyPress(Sender: TObject; var Key: Char);
begin
  // #8 is Backspace
  if not (Key in [#8, '0'..'9']) then begin
    ShowMessage('Invalid key');
    // Discard the key
    Key := #0;
  end;
end;

procedure TfrmConsult.edtEndSSNKeyPress(Sender: TObject; var Key: Char);
begin

  // #8 is Backspace
  if not (Key in [#8, '0'..'9']) then begin
    ShowMessage('Invalid key');
    // Discard the key
    Key := #0;
  end;

end;

procedure TfrmConsult.btnViewRequestClick(Sender: TObject);
begin
if IEN668 <> '' then
 begin
  Application.CreateForm(TfrmViewReq, frmViewReq);
  frmViewReq.edtVarIEN668.Text := IEN668;
  frmViewReq.ShowModal;
  end
else ShowMessage('Please select a PATIENT/RECORD to view');
end;

procedure TfrmConsult.edtStartSSNExit(Sender: TObject);
begin
if Length(edtStartSSN.Text) < 2 then
 begin
  ShowMessage('Please enter TWO numbers.');
  edtStartSSN.SetFocus;
 end
end;

procedure TfrmConsult.edtEndSSNExit(Sender: TObject);
begin
if Length(edtEndSSN.Text) < 2 then
 begin
  ShowMessage('Please enter TWO numbers.');
  edtEndSSN.SetFocus;
 end;
end;

procedure TfrmConsult.dtpkrBegDateChange(Sender: TObject);
var
d1,d2,d3,d4 : string;         //Gets the user input from the calendar
begin
    DORStartDate := '';
      if (Date2Year(dtpkrBegDate.Date) < 1900) then  //Checks century
    d1 := '1';
      if (Date2Year(dtpkrBegDate.Date) >= 1900) and
         (Date2Year(dtpkrBegDate.Date) < 2000) then
    d1 := '2';
      if (Date2Year(dtpkrBegDate.Date) >= 2000) then
    d1 := '3';

    d2 := Copy(IntToStr(Date2Year(dtpkrBegDate.Date)),3,2); //Gets year

      if Date2Month(dtpkrBegDate.Date) < 10 then //Pad month with 0 if needed
    d3:= '0'+ IntToStr(Date2Month(dtpkrBegDate.Date))
       else
    d3 := IntToStr(Date2Month(dtpkrBegDate.Date));

     if Date2Day(dtpkrBegDate.Date) < 10 then  //Pad day with 0 if needed
    d4:= '0'+ IntToStr(Date2Day(dtpkrBegDate.Date))
       else
    d4 := IntToStr(Date2Day(dtpkrBegDate.Date));

 DORStartDate := d1 + d2+ d3 + d4;                    //Assemble MUMPS date style
end;

procedure TfrmConsult.cbxSiteSelectionExit(Sender: TObject);
begin
if  cbxSiteSelection.Text <> '' then
 SiteID := cbxSiteSelection.GetSelectedRecord.IEN;
end;

procedure TfrmConsult.btnView2319Click(Sender: TObject);
begin
if IEN668 <> '' then
  begin
  Application.CreateForm(TfrmView2319, frmView2319);
  frmView2319.edtVarIEN668.Text  := IEN668; //sends IEN668 to View2319
  frmView2319.ShowModal;
  end
 else ShowMessage('Please select a PATIENT/RECORD to view');
end;

procedure TfrmConsult.chkAllSitesClick(Sender: TObject);
begin
if chkAllSites.Checked then
    begin
     cbxSiteSelection.Text := '';          //Clears the combo box
     cbxSiteSelection.Color := clBtnFace;
     SiteID := 'ALL';
    end;
 if not (chkAllSites.Checked) then
  begin
  SiteID :='';
  end;
end;

procedure TfrmConsult.cbxSiteSelectionDropDown(Sender: TObject);
begin
cbxSiteSelection.Color := clWhite;
chkAllSites.Checked := False;        //Unchecks the All box
end;

procedure TfrmConsult.btnExcelClick(Sender: TObject);
var
  buttonSelected : Integer;
  DIR : String;
  currdir : String;
 begin
  if frmMenu.brkrRPC.Connected = false then      //Checks if user is logged on
      MessageDlg('Please Sign On first.', mtInformation,
      [mbOk], 0)
  else

  begin

    if fileexists(excelfile) then
    begin
      if SysUtils.DeleteFile(ExcelFile) = False then
        raise Exception.Create('Please close the temporary Excel (.csv) file before continuing')     //rmpr*136
      else
        lblExcelPath.Caption := '';
    end;

  begin
  if grdConsult.Cells[1,1] = '' then
      MessageDlg('Please DISPLAY the data to send to Excel.', mtInformation,
      [mbOk], 0)
  else
  begin

    begin    //Check for default CSV folder and create it
      if not DirectoryExists('c:\NPPDDownload') then
      if not CreateDir('c:\NPPDDownload') then
      raise Exception.Create('Cannot create c:\NPPDDownload');
    end;

    DIR := 'c:\NPPDDownload';

      buttonSelected := Application.MessageBox('The data you are about to export may'+
      ' contain Patient Identifiable Information, which requires appropriate measures '+
      'to ensure its confidentiality.  Please select only a secure, encrypted location'+
      ' to save this data.','Security Reminder',MB_OK + MB_DEFBUTTON1);


    if buttonSelected = ID_OK  then
    begin
      currdir := GetCurrentDir;    //capture current directory
      if SelectDirectory(DIR, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
          begin
            ExcelFile := DIR+'\DOR_'+SiteID+'_'+edtStartSSN.Text+'_'+edtEndSSN.Text+'.csv';
            grdConsult.SaveToCSV(ExcelFile);
            ShellExecute(frmConsult.Handle,nil,Pchar(ExcelFile),nil,nil,SW_SHOWNORMAL);
            lblExcelPath.Caption := DIR;

          end;
      end;
      SetCurrentDir(currdir);  //reset current directory
      end;
  end;
 end;
end;

procedure TfrmConsult.btnViewCalcDetailClick(Sender: TObject);
begin
  if grdConsult.Cells[1,1] = '' then
      MessageDlg('Please DISPLAY the data to View.', mtInformation,
      [mbOk], 0)
  else frmCalcDetail.ShowModal;
end;

procedure TfrmConsult.edtStartSSNClick(Sender: TObject);
begin
edtStartSSN.SelectAll;
end;

procedure TfrmConsult.edtEndSSNClick(Sender: TObject);
begin
edtEndSSN.SelectAll;
end;

procedure TfrmConsult.dtpkrBegDateCloseUp(Sender: TObject);
begin
    if Trunc(Date) - Trunc(dtpkrBegDate.Date) < 0 then
      ShowMessage('Please enter an EARLIER date');
end;

procedure TfrmConsult.mnuItemOpenClick(Sender: TObject);
begin
if chkOpen.Checked = false then     //Syncs menu with check box
chkOpen.Checked := true else
chkOpen.Checked := false;
mnuItemSelectStatus.Click;
end;

procedure TfrmConsult.mnuItemBegDateClick(Sender: TObject);
begin
dtpkrBegDate.Perform(WM_KEYDOWN, VK_F4, 0); //Calls Calendar from Menu
dtpkrBegDate.Perform(WM_KEYUP, VK_F4, 0);
end;

procedure TfrmConsult.mnuItemDisplayClick(Sender: TObject);
begin
btnDisplay.Click;
end;

procedure TfrmConsult.mnuItemSelectStartingSSNClick(Sender: TObject);
begin
edtStartSSN.SetFocus;
end;

procedure TfrmConsult.mnuItemSelectEndingSSNClick(Sender: TObject);
begin
edtEndSSN.SetFocus;
end;

procedure TfrmConsult.btnPendingCalcClick(Sender: TObject);
begin
 if grdConsult.Cells[1,1] = '' then
      MessageDlg('Please DISPLAY the data to View.', mtInformation,
      [mbOk], 0)
  else frmPendingCalc.ShowModal;
end;

procedure TfrmConsult.btnPrintClick(Sender: TObject);
var
poOriginal : TPrinterOrientation;
begin
  if frmMenu.brkrRPC.Connected = false then      //Checks if user is logged on
      MessageDlg('Please Sign On first.', mtInformation,
      [mbOk], 0)
  else
  begin
  if grdConsult.Cells[1,1] = '' then
      MessageDlg('Please DISPLAY the data to print.', mtInformation,
      [mbOk], 0)
  else
  begin
    poOriginal := Printer.Orientation;   //Save original Printer Orientation
    Printer.Orientation := poLandscape;  //Set to landscape
   if dlgPrint.Execute = true then
    begin
     grdConsult.PrintOptions.PageTitle :=      //Form HEADER
      'DELAYED ORDER REPORT   '+PrnHeader+'     Printed: '+Date2Str(Now);
     grdConsult.PrintOptions.ToRow := grdConsult.RowCount;
     grdConsult.Print;     //PRINT
   end; //Dialog
   Printer.Orientation := poOriginal;  //reset to original
  end;
 end;
end;

procedure TfrmConsult.mnuItemClearClick(Sender: TObject);
begin
btnClear.Click;
end;

procedure TfrmConsult.mnuItemCloseClick(Sender: TObject);
begin
btnClose.Click;
end;

procedure TfrmConsult.mnuItemSelectSiteClick(Sender: TObject);
begin  //Pulls Down the Site Selection Box
cbxSiteSelection.SetFocus;
cbxSiteSelection.DroppedDown := not cbxSiteSelection.DroppedDown;
cbxSiteSelection.Perform(WM_KEYDOWN, VK_F4, 0); //Calls pull down from Menu
end;

procedure TfrmConsult.mnuItemView2319Click(Sender: TObject);
begin
btnView2319.Click;
end;

procedure TfrmConsult.mnuItemViewCPRSClick(Sender: TObject);
begin
btnViewCPRS.Click;
end;

procedure TfrmConsult.mnuItemViewRequestClick(Sender: TObject);
begin
btnViewRequest.Click;
end;

procedure TfrmConsult.mnuItemViewDORClick(Sender: TObject);
begin
btnViewCalcDetail.Click;
end;

procedure TfrmConsult.mnuItemViewPendingCalcClick(Sender: TObject);
begin
btnPendingCalc.Click;
end;

procedure TfrmConsult.FormClose(Sender: TObject; var Action: TCloseAction);
begin

     if fileexists(excelfile) then
    begin
      if SysUtils.DeleteFile(ExcelFile) = False then
        raise Exception.Create('Please close the temporary Excel (.csv) file before navigating from this form')    //RMPR*136
      else
        lblExcelPath.Caption := '';
    end;

end;

procedure TfrmConsult.mnuItemPendingClick(Sender: TObject);
begin
if chkPending.Checked = false then    //Syncs menu with check box
    chkPending.Checked := true else
    chkPending.Checked := false;
end;

procedure TfrmConsult.mnuItemCancelledClick(Sender: TObject);
begin
if chkCancelled.Checked = false then  //Syncs menu with check box
    chkCancelled.Checked := true else
    chkCancelled.Checked := false;
end;

procedure TfrmConsult.mnuItemClosedClick(Sender: TObject);
begin
if chkClosed.Checked = false then     //Syncs menu with check box
    chkClosed.Checked := true else
    chkClosed.Checked := false;
end;

procedure TfrmConsult.mnuItemSelectStatusClick(Sender: TObject);
begin
if chkOpen.Checked then mnuItemOpen.Checked := True    //Sets begining status
  else mnuItemOpen.Checked := False;
if chkPending.Checked then mnuItemPending.Checked := True
  else mnuItemPending.Checked := False;
if chkCancelled.Checked then mnuItemCancelled.Checked := True
  else mnuItemCancelled.Checked := False;
if chkClosed.Checked then mnuItemClosed.Checked := True
  else mnuItemClosed.Checked := False;
end;

procedure TfrmConsult.mnuItemAboutClick(Sender: TObject);
begin
dlgAbout.ShowModal;
end;

procedure TfrmConsult.mnuSection508Click(Sender: TObject);
var
  reg : TRegistry;          //Toggle Sec 508 screen settings in registry
begin
  reg := TRegistry.Create;
  reg.rootkey := HKEY_LOCAL_MACHINE;
  reg.OpenKey('\SOFTWARE\VISTA\PROS\DelayedOrderReport',False);
  Sec508 := reg.ReadString('Sec508');
   begin  //Toggle the registry key
    if Sec508 = '0' then
       begin
        if MessageDlg('Do you wish to activate Section 508 assistance?',
        mtConfirmation, [mbYes, mbNo], 0) = mrYes then
          begin
            reg.WriteString('Sec508','1');    //Turn it on
            ShowMessage('Please EXIT and RESTART the program for the changes to take effect');
          end;
       end
   else
      begin
       if MessageDlg('Do you wish to turn off Section 508 assistance?',
       mtConfirmation, [mbYes, mbNo], 0) = mrYes then
         begin
           reg.WriteString('Sec508', '0');  //Turn it off
           ShowMessage('Please EXIT and RESTART the program for the changes to take effect');
         end;
      end;
 end;
  reg.CloseKey;
  reg.Free;
end;

procedure TfrmConsult.mnuItemPrintRequestGridClick(Sender: TObject);
begin
 if grdConsult.Cells[1,1] = '' then
      MessageDlg('Please DISPLAY the data to print.', mtInformation,
      [mbOk], 0)
  else
  btnPrint.Click;
end;

procedure TfrmConsult.mnuItemPrintCalculationDetailClick(Sender: TObject);
begin
 if grdConsult.Cells[1,1] = '' then
      MessageDlg('Please DISPLAY the data to print.', mtInformation,
      [mbOk], 0)
 else
 frmCalcDetail.btnPrintCalc.Click;
end;

procedure TfrmConsult.mnuItemPrintPendingGridClick(Sender: TObject);
begin
 if grdConsult.Cells[1,1] = '' then
      MessageDlg('Please DISPLAY the data to print.', mtInformation,
      [mbOk], 0)
 else
 begin
  frmPendingCalc.btnPrint.Click;
 end;
end;

procedure TfrmConsult.mnuItemSendRequestClick(Sender: TObject);
begin
if grdConsult.Cells[1,1] = '' then
      MessageDlg('Please DISPLAY the data to send to Excel.', mtInformation,
      [mbOk], 0)
  else
  btnExcel.Click;
end;

procedure TfrmConsult.mnuItemSendPendingClick(Sender: TObject);
begin
if grdConsult.Cells[1,1] = '' then
      MessageDlg('Please DISPLAY the data to send to Excel.', mtInformation,
      [mbOk], 0)
  else
  begin
  frmPendingCalc.Show;
  frmPendingCalc.btnExcel.Click;
  end;
end;

procedure TfrmConsult.grdConsultDblClick(Sender: TObject);
begin
btnViewRequest.Click;
end;

procedure TfrmConsult.mnuItemRefreshClick(Sender: TObject);
begin
btnRefresh.Click;
end;

procedure TfrmConsult.grdConsultRowSelected(Sender: TObject);
begin
  PatName := grdConsult.Cells[13,grdConsult.Row]; //For display in other forms
  PatSSN  := grdConsult.Cells[14,grdConsult.Row];
  IEN668  := grdConsult.Cells[15,grdConsult.Row]; //For display in other forms
end;

procedure TfrmConsult.cbxSiteSelectionEnter(Sender: TObject);
begin
cbxSiteSelection.Color := clWhite;
chkAllSites.Checked := False;        //Unchecks the All box

end;

procedure TfrmConsult.btnClearClick(Sender: TObject);
var
  i : integer;
begin
       edtTotalDelayed.Value := 0;
       edtTotalRecords.Value := 0;
     edtPercentDelayed.Value := 00.00;
                     PatName := '';
                      IEN668 := '';

  for i :=1 to 21 do   //If selected will clear the grid
   grdConsult.Rows[i].Text := '';
   grdConsult.Row := 1;
   grdConsult.Cells[0,1] :='';
   grdConsult.RowCount := 21;

 for i :=1 to frmPendingCalc.grdPendingCalc.RowCount -1 do   //If selected will clear the grid
    frmPendingCalc.grdPendingCalc.Rows[i].Text :='';
    frmPendingCalc.grdPendingCalc.Row := 1;
    grdConsult.Cells[0,1] :='';
end;

procedure TfrmConsult.numItemHelpContentsClick(Sender: TObject);
begin
Application.HelpCommand (Help_Index,0);
end;

procedure TfrmConsult.appDORMessage(var Msg: tagMSG;
  var Handled: Boolean);
var
   i: SmallInt;
begin
  if grdConsult.Focused then
  begin
   if Msg.message = WM_MOUSEWHEEL then
   begin
     Msg.message := WM_KEYDOWN;
     Msg.lParam := 0;
     i := HiWord(Msg.wParam) ;
     if i > 0 then
      begin

    SendMessage(grdConsult.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEUP,     { Scroll Command }
                0);            { Not Used }

      end
     else
    SendMessage(grdConsult.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEDOWN,     { Scroll Command }
                0);            { Not Used }


     Handled := False;
   end;
  end;


end;

end.

