unit PROS_DOR_PendingCalc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, SRGrad, Buttons, MyGrids, SortGrid, ExtCtrls, FileCtrl, ShellAPI,
  CurrEdit, ESBDates, Printers, AppEvnts;

type
  TfrmPendingCalc = class(TForm)
    lblActionToToday: TLabel;
    lblPlus1: TLabel;
    lblPlus2: TLabel;
    lblPlus3: TLabel;
    lblPlus4: TLabel;
    lblEquals: TLabel;
    lblDaysPending: TLabel;
    lbl0_5: TLabel;
    lbl6_9: TLabel;
    lbl10_29: TLabel;
    lbl30_89: TLabel;
    lbl90: TLabel;
    lblTotal: TLabel;
    btnClose: TBitBtn;
    grdPendingCalc: TSortGrid;
    btnExcel: TBitBtn;
    lblGridBanner: TLabel;
    edt1stAction0_5: TCurrencyEdit;
    edt1stAction6_9: TCurrencyEdit;
    edt1stAction10_29: TCurrencyEdit;
    edt1stAction30_89: TCurrencyEdit;
    edt1stAction90: TCurrencyEdit;
    edt1stActionTotal: TCurrencyEdit;
    btnPrint: TBitBtn;
    dlgPrint: TPrintDialog;
    appPendingCalc: TApplicationEvents;
    svdlgPendingCalc: TSaveDialog;
    lblExcelPth: TLabel;
    procedure btnCloseClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure grdPendingCalcGetSortStyle(Sender: TObject; Col: Integer;
      var SortStyle: TSortStyle);
    procedure grdPendingCalcDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnExcelClick(Sender: TObject);
    procedure btnPrintClick(Sender: TObject);
    procedure grdPendingCalcDblClick(Sender: TObject);
    procedure grdPendingCalcClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure appPendingCalcMessage(var Msg: tagMSG;
      var Handled: Boolean);
  private
  ExcelFile : string;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPendingCalc: TfrmPendingCalc;

implementation

uses PROS_DOR_Consult, Pros_Menu;

{$R *.DFM}

procedure TfrmPendingCalc.btnCloseClick(Sender: TObject);
begin
Close;
end;

procedure TfrmPendingCalc.FormActivate(Sender: TObject);
begin
with grdPendingCalc do               // Sets column headers
 begin
      Cells[0,0] := 'Station';
      Cells[1,0] := 'Create';
      Cells[2,0] := '1st Action';
      Cells[3,0] := 'Pend 0-5';
      Cells[4,0] := 'Pend 6-9';
      Cells[5,0] := 'Pend 10-29';
      Cells[6,0] := 'Pend 30-89';
      Cells[7,0] := 'Pend 90+';
      Cells[8,0] := 'Description';
      Cells[9,0] := 'Patient';
      Cells[10,0] := 'SSN';
  end;
end;

procedure TfrmPendingCalc.grdPendingCalcGetSortStyle(Sender: TObject;
  Col: Integer; var SortStyle: TSortStyle);
begin
if Col=1 then SortStyle := ssDateTime; //Sort Create as date
//if Col=2 then SortStyle := ssDateTime; //Sort Stop as date
if Col=3 then SortStyle := ssNumeric; //Sort 0-5 as a number
if Col=4 then SortStyle := ssNumeric; //Sort 6-9 as a number
if Col=5 then SortStyle := ssNumeric; //Sort 10-29 as a number
if Col=6 then SortStyle := ssNumeric; //Sort 30-89 as a number
if Col=7 then SortStyle := ssNumeric; //Sort 90+ as a number
end;

procedure TfrmPendingCalc.grdPendingCalcDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
  with grdPendingCalc do
  begin
  // Draw the Bands with alternating colors
     if ARow mod 2 = 0 then
        Canvas.Brush.Color := $F1F2DE//Lt Green  $CFFFFF//light yellow
       else
        Canvas.Brush.Color := $FFFFFF; //white

  // Don't change color for first Column, first row
    if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace else
     begin
      case ACol of
      0: Canvas.Font.Color := clBlack
     end;

// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;
  end;

//Final draw of grid
      Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
      Canvas.FrameRect(Rect);
// * * Final draw needs to be with CASE or the sort icon overwrites header text
  end;
 end;
end;

procedure TfrmPendingCalc.btnExcelClick(Sender: TObject);
var
    DIR : String;
    buttonSelected : Integer;
    currdir : String;
 begin
  if frmMenu.brkrRPC.Connected = false then      //Checks if user is logged on
      MessageDlg('Please Sign On first.', mtInformation,
      [mbOk], 0)
  else

  begin

    if fileexists(excelfile) then
    begin
      if SysUtils.DeleteFile(ExcelFile) = False then
        raise Exception.Create('Please close the temporary Excel (.csv) file before continuing')     //rmpr*136
      else
        lblExcelPth.Caption := '';
    end;

  begin
    if grdPendingCalc.Cells[1,1] = '' then
      MessageDlg('Please DISPLAY the data to print.', mtInformation,
      [mbOk], 0)
  else
  begin
     begin    //Check for default CSV folder and create it
      if not DirectoryExists('c:\NPPDDownload') then
      if not CreateDir('c:\NPPDDownload') then
      raise Exception.Create('Cannot create c:\NPPDDownload');
     end;

     DIR := 'c:\NPPDDownload';

      buttonSelected := Application.MessageBox('The data you are about to export may'+
      ' contain Patient Identifiable Information, which requires appropriate measures '+
      'to ensure its confidentiality.  Please select only a secure, encrypted location'+
      ' to save this data.','Security Reminder',MB_OK + MB_DEFBUTTON1);


    if buttonSelected = ID_OK  then
     begin
        currdir := GetCurrentDir;    //capture current directory
        if SelectDirectory(DIR, [sdAllowCreate, sdPerformCreate, sdPrompt],0) then
        begin
          ExcelFile := DIR+'\DOR_Pend_'+SiteID+'_'+
                frmConsult.edtStartSSN.Text+'_'+frmConsult.edtEndSSN.Text+'.csv';
  grdPendingCalc.SaveToCSV(ExcelFile);
  ShellExecute(frmPendingCalc.Handle, nil, PChar(ExcelFile), nil, nil, SW_SHOWNORMAL);
          lblExcelPth.Caption := DIR;

        end;
        SetCurrentDir(currdir);  //reset current directory
        end;
      end;
  end;
  end;

end;

procedure TfrmPendingCalc.btnPrintClick(Sender: TObject);
var
poOriginal : TPrinterOrientation;
begin
  if frmMenu.brkrRPC.Connected = false then      //Checks if user is logged on
      MessageDlg('Please Sign On first.', mtInformation,
      [mbOk], 0)
  else
  begin
  if grdPendingCalc.Cells[1,1] = '' then
      MessageDlg('Please DISPLAY the data to print.', mtInformation,
      [mbOk], 0)
  else
  begin
  poOriginal := Printer.Orientation;   //Save original Printer Orientation
  Printer.Orientation := poLandscape;  //Set to landscape
   if dlgPrint.Execute = true then
    begin
     grdPendingCalc.PrintOptions.PageTitle :=      //Form HEADER
      'PENDING ORDER REPORT   '+PrnHeader+'    Days 1st Action Date to TODAY: '+Date2Str(Now);
     grdPendingCalc.PrintOptions.ToRow :=(frmMenu.brkrRPC.Results.Count +1);

     grdPendingCalc.Print;     //PRINT
   end; //Dialog
  Printer.Orientation := poOriginal;  //reset to original
  end;
 end;
end;

procedure TfrmPendingCalc.grdPendingCalcDblClick(Sender: TObject);
begin
  IEN668  := grdPendingCalc.Cells[11,grdPendingCalc.Row];
  frmConsult.btnViewRequest.Click; //Calls 2319 from DOR screen
end;

procedure TfrmPendingCalc.grdPendingCalcClick(Sender: TObject);
begin
  IEN668  := grdPendingCalc.Cells[11,grdPendingCalc.Row];
end;

procedure TfrmPendingCalc.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 IEN668 := frmConsult.grdConsult.Cells[15,frmConsult.grdConsult.Row]; //Reset to DOR grid
 
      if fileexists(excelfile) then
    begin
      if SysUtils.DeleteFile(ExcelFile) = False then
        raise Exception.Create('Please close the temporary Excel (.csv) file before navigating from this form')    //RMPR*136
      else
        lblExcelPth.Caption := '';
    end;
end;


procedure TfrmPendingCalc.appPendingCalcMessage(var Msg: tagMSG;
  var Handled: Boolean);
var
   i: SmallInt;
begin
  if grdPendingCalc.Focused then
  begin
   if Msg.message = WM_MOUSEWHEEL then
   begin
     Msg.message := WM_KEYDOWN;
     Msg.lParam := 0;
     i := HiWord(Msg.wParam) ;
     if i > 0 then
      begin

    SendMessage(grdPendingCalc.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEUP,     { Scroll Command }
                0);            { Not Used }

      end
     else
    SendMessage(grdPendingCalc.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEDOWN,     { Scroll Command }
                0);            { Not Used }


     Handled := False;
   end;
  end;
end;

end.
