{*****************************************************
  Prosthetic VistA View 2319 - GUI    ver 1.3.116   September, 2005
  Office of Information Field Office
  Department of Veterans Affairs
  Hines,Illinois

  Developers: Helen Corkwell, Sam Spencer, Ken Nelson
  Description: GUI to view a patients 2319
  Requires: RMPR*3.0*116

*******************************************************}

unit PROS_DOR_View2319;     // Form 2319

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Diaccess, Fmcmpnts, Grids, StdCtrls, Buttons,
  MFunStr, Trpcb, SRGrad, ExtCtrls, MyGrids, SortGrid, CurrEdit, Fmcntrls,
  AppEvnts;

type
  TfrmView2319 = class(TForm)
    pgctrlView2319: TPageControl;
    tbshtPtDem: TTabSheet;
    tbshtClinEnrol: TTabSheet;
    tbshtEntitle: TTabSheet;
    tbshtAppTrans: TTabSheet;
    tbshtAutoAdpt: TTabSheet;
    tbshtCritCom: TTabSheet;
    tbshtHISA: TTabSheet;
    tbshtHomeOx: TTabSheet;
    edtPatDoB: TEdit;
    edtPatAge: TEdit;
    edtPatSex: TEdit;
    edtPatDoD: TEdit;
    edtPatRace: TEdit;
    edtPatReligion: TEdit;
    edtPatMaritalStat: TEdit;
    edtPatSSN: TEdit;
    edtClaimNum: TEdit;
    edtPatAdd: TEdit;
    edtPatCity: TEdit;
    edtPatState: TEdit;
    edtPatZip: TEdit;
    edtPatCounty: TEdit;
    edtPatPhone: TEdit;
    edtNOKName: TEdit;
    edtNOKAdd: TEdit;
    btnPtDem: TBitBtn;
    edtNOKCity: TEdit;
    edtNOKState: TEdit;
    edtNOKZip: TEdit;
    edtNOKPhone: TEdit;
    lblPatName: TLabel;
    lblPatDOB: TLabel;
    lblPatAge: TLabel;
    lblPatSex: TLabel;
    lblPatDoD: TLabel;
    lblPatRace: TLabel;
    lblPatRelgion: TLabel;
    lblPatMaritalStat: TLabel;
    lblPatSSN: TLabel;
    lblClaimNum: TLabel;
    lblPatAdd: TLabel;
    lblPatCity: TLabel;
    lblPatState: TLabel;
    lblPatZip: TLabel;
    lblPatCounty: TLabel;
    lblPatPhone: TLabel;
    lblNOKName: TLabel;
    lblNOKAdd: TLabel;
    lblNOKCity: TLabel;
    lblNOKState: TLabel;
    lblNOKZip: TLabel;
    lblNOKPhone: TLabel;
    btnAppTrans: TBitBtn;
    bvlView2319Dem: TBevel;
    bvlView2319Ben: TBevel;
    edtNOKRelation: TEdit;
    edtPatType: TEdit;
    edtPeriodOfSrv: TEdit;
    lblNOKRelation: TLabel;
    lblPeriodOfServ: TLabel;
    lblBenefit: TLabel;
    bvlView2319KoK: TBevel;
    lblNextOfKin: TLabel;
    edtPriEligCode: TEdit;
    lblPriEligCode: TLabel;
    edtEligVerified: TEdit;
    lblEligVerified: TLabel;
    lblPatType: TLabel;
    edtEmrCity: TEdit;
    edtEmrState: TEdit;
    edtEmrZip: TEdit;
    edtRcvAA: TEdit;
    edtRcvHousebound: TEdit;
    edtRcvVAPen: TEdit;
    edtRcvVADis: TEdit;
    edtDisCode: TEdit;
    edtPOW: TEdit;
    edtEmrName: TEdit;
    edtEmrAdd: TEdit;
    lblReceiving: TLabel;
    lblEmrCity: TLabel;
    lblRcvAA: TLabel;
    lblRcvHousebound: TLabel;
    lblRcvVAPen: TLabel;
    lblRcvVADis: TLabel;
    lblRcvTotalAmt: TLabel;
    lblDisCode: TLabel;
    lblPOW: TLabel;
    lblEmrName: TLabel;
    lblEmrAdd: TLabel;
    grdAppTrans: TSortGrid;
    btnClosePtDem: TBitBtn;
    lblPriEmgContact: TLabel;
    numRcvTotalAmt: TCurrencyEdit;
    lblAppTransTotal: TLabel;
    lblTotalAppTrans: TLabel;
    btnHISA: TBitBtn;
    lblHISATotal: TLabel;
    lblTotalHISA: TLabel;
    grdMiniDis: TSortGrid;
    lblMiniDis: TLabel;
    btnPtDis: TBitBtn;
    lblHomeO2Total: TLabel;
    lblTotalHomeO2: TLabel;
    btnHomeO2: TBitBtn;
    btnCritCom: TBitBtn;
    grdClinEnrol: TSortGrid;
    btnCEnrollments: TBitBtn;
    lblCETotal: TLabel;
    lblTotalCE: TLabel;
    grdPendAppt: TSortGrid;
    lblCEPendApptTotal: TLabel;
    lblTotalPendAppt: TLabel;
    lblCE: TLabel;
    lblCEPendAppt: TLabel;
    btnCEPendAppt: TBitBtn;
    memCritCom: TMemo;
    edtEmrPhone: TEdit;
    edtEmrRelation: TEdit;
    lblEmrState: TLabel;
    lblEmrZip: TLabel;
    lblEmrPhone: TLabel;
    lblEmrRelation: TLabel;
    lblCELastActType: TLabel;
    lblCELastTypeMove: TLabel;
    lblCEDate: TLabel;
    lblCELastDiag: TLabel;
    lblCELastWard: TLabel;
    lblCELastPhys: TLabel;
    grdLettersOnFile: TSortGrid;
    bvlCELastMove: TBevel;
    bvlCEPrevMove: TBevel;
    lblCEPrevActType: TLabel;
    lblCEPrevDate: TLabel;
    lblCEPrevTypeMove: TLabel;
    lblCEPrevWard: TLabel;
    lblCEPrevPhys: TLabel;
    lblCEPrevDiag: TLabel;
    lblCELettersOnFile: TLabel;
    lblCELettersOnFileTotal: TLabel;
    lblTotalLettersOnFile: TLabel;
    edtCELastActType: TEdit;
    edtCELastDate: TEdit;
    edtCELastTypeMove: TEdit;
    edtCELastWard: TEdit;
    edtCELastPhys: TEdit;
    edtCELastDiag: TEdit;
    edtCEPrevActType: TEdit;
    edtCEPrevDate: TEdit;
    edtCEPrevTypeMove: TEdit;
    edtCEPrevWard: TEdit;
    edtCEPrevPhys: TEdit;
    edtCEPrevDiag: TEdit;
    lblLastMove: TLabel;
    btnCELetters: TBitBtn;
    btnCEMovements: TBitBtn;
    btnCloseCE: TBitBtn;
    btnCloseAppTrans: TBitBtn;
    btnCloseCritCom: TBitBtn;
    btnCloseHISA: TBitBtn;
    btnCloseHomeO2: TBitBtn;
    btnCloseEntInfo: TBitBtn;
    btnCloseAutoAdapt: TBitBtn;
    btnViewApplianceDetail: TBitBtn;
    lblAutoAdaptNotAvailable: TLabel;
    lblEntitNotAvailable: TLabel;
    btnViewHISADetail: TBitBtn;
    btnViewHomeOxygenDetail: TBitBtn;
    edtVarIEN668: TFMEdit;
    edtVarPatName: TFMEdit;
    edtVarPatSSN: TFMEdit;
    grdHISA: TSortGrid;
    grdHomeO2: TSortGrid;
    appView2319: TApplicationEvents;
    procedure FormActivate(Sender: TObject);
    procedure grdAppTransDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnAppTransClick(Sender: TObject);
    procedure btnPtDemClick(Sender: TObject);
    procedure btnHISAClick(Sender: TObject);
    procedure grdHISADrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnPtDisClick(Sender: TObject);
    procedure btnHomeO2Click(Sender: TObject);
    procedure btnCritComClick(Sender: TObject);
    procedure grdHomeO2DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnCEnrollmentsClick(Sender: TObject);
    procedure grdClinEnrolDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure grdPendApptDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure btnCEPendApptClick(Sender: TObject);
    procedure btnClosePtDemClick(Sender: TObject);
    procedure btnCELettersClick(Sender: TObject);
    procedure btnCEMovementsClick(Sender: TObject);
    procedure grdLettersOnFileDrawCell(Sender: TObject; ACol,
      ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure btnCloseCEClick(Sender: TObject);
    procedure btnCloseEntInfoClick(Sender: TObject);
    procedure btnCloseAppTransClick(Sender: TObject);
    procedure btnCloseAutoAdaptClick(Sender: TObject);
    procedure btnCloseCritComClick(Sender: TObject);
    procedure btnCloseHISAClick(Sender: TObject);
    procedure btnCloseHomeO2Click(Sender: TObject);
    procedure btnViewApplianceDetailClick(Sender: TObject);
    procedure grdAppTransClick(Sender: TObject);
    procedure edtPOWChange(Sender: TObject);
    procedure btnViewHISADetailClick(Sender: TObject);
    procedure grdHISAClick(Sender: TObject);
    procedure btnViewHomeOxygenDetailClick(Sender: TObject);
    procedure grdHomeO2Click(Sender: TObject);
    procedure grdAppTransDblClick(Sender: TObject);
    procedure grdHISADblClick(Sender: TObject);
    procedure grdHomeO2DblClick(Sender: TObject);
    procedure grdAppTransGetSortStyle(Sender: TObject; Col: Integer;
      var SortStyle: TSortStyle);
    procedure tbshtHomeOxShow(Sender: TObject);
    procedure tbshtHISAShow(Sender: TObject);
    procedure tbshtAppTransShow(Sender: TObject);
    procedure grdAppTransGetCellFormat(Sender: TObject; Col, Row: Integer;
      State: TGridDrawState; var FormatOptions: TFormatOptions;
      var CheckBox, Combobox, Ellipsis: Boolean);
    procedure grdHISAGetCellFormat(Sender: TObject; Col, Row: Integer;
      State: TGridDrawState; var FormatOptions: TFormatOptions;
      var CheckBox, Combobox, Ellipsis: Boolean);
    procedure grdHomeO2GetCellFormat(Sender: TObject; Col, Row: Integer;
      State: TGridDrawState; var FormatOptions: TFormatOptions;
      var CheckBox, Combobox, Ellipsis: Boolean);
    procedure appView2319Message(var Msg: tagMSG;
      var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmView2319: TfrmView2319;
  IEN660 : string;

implementation

uses PROS_DOR_AppTransDetail, PROS_POC_PurOrderConsult, PROS_DOR_Consult, Pros_Menu;

{$R *.DFM}


procedure TfrmView2319.FormActivate(Sender: TObject);
begin
IEN660 := '';
IEN668 := edtVarIEN668.Text;   //Receives var from sending app

//IEN668 := frmPurOrderConsult.grdConsult.Cells[9,frmPurOrderConsult.grdConsult.Row];
pgctrlView2319.ActivePageIndex := 3; //Default display tab 4 (Zero based)

//For Tab 1
with grdMiniDis do       // Grid header
 begin
      Cells[0,0] := 'Disability';
      Cells[1,0] := ' %';
      Cells[2,0] := 'SC';
 end;

//For Tab 2  Grid headers
with grdClinEnrol do
 begin
      Cells[0,0] := 'Clinic';
      Cells[1,0] := 'Date/Time';
      Cells[2,0] := 'Type';
 end;

with grdPendAppt do
 begin
      Cells[0,0] := 'Appt. Date/Time';
      Cells[1,0] := 'Clinic';
      Cells[2,0] := 'Status';
      Cells[3,0] := 'Type';
 end;

with grdLettersOnFile do
 begin
      Cells[0,0] := 'Type of Letter';
      Cells[1,0] := 'Employee';
      Cells[2,0] := 'Date';
 end;

 //For Tab 4
with grdAppTrans do       // Grid header
 begin

      Cells[0,0] := 'Date';
      Cells[1,0] := 'Qty';
      Cells[2,0] := 'HCPC Item';
      Cells[3,0] := 'Typ';
      Cells[4,0] := 'Vendor';
      Cells[5,0] := 'Station';
      Cells[6,0] := 'Serial';
      Cells[7,0] := 'HCPC';
      Cells[8,0] := 'Total Cost';
      Cells[9,0] := 'NoC';
      Cells[10,0] := 'IEN660';
  end;

//For Tab 7
with grdHISA do             //Grid header
 begin
      Cells[0,0] := 'Date';
      Cells[1,0] := 'Qty';
      Cells[2,0] := 'HCPC Item';
      Cells[3,0] := 'Typ';
      Cells[4,0] := 'Vendor';
      Cells[5,0] := 'Station';
      Cells[6,0] := 'Serial';
      Cells[7,0] := 'HCPC';
      Cells[8,0] := 'Total Cost';
      Cells[9,0] := 'IEN660';
 end;

//For Tab 8
with grdHomeO2 do             //Grid header
 begin
      Cells[0,0] := 'Date';
      Cells[1,0] := 'Qty';
      Cells[2,0] := 'HCPC Item';
      Cells[3,0] := 'Typ';
      Cells[4,0] := 'Vendor';
      Cells[5,0] := 'Station';
      Cells[6,0] := 'Serial';
      Cells[7,0] := 'HCPC';
      Cells[8,0] := 'Total Cost';
      Cells[9,0] := 'IEN660';
 end;


btnPtDem.Click;        //Gets data - Tab 1 Pt Demographics
btnPtDis.Click;        //Gets data for the grid - Tab 1 Disabilities
btnCEnrollments.Click; //Gets data for the grid - Tab 2 Clinic Enrol
btnCEPendAppt.Click;   //Gets data for the grid - Tab 2 Pend Appt
btnCELetters.Click;    //Gets data for the grid - Tab 2 Letters On File
btnCEMovements.Click;  //Gets data  - Tab 2 Patient Movements
btnAppTrans.Click;     //Gets data for the grid - Tab 4 Appl Trans
btnCritCom.Click;      //Gets data - Tab 6 Critical Comments
btnHISA.Click;         //Gets data for the grid - Tab 7 HISA
btnHomeO2.Click;       //Gets data for the grid - Tab 8 Home Oxygen

end;

procedure TfrmView2319.grdAppTransDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  with grdAppTrans do
  begin
    // Don't change color for first Column, first row
    if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace
    else
    begin
      case ACol of
        0:  begin
             Canvas.Font.Color := clBlack; //Date
            // ColWidths[0] := 65;
            end;
        1: begin
             Canvas.Font.Color := clBlack; //Qty
             //ColWidths[1] := 30;
            end;
        2: begin
             Canvas.Font.Color := clBlack; //Item
             //ColWidths[2] := 200;
            end;
        3: begin
             Canvas.Font.Color := clBlack; //Type
             //ColWidths[3] := 30;
            end;
        4:  begin
             Canvas.Font.Color := clBlack; //Vendor
             //ColWidths[4] := 150;
            end;
        5:  begin
             Canvas.Font.Color := clBlack; //Station
             //ColWidths[5] := 30;
            end;
        6:  begin
             Canvas.Font.Color := clBlack; //Serial
             //ColWidths[6] := 100;
            end;
        7:  begin
             Canvas.Font.Color := clBlack; //HCPC
             //ColWidths[7] := 65;
            end;
        8:  begin
             Canvas.Font.Color := clBlack; //Total Cost
             //ColWidths[8] := 65;
            end;
        9:  begin
             Canvas.Font.Color := clBlack; //IEN660
             //ColWidths[9] := 50;
            end;




      end;

// Draw the Bands with alternating colors
     if ARow mod 2 = 0 then
        Canvas.Brush.Color := $CFFFFF //$00E1FFF9
      else
        Canvas.Brush.Color := $FFFFFF;//$00FFEBDF;

// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;

  end;


//Final draw of grid
      Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
      Canvas.FrameRect(Rect);

    end;
  end;
end;


procedure TfrmView2319.btnAppTransClick(Sender: TObject);
var
  i : integer;
begin
//    grdAppTrans.Clear;
    grdApptrans.RowCount := 22;
    lblTotalAppTrans.Caption := '0';

    frmMenu.brkrRPC.RemoteProcedure := 'RMPR TRANS LIST';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;
 if frmMenu.brkrRPC.Results.Count > 0 then  //check for NO results
 begin

  grdAppTrans.RowCount := frmMenu.brkrRPC.Results.Count +1;//Sizes grid to match results

  for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do  //Tab 4
   begin
   with grdAppTrans do
     begin
       Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);//Date
       Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);//Qty
       Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4);//Item
       Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',6);//Type
       Cells[4,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',7);//Vendor
       Cells[5,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',8);//Station
       Cells[6,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',9);//Serial
       Cells[7,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',5);//HCPCS
       Cells[8,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',11);//Cost
       if  Piece(frmMenu.brkrRPC.Results[i],'^',12) = '1' then  // No Count 1 = Yes
       Cells[9,i+1] := 'Yes'
      else
       Cells[9,i+1] := '';
       Cells[10,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);//IEN660

     end;
   end;

  //Set record count display
  if Piece(frmMenu.brkrRPC.Results[0],'^',1) <> 'NOTHING TO REPORT' then
     begin
      lblTotalAppTrans.Caption := IntToStr(frmMenu.brkrRPC.Results.Count);
      IEN660 := grdAppTrans.Cells[10,grdAppTrans.Row];
     end
  else
  begin
     grdAppTrans.Cells[2,1] := Piece(frmMenu.brkrRPC.Results[0],'^',1);
     lblTotalAppTrans.Caption := '0';
  end;
  end

 else

 begin                        //if NO results returned
  grdAppTrans.RowCount := 2;
  grdAppTrans.Cells[2,1] := 'ERROR: No data received';
  lblTotalAppTrans.Caption := '0';
 end;
end;


procedure TfrmView2319.btnPtDemClick(Sender: TObject);

begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR PT DEM';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call;  //Data for Tab 1
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;


   begin
    lblPatName.Caption := Piece(frmMenu.brkrRPC.Results[0],'^',1);//Name
               PatName := Piece(frmMenu.brkrRPC.Results[0],'^',1);//Name
        edtPatDoB.Text := Piece(frmMenu.brkrRPC.Results[2],'^',2);  //DOB
        edtPatAge.Text := Piece(frmMenu.brkrRPC.Results[3],'^',1);  //AGE
        edtPatSex.Text := Piece(frmMenu.brkrRPC.Results[4],'^',2);  //Sex
        edtPatDoD.Text := Piece(frmMenu.brkrRPC.Results[5],'^',2);  //DOD

  if edtPatDoD.Text <> '' then  // Turns off AGE if Pt is Deceased
     begin
      lblPatName.Font.Color := clRed;
      lblPatAge.Visible := False;
      edtPatAge.Visible  := False;
      lblPatDoD.Visible := True;
      edtPatDoD.Visible  := True;
    end
  else          //Reset to default
    begin
      lblPatName.Font.Color := clBlue;
      lblPatAge.Visible := True;
      edtPatAge.Visible := True;
      lblPatDoD.Visible := False;
      edtPatDoD.Visible := False;
    end;

          edtPatRace.Text := Piece(frmMenu.brkrRPC.Results[6],'^',2); //Race
      edtPatReligion.Text := Piece(frmMenu.brkrRPC.Results[7],'^',2); //Religion
   edtPatMaritalStat.Text := Piece(frmMenu.brkrRPC.Results[8],'^',2); //Married
           edtPatSSN.Text := frmMenu.brkrRPC.Results[9];              //SSN
                   PatSSN := frmMenu.brkrRPC.Results[9];              //SSN
         edtClaimNum.Text := Piece(frmMenu.brkrRPC.Results[11],'^',1);//Claim #
           edtPatAdd.Text := frmMenu.brkrRPC.Results[12];             //Address
          edtPatCity.Text := frmMenu.brkrRPC.Results[13];             //City
         edtPatState.Text := Piece(frmMenu.brkrRPC.Results[14],'^',2);//State
           edtPatZip.Text := frmMenu.brkrRPC.Results[15];             //Zip
        edtPatCounty.Text := Piece(frmMenu.brkrRPC.Results[16],'^',2);//County
         edtPatPhone.Text := frmMenu.brkrRPC.Results[17];             //Pat Phone

          edtNOKName.Text := frmMenu.brkrRPC.Results[19];             //NOK Name
           edtNOKAdd.Text := frmMenu.brkrRPC.Results[20];             //NOK Add
          edtNOKCity.Text := frmMenu.brkrRPC.Results[21];             //NOK City
         edtNOKState.Text := Piece(frmMenu.brkrRPC.Results[22],'^',2);//NOK State
           edtNOKZip.Text := frmMenu.brkrRPC.Results[23];             //NOK ZIP
         edtNOKPhone.Text := frmMenu.brkrRPC.Results[24];             //NOK Phone
      edtNOKRelation.Text := frmMenu.brkrRPC.Results[25];             //NOK Relship
          edtPatType.Text := frmMenu.brkrRPC.Results[26];             //Pat Type
      edtPeriodOfSrv.Text := frmMenu.brkrRPC.Results[27];             //Period of Srv
      edtPriEligCode.Text := frmMenu.brkrRPC.Results[28];             //Elig Code
     edtEligVerified.Text := frmMenu.brkrRPC.Results[29];             //Elig Very?
            edtRcvAA.Text := frmMenu.brkrRPC.Results[30];             //A&A Benef
    edtRcvHousebound.Text := frmMenu.brkrRPC.Results[31];             //House Benf
         edtRcvVAPen.Text := frmMenu.brkrRPC.Results[32];             //VA Pension
         edtRcvVADis.Text := frmMenu.brkrRPC.Results[33];             //Recv VA Dis
     numRcvTotalAmt.Value := StrToFloat(frmMenu.brkrRPC.Results[34]); //Total $ Anual
          edtDisCode.Text := frmMenu.brkrRPC.Results[35];             //Dis Code
              edtPOW.Text := frmMenu.brkrRPC.Results[36];             //POW
  end;
 frmView2319.Caption := 'View 2319                   '+
                        '                           '+PatName+'   SSN:'+PatSSN;//Form Header
end;


procedure TfrmView2319.btnHISAClick(Sender: TObject);
var
  i : integer;

begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR TRANS HISA';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call; // Data for Tab 7
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;


 grdHISA.RowCount := frmMenu.brkrRPC.Results.Count +1;//Sizes grid to match results

 for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do
   begin
     with grdHISA do
       begin
         Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);//Date
         Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);//Qty
         Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4);//Item
         Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',6);//Type
         Cells[4,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',7);//Vendor
         Cells[5,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',8);//Station
         Cells[6,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',9);//Serial
         Cells[7,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',5);//HCPCS
         Cells[8,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',11);//Cost
         Cells[9,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);//IEN660
       end; //With do
   end;

 //Set record count display
  if Piece(frmMenu.brkrRPC.Results[0],'^',1) <> 'NOTHING TO REPORT' then
     lblTotalHISA.Caption := IntToStr(frmMenu.brkrRPC.Results.Count)
  else
  begin
     grdHISA.Cells[2,1] := Piece(frmMenu.brkrRPC.Results[0],'^',1);
     lblTotalHISA.Caption := '0';
  end;
 grdHISA.Row := 1; 
end;


procedure TfrmView2319.grdHISADrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  with grdHISA do
  begin
    // Don't change color for first Column, first row
    if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace
    else
    begin
      case ACol of
        0: Canvas.Font.Color := clBlack;
        1: Canvas.Font.Color := clBlack;
        2: Canvas.Font.Color := clBlack;
      end;

// Draw the Bands with alternating colors
     if ARow mod 2 = 0 then
        Canvas.Brush.Color := $CFFFFF //$00E1FFF9
      else
        Canvas.Brush.Color := $FFFFFF;//$00FFEBDF;

// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;
  end;

//Final draw of grid
      Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
      Canvas.FrameRect(Rect);
    end;
  end;
end;


procedure TfrmView2319.btnPtDisClick(Sender: TObject);
var
  i : integer;
begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR DIS LIST';   //Pt Disability Grid
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;

 grdMiniDis.RowCount := frmMenu.brkrRPC.Results.Count +1;//Sizes grid to match results

 for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do  //Tab 4
   begin
    with grdMiniDis do
      begin
         Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);//Disab
         Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);//% Disab
         Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);// SC YES/NO

      end; // with do
  end;
end;


procedure TfrmView2319.btnHomeO2Click(Sender: TObject);
var
  i : integer;
begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR TRANS HOME O2';   //Home Oxygen
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;


 grdHomeO2.RowCount := frmMenu.brkrRPC.Results.Count +1;//Sizes grid to match results

 for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do  //Tab 4
   begin
     with grdHomeO2 do
       begin
         Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);//Date
         Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);//Qty
         Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4);//Item
         Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',6);//Type
         Cells[4,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',7);//Vendor
         Cells[5,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',8);//Station
         Cells[6,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',9);//Serial
         Cells[7,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',5);//HCPCS
         Cells[8,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',11);//Cost
         Cells[9,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);//IEN660
       end;  //with do
   end;


  //Set record count display
  if Piece(frmMenu.brkrRPC.Results[0],'^',1) <> 'NOTHING TO REPORT' then
     lblTotalHomeO2.Caption := IntToStr(frmMenu.brkrRPC.Results.Count)
  else
  begin
     grdHomeO2.Cells[2,1] := Piece(frmMenu.brkrRPC.Results[0],'^',1);
     lblTotalHomeO2.Caption := '0';
  end;
 grdHomeO2.Row := 1;
end;


procedure TfrmView2319.btnCritComClick(Sender: TObject);  //Critical Comments
var
 i : integer;
begin
   begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR CRITICAL COM';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;
 end;

  memCritCom.Lines.Clear;
  for i := 0 to frmMenu.brkrRPC.Results.Count -1 do
  begin
  memCritCom.Lines.Add (frmMenu.brkrRPC.Results[i]);
  end;
end;


procedure TfrmView2319.grdHomeO2DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
with grdHomeO2 do
  begin
    // Don't change color for first Column, first row
    if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace
    else
      begin
      case ACol of
        0: Canvas.Font.Color := clBlack;
        1: Canvas.Font.Color := clBlack;
        2: Canvas.Font.Color := clBlack;
        3: Canvas.Font.Color := clBlack;

      end;

 // Draw the Bands with alternating colors
     if ARow mod 2 = 0 then
        Canvas.Brush.Color := $CFFFFF //$00E1FFF9
      else
        Canvas.Brush.Color := $FFFFFF;//$00FFEBDF;

// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;
  end;

//Final draw of grid
      Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
      Canvas.FrameRect(Rect);
  end;
 end;
end;


procedure TfrmView2319.btnCEnrollmentsClick(Sender: TObject);
var
i : integer;
begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR CLINIC ENROLLMENT';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;


    grdClinEnrol.RowCount := frmMenu.brkrRPC.Results.Count +1;//Sizes grid to match results

 for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do
   begin
     with grdClinEnrol do
       begin
         Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);//Clinic
         Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);//Date
         Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);//Status
         Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4);//Type
       end; //With do
   end;

   //Set record count display
  if Piece(frmMenu.brkrRPC.Results[0],'^',1) <> 'NOTHING TO REPORT' then
     lblTotalCE.Caption := IntToStr(frmMenu.brkrRPC.Results.Count)
  else
  begin
     grdClinEnrol.Cells[2,1] := Piece(frmMenu.brkrRPC.Results[0],'^',1);
     lblTotalCE.Caption := '0';
  end;
 end;



procedure TfrmView2319.grdClinEnrolDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
  with grdClinEnrol do
  begin
    // Don't change color for first Column, first row
    if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace
    else
    begin
      case ACol of
        0: Canvas.Font.Color := clBlack;
        1: Canvas.Font.Color := clBlack;
        2: Canvas.Font.Color := clBlack;
      end;

// Draw the Bands with alternating colors
     if ARow mod 2 = 0 then
        Canvas.Brush.Color := $CFFFFF //$00E1FFF9
      else
        Canvas.Brush.Color := $FFFFFF;//$00FFEBDF;

// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;
  end;

//Final draw of grid
      Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
      Canvas.FrameRect(Rect);
    end;
  end;
end;


procedure TfrmView2319.btnCEPendApptClick(Sender: TObject);
var
i : integer;
begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR PENDING APPOINTMENTS';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;


    grdPendAppt.RowCount := frmMenu.brkrRPC.Results.Count +1;//Sizes grid to match results

 for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do
   begin
     with grdPendAppt do
       begin
         Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);//Date
         Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);//Clinic
         Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);//Status
         Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4);//Type
       end; //with do
   end;

   //Set record count display
  if Piece(frmMenu.brkrRPC.Results[0],'^',1) <> 'NOTHING TO REPORT' then
     lblTotalPendAppt.Caption := IntToStr(frmMenu.brkrRPC.Results.Count)
  else
  begin
     grdPendAppt.Cells[0,1] := Piece(frmMenu.brkrRPC.Results[0],'^',1);
     lblTotalPendAppt.Caption := '0';
  end;
 end;


procedure TfrmView2319.grdPendApptDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
  with grdPendAppt do
  begin
    // Don't change color for first Column, first row
    if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace
    else
    begin
      case ACol of
        0: Canvas.Font.Color := clBlack;
        1: Canvas.Font.Color := clBlack;
        2: Canvas.Font.Color := clBlack;
      end;

// Draw the Bands with alternating colors
     if ARow mod 2 = 0 then
        Canvas.Brush.Color := $CFFFFF //$00E1FFF9
      else
        Canvas.Brush.Color := $FFFFFF;//$00FFEBDF;

// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;
  end;

//Final draw of grid
      Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
      Canvas.FrameRect(Rect);
    end;
  end;
end;


procedure TfrmView2319.btnClosePtDemClick(Sender: TObject);
begin
Close;
end;

procedure TfrmView2319.btnCELettersClick(Sender: TObject);
var
i : integer;
begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR CLINIC LETTER LIST';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;


   grdLettersOnFile.RowCount := frmMenu.brkrRPC.Results.Count +1;//Sizes grid to match results

 for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do  //Tab 2
   begin
     with grdLettersOnFile do
       begin
         Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);//Type
         Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4);//Employee
         Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',5);//Date
         Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);//EIN665.4
       end; // with do
   end;

   //Set record count display
  if Piece(frmMenu.brkrRPC.Results[0],'^',1) <> 'NOTHING TO REPORT' then
     lblTotalLettersOnFile.Caption := IntToStr(frmMenu.brkrRPC.Results.Count)
  else
  begin
    grdLettersOnFile.Cells[0,1] := Piece(frmMenu.brkrRPC.Results[0],'^',1);
    lblTotalLettersOnFile.Caption := '0';
  end;
end;


procedure TfrmView2319.btnCEMovementsClick(Sender: TObject);
begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR LAST PT MOVEMENTS';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;


   begin
    //Last Move
      edtCELastActType.Text := frmMenu.brkrRPC.Results[5];  //Transaction Type
         edtCELastDate.Text := frmMenu.brkrRPC.Results[6];  //Date
     edtCELastTypeMove.Text := frmMenu.brkrRPC.Results[7];  //Type of Movement
         edtCELastWard.Text := frmMenu.brkrRPC.Results[8];  //Ward
         edtCELastPhys.Text := frmMenu.brkrRPC.Results[9];  //Physician
         edtCELastDiag.Text := frmMenu.brkrRPC.Results[10]; //Diagnosis
   //Previous Move
      edtCEPrevActType.Text := frmMenu.brkrRPC.Results[12]; //Transaction Type
         edtCEPrevDate.Text := frmMenu.brkrRPC.Results[13]; //Date
     edtCEPrevTypeMove.Text := frmMenu.brkrRPC.Results[14]; //Type of Movement
         edtCEPrevWard.Text := frmMenu.brkrRPC.Results[15]; //Ward
         edtCEPrevPhys.Text := frmMenu.brkrRPC.Results[16]; //Physician
         edtCEPrevDiag.Text := frmMenu.brkrRPC.Results[17]; //Diagnosis
   end;
end;


procedure TfrmView2319.grdLettersOnFileDrawCell(Sender: TObject; ACol,
  ARow: Integer; Rect: TRect; State: TGridDrawState);
begin
  with grdLettersOnFile do
  begin
    // Don't change color for first Column, first row
    if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace
    else
    begin
      case ACol of
        0: Canvas.Font.Color := clBlack;
        1: Canvas.Font.Color := clBlack;
        2: Canvas.Font.Color := clBlack;
      end;

// Draw the Bands with alternating colors
     if ARow mod 2 = 0 then
        Canvas.Brush.Color := $CFFFFF //$00E1FFF9
      else
        Canvas.Brush.Color := $FFFFFF;//$00FFEBDF;

// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;
  end;

//Final draw of grid
      Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
      Canvas.FrameRect(Rect);
    end;
  end;
end;


procedure TfrmView2319.btnCloseCEClick(Sender: TObject);
begin
Close;
end;

procedure TfrmView2319.btnCloseEntInfoClick(Sender: TObject);
begin
Close;
end;

procedure TfrmView2319.btnCloseAppTransClick(Sender: TObject);
begin
Close;
end;

procedure TfrmView2319.btnCloseAutoAdaptClick(Sender: TObject);
begin
Close;
end;

procedure TfrmView2319.btnCloseCritComClick(Sender: TObject);
begin
Close;
end;

procedure TfrmView2319.btnCloseHISAClick(Sender: TObject);
begin
Close;
end;

procedure TfrmView2319.btnCloseHomeO2Click(Sender: TObject);
begin
Close;
end;

procedure TfrmView2319.btnViewApplianceDetailClick(Sender: TObject);
begin
if IEN660 = 'NOTHING TO REPORT' then ShowMessage('  Sorry, no data to view  ') else
 begin
  if IEN660 <> '' then
   begin
    Application.CreateForm(TfrmAppTransDetail, frmAppTransDetail);
    frmAppTransDetail.ShowModal;
    end
   else ShowMessage('Please select a RECORD to view');
 end;
end;

procedure TfrmView2319.grdAppTransClick(Sender: TObject);
begin
IEN660 := grdAppTrans.Cells[10,grdAppTrans.Row]; //For display in other forms
end;

procedure TfrmView2319.edtPOWChange(Sender: TObject);
begin
if edtPOW.Text = 'YES' then //If POW, sets label to Blue and text to White & Blue
 begin
  lblPOW.Font.Color:= clBlue;
  lblPOW.Font.Style:= [fsBold];
  edtPOW.Font.Color := clWhite;
  edtPOW.Brush.Color := clBlue;
 end;
if edtPOW.Text = 'NO' then
 begin
  lblPOW.Font.Color:= clBlack;
  lblPOW.Font.Style:= [];
  edtPOW.Font.Color := clBlack;
  edtPOW.Brush.Color := $CFFFFF;
 end;
end;

procedure TfrmView2319.btnViewHISADetailClick(Sender: TObject);
begin
if IEN660 = 'NOTHING TO REPORT' then ShowMessage('  Sorry, no data to view  ') else
 begin
  if IEN660 <> '' then
    begin
    Application.CreateForm(TfrmAppTransDetail, frmAppTransDetail);
    frmAppTransDetail.ShowModal;
    end
   else ShowMessage('Please select a RECORD to view');
 end;
end;

procedure TfrmView2319.grdHISAClick(Sender: TObject);
begin
IEN660 := grdHISA.Cells[9,grdHISA.Row]; //For display in other forms
end;

procedure TfrmView2319.btnViewHomeOxygenDetailClick(Sender: TObject);
begin
if IEN660 = 'NOTHING TO REPORT' then ShowMessage('  Sorry, no data to view  ') else
 begin
  if IEN660 <> '' then
    begin
    Application.CreateForm(TfrmAppTransDetail, frmAppTransDetail);
    frmAppTransDetail.ShowModal;
    end
   else ShowMessage('Please select a RECORD to view');
 end;
end;

procedure TfrmView2319.grdHomeO2Click(Sender: TObject);
begin
IEN660 := grdHomeO2.Cells[9,grdHomeO2.Row]; //For display in other forms
end;

procedure TfrmView2319.grdAppTransDblClick(Sender: TObject);
begin
//IEN660 := grdAppTrans.Cells[10,grdAppTrans.Row]; //For display in other forms
btnViewApplianceDetail.Click;

end;

procedure TfrmView2319.grdHISADblClick(Sender: TObject);
begin
IEN660 := grdHISA.Cells[9,grdHISA.Row]; //For display in other forms
btnViewHISADetail.Click;
end;

procedure TfrmView2319.grdHomeO2DblClick(Sender: TObject);
begin
IEN660 := grdHomeO2.Cells[9,grdHomeO2.Row]; //For display in other forms
btnViewHomeOxygenDetail.Click;
end;

procedure TfrmView2319.grdAppTransGetSortStyle(Sender: TObject;
  Col: Integer; var SortStyle: TSortStyle);
begin
if Col = 0 then SortStyle := ssDateTime; //Sort Date as date
end;


//**** Ensures that the selected record is used for detail lookup
procedure TfrmView2319.tbshtHomeOxShow(Sender: TObject);
begin
IEN660 := grdHomeO2.Cells[9,grdHomeO2.Row];
end;

procedure TfrmView2319.tbshtHISAShow(Sender: TObject);
begin
IEN660 := grdHISA.Cells[9,grdHISA.Row];
end;

procedure TfrmView2319.tbshtAppTransShow(Sender: TObject);
begin
IEN660 := grdAppTrans.Cells[10,grdAppTrans.Row];
end;
//****

procedure TfrmView2319.grdAppTransGetCellFormat(Sender: TObject; Col,
  Row: Integer; State: TGridDrawState; var FormatOptions: TFormatOptions;
  var CheckBox, Combobox, Ellipsis: Boolean);
begin
if (Col = 2) then formatoptions.AlignmentHorz := taCenter;
//if Col = 8 then formatoptions.AlignmentHorz := taRightJustify;
//if Col = 9 then formatoptions.AlignmentHorz := taRightJustify;
end;

procedure TfrmView2319.grdHISAGetCellFormat(Sender: TObject; Col,
  Row: Integer; State: TGridDrawState; var FormatOptions: TFormatOptions;
  var CheckBox, Combobox, Ellipsis: Boolean);
begin
if (Col = 8) and (Row > 0) then formatoptions.AlignmentHorz := taRightJustify;
if (Col = 9) and (Row > 0) then formatoptions.AlignmentHorz := taRightJustify;
end;

procedure TfrmView2319.grdHomeO2GetCellFormat(Sender: TObject; Col,
  Row: Integer; State: TGridDrawState; var FormatOptions: TFormatOptions;
  var CheckBox, Combobox, Ellipsis: Boolean);
begin
if (Col = 8) and (Row > 0) then formatoptions.AlignmentHorz := taRightJustify;
if (Col = 9) and (Row > 0) then formatoptions.AlignmentHorz := taRightJustify;
end;



procedure TfrmView2319.appView2319Message(var Msg: tagMSG;
  var Handled: Boolean);
var
   i: SmallInt;
begin

// ************** For the Appliance Transaction grid
 if grdAppTrans.Focused then
  begin
    if Msg.message = WM_MOUSEWHEEL then
    begin
     Msg.message := WM_KEYDOWN;
     Msg.lParam := 0;
     i := HiWord(Msg.wParam) ;
     if i > 0 then
      begin

      SendMessage(grdAppTrans.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEUP,     { Scroll Command }
                0);            { Not Used }

       end
      else
       SendMessage(grdAppTrans.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEDOWN,     { Scroll Command }
                0);            { Not Used }


      Handled := False;
     end;
  end;

//************** For the HISA grid

 if grdHISA.Focused then
  begin
    if Msg.message = WM_MOUSEWHEEL then
    begin
     Msg.message := WM_KEYDOWN;
     Msg.lParam := 0;
     i := HiWord(Msg.wParam) ;
     if i > 0 then
      begin

      SendMessage(grdHISA.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEUP,     { Scroll Command }
                0);            { Not Used }

       end
      else
       SendMessage(grdHISA.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEDOWN,     { Scroll Command }
                0);            { Not Used }


      Handled := False;
     end;
  end;

//************** For Home Oxygen grid

 if grdHomeO2.Focused then
  begin
    if Msg.message = WM_MOUSEWHEEL then
    begin
     Msg.message := WM_KEYDOWN;
     Msg.lParam := 0;
     i := HiWord(Msg.wParam) ;
     if i > 0 then
      begin

      SendMessage(grdHomeO2.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEUP,     { Scroll Command }
                0);            { Not Used }

       end
      else
       SendMessage(grdHomeO2.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEDOWN,     { Scroll Command }
                0);            { Not Used }


      Handled := False;
     end;
  end;

end;

END.
