unit PROS_DOR_ViewReq;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Trpcb, SRGrad, Fmcntrls;

type
  TfrmViewReq = class(TForm)
    edtOrderSusDate: TEdit;
    edtInitialActionDate: TEdit;
    edtCompletionDate: TEdit;
    edtRequestor: TEdit;
    lblOrderSusDate: TLabel;
    lblIntialActionDate: TLabel;
    lblCompletionDate: TLabel;
    lblRequestor: TLabel;
    lblSuspendedBy: TLabel;
    lblDescription: TLabel;
    lblIntialActionNotes: TLabel;
    memDescription: TMemo;
    memIntialAtionNotes: TMemo;
    memCompletionNotes: TMemo;
    lblCompletionNote: TLabel;
    edtSuspendedBy: TEdit;
    btnClose: TBitBtn;
    edtVarIEN668: TFMEdit;
    procedure btnCloseClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmViewReq: TfrmViewReq;

implementation

uses PROS_DOR_Consult, Pros_Menu;

{$R *.DFM}

procedure TfrmViewReq.btnCloseClick(Sender: TObject);
begin
Close;
end;

procedure TfrmViewReq.FormActivate(Sender: TObject);
var
  i : integer;
begin
   IEN668 := edtVarIEN668.Text;  //Receives var from sending app
 begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR VIEW REQ';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].Ptype := literal;
  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;


         edtOrderSusDate.Text := frmMenu.brkrRPC.Results[0]; // Order/Sus Date
    edtInitialActionDate.Text := frmMenu.brkrRPC.Results[3]; // Init Action Date
       edtCompletionDate.Text := frmMenu.brkrRPC.Results[4]; // Completion Date
            edtRequestor.Text := frmMenu.brkrRPC.Results[1]; // Requestor
          edtSuspendedBy.Text := frmMenu.brkrRPC.Results[2]; // Suspended By

 end;

 begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR VIEW REQ DESC';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;


    memDescription.Lines.Clear;
    for i := 0 to frmMenu.brkrRPC.Results.Count -1 do
     begin
      memDescription.Lines.Add (frmMenu.brkrRPC.Results[i]);
     end;
    memDescription.SelStart := 0;
    memDescription.Perform(EM_SCROLLCARET, 0, 0);  //Sets cursor to top
  end;

  begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR VIEW REQ IA NOTE';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;


    memIntialAtionNotes.Lines.Clear;
    for i := 0 to frmMenu.brkrRPC.Results.Count -1 do
     begin
      memIntialAtionNotes.Lines.Add (frmMenu.brkrRPC.Results[i]);
     end;
    memIntialAtionNotes.SelStart := 0;
    memIntialAtionNotes.Perform(EM_SCROLLCARET, 0, 0);  //Sets cursor to top
  end;

  begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR VIEW REQ COMP NOTE';
    frmMenu.brkrRPC.Param[0].Value := IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;
  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;


    memCompletionNotes.Lines.Clear;
    for i := 0 to frmMenu.brkrRPC.Results.Count -1 do
     begin
      memCompletionNotes.Lines.Add (frmMenu.brkrRPC.Results[i]);
     end;
    memCompletionNotes.SelStart := 0;
    memCompletionNotes.Perform(EM_SCROLLCARET, 0, 0);  //Sets cursor to top
  end;
 end;

procedure TfrmViewReq.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Release;
end;

end.
