unit uPROS_InventoryTransactionDetail;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MyGrids, SortGrid, StdCtrls, Buttons, ExtCtrls, Fmcntrls,
  Rpcconf1, Trpcb, MFunStr, ProgBar, Grids, CurrEdit, NumEdit, AppEvnts, Menus,
  ComCtrls, VA508AccessibilityManager;

type
  TfrmInventoryTransactionDetail = class(TForm)
    Label7: TLabel;
    btnDisplay: TBitBtn;
    edtDateTime: TEdit;
    pnlProgressBar: TPanel;
    edtInventoryTransactionIEN: TEdit;
    grdInventoryTransactionDetail: TSortGrid;
    btnClear: TBitBtn;
    btnClose: TBitBtn;
    Panel2: TPanel;
    Label1: TLabel;
    btnDisplayErrorLog: TBitBtn;
    grdInventoryTransactionErrorLog: TSortGrid;
    lblBannerName: TLabel;
    Label2: TLabel;
    edtItemDescriptionDisplay: TEdit;
    Label4: TLabel;
    edtCurrentStatusDisplay: TEdit;
    btnEditHistory: TBitBtn;
    btnDeleteHistory: TBitBtn;
    btnEditError: TBitBtn;
    Label3: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    edtBarCodeHCPCSDisplay: TEdit;
    Label9: TLabel;
    edtBarcodeItemCost: TCurrencyEdit;
    Label10: TLabel;
    edtVendorDisplay: TEdit;
    edtQty: TIntEdit;
    Label19: TLabel;
    edtTotalCost: TCurrencyEdit;
    appInventoryTransactionDetail: TApplicationEvents;
    edtTypeOfTranactionDisplay: TEdit;
    edtExpirationDateDisplay: TEdit;
    edtStoreroomDisplay: TEdit;
    edtSourceDisplay: TEdit;
    edtSerialNumberDisplay: TEdit;
    edtLotNumberDisplay: TEdit;
    edtExcludeWaiverDisplay: TEdit;
    Label5: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    edtHCPCSVersionDateDisplay: TEdit;
    edtActionDisplay: TEdit;
    Label17: TLabel;
    Label18: TLabel;
    edtDateOfReceiptDisplay: TEdit;
    Label20: TLabel;
    edtContractNumberDisplay: TEdit;
    Label21: TLabel;
    edtItemNumberDisplay: TEdit;
    Label22: TLabel;
    edtLastActionDateDisplay: TEdit;
    Label23: TLabel;
    Label24: TLabel;
    edtStationDisplay: TEdit;
    StatusBar1: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Close1: TMenuItem;
    SelectDisplay1: TMenuItem;
    DisplayRefresh1: TMenuItem;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    N2: TMenuItem;
    About1: TMenuItem;
    mnuActions: TMenuItem;
    mnuEditRecord: TMenuItem;
    mnuDeleteRecord: TMenuItem;
    N1: TMenuItem;
    mnuEditErrorLog: TMenuItem;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    VA508ComponentAccessibility1: TVA508ComponentAccessibility;
    VA508ComponentAccessibility2: TVA508ComponentAccessibility;
    mnuGoBack: TMenuItem;
    N3: TMenuItem;
    edtNumberOfTotalRecords: TEdit;
    procedure btnDisplayClick(Sender: TObject);
    procedure btnClearClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnCloseClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure grdInventoryTransactionDetailDrawCell(Sender: TObject; ACol,
      ARow: Integer; Rect: TRect; State: TGridDrawState);
    procedure btnDisplayErrorLogClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnEditHistoryClick(Sender: TObject);
    procedure appInventoryTransactionDetailMessage(var Msg: tagMSG;
      var Handled: Boolean);
    procedure btnDeleteHistoryClick(Sender: TObject);
    procedure btnEditErrorClick(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure VA508ComponentAccessibility1ValueQuery(Sender: TObject;
      var Text: string);
    procedure VA508ComponentAccessibility2ValueQuery(Sender: TObject;
      var Text: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmInventoryTransactionDetail: TfrmInventoryTransactionDetail;
  IMDetailIEN668 : string;
implementation

uses Pros_Menu
,uPROS_InventoryTransactionEdit, uPROS_InventoryTransactionMonitor,
  uPROS_InventoryTransactionErrorResolve, PROS_Menu_About;

{$R *.dfm}

function buildOutput(o: TSortGrid): String;

var text: String;
const delim: string = '^';
var i: integer;

Begin
  o.SelectedRows.Sort;
  Text := delim + inttostr(o.RowCount-1) + delim;   // row count
  Text := Text + inttostr(o.colCount) + delim;    // column count

  for i := 0 to o.colCount-1 do // column headers
    Text := Text + o.Cells[i,0] + delim; // row 0 is column header
    Text := Text + IntToStr(o.Row) + delim; // current row number
    Text := Text + inttostr(0) + delim; // current column num will always be 0 when in row selection mode

  for i := 0 to o.colCount-1 do // data
    Text := Text + o.Cells[i,o.Row] + delim; // row 0 is column header
    Text := Text + intToStr(o.SelectedRows.Count) + delim; // row selection count
    Text := Text + intToStr(0) + delim; // col selection count

 for i := 0 to o.SelectedRows.Count - 1 do
  Begin
     if i = o.SelectedRows.Count -1 then
       Text := Text + o.SelectedRows[i] // selected rows
     Else
       Text := Text + o.SelectedRows[i] + ','; // selected rows
   End;

  Text := Text + delim;  // delim after selected rows
  Text := Text + IntToStr(0) + Delim; // selected columns

  buildOutput := Text;

End;

procedure TfrmInventoryTransactionDetail.VA508ComponentAccessibility1ValueQuery(Sender: TObject;
var Text: string);
begin
  Text := buildOutput(TSortGrid(TVA508ComponentAccessibility(sender).Component));
End;

procedure TfrmInventoryTransactionDetail.VA508ComponentAccessibility2ValueQuery(Sender: TObject;
var Text: string);
begin
  Text := buildOutput(TSortGrid(TVA508ComponentAccessibility(sender).Component));
End;

procedure TfrmInventoryTransactionDetail.btnDisplayErrorLogClick(Sender: TObject);
var
  i : integer;
begin

  if grdInventoryTransactionDetail.Cells[1,1] <> ''  then

 begin
  for i :=1 to grdInventoryTransactionErrorLog.RowCount -1 do   //If selected will clear the grid
    grdInventoryTransactionErrorLog.Rows[i].Clear;

  grdInventoryTransactionErrorLog.Row := 1;

//  frmMenu.brkrRPC.CreateContext('RMPR PURCHASE ORDER GUI');
  frmMenu.brkrRPC.RemoteProcedure := 'RMPR INV MON ERROR LOG';
  frmMenu.brkrRPC.Param[0].Value := edtInventoryTransactionIEN.Text;
  frmMenu.brkrRPC.Param[0].PType := literal;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

    if frmMenu.brkrRPC.Results.Count > 0 then
        grdInventoryTransactionErrorLog.RowCount := frmMenu.brkrRPC.Results.Count +1;


    for i:= 0 to frmMenu.brkrRPC.Results.Count -1  do

//    edit2.Text := Piece(frmMenu.brkrRPC.Results[i],'^',1);
    with grdInventoryTransactionErrorLog do
    begin
      Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4);  //RESOLVED
      Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);  //SOURCE
      Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);  //CODE
      Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);  //ERROR DESCRIPTION
      Cells[4,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',5);  //FLAG
      Cells[5,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',6);  //USER
      Cells[6,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',7);  //DATE/TIME RESOLVED
      Cells[7,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',8);  //TRANSACTION
      Cells[8,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',9); //Remarks
      Cells[9,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',10); //IEN 666.09


    end;
 end;
end;

procedure TfrmInventoryTransactionDetail.About1Click(Sender: TObject);
begin
dlgAbout.ShowModal;
end;

procedure TfrmInventoryTransactionDetail.appInventoryTransactionDetailMessage(
  var Msg: tagMSG; var Handled: Boolean);
var
   i: SmallInt;
begin
  if grdInventoryTransactionDetail.Focused then
  begin
   if Msg.message = WM_MOUSEWHEEL then
   begin
     Msg.message := WM_KEYDOWN;
     Msg.lParam := 0;
     i := HiWord(Msg.wParam) ;
     if i > 0 then
      begin

    SendMessage(grdInventoryTransactionDetail.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEUP,     { Scroll Command }
                0);            { Not Used }

      end
     else
    SendMessage(grdInventoryTransactionDetail.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEDOWN,     { Scroll Command }
                0);            { Not Used }


     Handled := False;
   end;
  end;

 if grdInventoryTransactionErrorLog.Focused then
  begin
   if Msg.message = WM_MOUSEWHEEL then
   begin
     Msg.message := WM_KEYDOWN;
     Msg.lParam := 0;
     i := HiWord(Msg.wParam) ;
     if i > 0 then
      begin

    SendMessage(grdInventoryTransactionErrorLog.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEUP,     { Scroll Command }
                0);            { Not Used }

      end
     else
    SendMessage(grdInventoryTransactionErrorLog.Handle,  { HWND of the Memo Control }
                WM_VSCROLL,    { Windows Message }
                SB_LINEDOWN,     { Scroll Command }
                0);            { Not Used }


     Handled := False;
   end;
  end;


end;

procedure TfrmInventoryTransactionDetail.btnEditHistoryClick(Sender: TObject);
begin
  grdInventoryTransactionDetail.Row := 1; //moves cursor to top rec - for visual reference

  if grdInventoryTransactionDetail.Cells[0,1] = 'COMPLETE' then

  begin

  if grdInventoryTransactionDetail.Cells[35,1] <> '' then
 begin
     grdInventoryTransactionDetail.Row := 1;
  Application.CreateForm(TfrmInventoryTransactionEdit, frmInventoryTransactionEdit);
       frmInventoryTransactionEdit.Caption := 'Inventory Transaction Edit '+grdInventoryTransactionDetail.Cells[5,1] +' '+ grdInventoryTransactionDetail.Cells[6,1];

       frmInventoryTransactionEdit.edtItemDescription.Text := grdInventoryTransactionDetail.Cells[9,1];
          frmInventoryTransactionEdit.edtBarCodeHCPCS.Text := grdInventoryTransactionDetail.Cells[30,1];
      frmInventoryTransactionEdit.edtBarCodeItemCost.Value := strToFloat(grdInventoryTransactionDetail.Cells[11,1]);
frmInventoryTransactionEdit.edtBarCodeHCPCSChangeDate.Text := grdInventoryTransactionDetail.Cells[31,1];
           frmInventoryTransactionEdit.edtIssuedHCPCS.Text := grdInventoryTransactionDetail.Cells[7,1];
        frmInventoryTransactionEdit.edtIssuedHCPCSIEN.Text := grdInventoryTransactionDetail.Cells[42,1];
            frmInventoryTransactionEdit.edtQtyCurrent.Text := grdInventoryTransactionDetail.Cells[10,1];
                frmInventoryTransactionEdit.edtQtyNew.Text := frmInventoryTransactionEdit.edtQtyCurrent.Text; //Sets display
         frmInventoryTransactionEdit.edtDateOfReceipt.Text := grdInventoryTransactionDetail.Cells[19,1];
        frmInventoryTransactionEdit.edtExpirationDate.Text := grdInventoryTransactionDetail.Cells[14,1];
                frmInventoryTransactionEdit.edtVendor.Text := grdInventoryTransactionDetail.Cells[18,1];
         frmInventoryTransactionEdit.edtExternalLotID.Text := grdInventoryTransactionDetail.Cells[33,1];
            frmInventoryTransactionEdit.edtItemNumber.Text := grdInventoryTransactionDetail.Cells[8,1];
             frmInventoryTransactionEdit.edtStoreRoom.Text := grdInventoryTransactionDetail.Cells[14,1];
         frmInventoryTransactionEdit.edtStationNumber.Text := grdInventoryTransactionDetail.Cells[13,1];

    frmInventoryTransactionEdit.edtEligibilityDisplay.Text := grdInventoryTransactionDetail.Cells[22,1];
       frmInventoryTransactionEdit.edtEligibilityCode.Text := grdInventoryTransactionDetail.Cells[40,1];

          frmInventoryTransactionEdit.edtSerialNumber.Text := grdInventoryTransactionDetail.Cells[15,1];
             frmInventoryTransactionEdit.edtLotNumber.Text := grdInventoryTransactionDetail.Cells[16,1];
               frmInventoryTransactionEdit.edtRemarks.Text := grdInventoryTransactionDetail.Cells[23,1];
                frmInventoryTransactionEdit.edtIEN668.Text := grdInventoryTransactionDetail.Cells[36,1];
                frmInventoryTransactionEdit.edtIEN660.Text := grdInventoryTransactionDetail.Cells[35,1];
         frmInventoryTransactionEdit.lblBannerName.Caption := grdInventoryTransactionDetail.Cells[5,1] +' '+ grdInventoryTransactionDetail.Cells[6,1];
     frmInventoryTransactionEdit.edtTypeOfTransaction.Text := grdInventoryTransactionDetail.Cells[41,1];


                   if grdInventoryTransactionDetail.Cells[17,1] = 'EXCLUDED'  then
                     begin
                      frmInventoryTransactionEdit.edtExcludeWaiver.Text := 'E';
                      frmInventoryTransactionEdit.chkExclude.Checked := True;
                      frmInventoryTransactionEdit.chkWaiver.Checked := False;
                     end;

                     if grdInventoryTransactionDetail.Cells[17,1] = 'WAIVER'  then
                     begin
                      frmInventoryTransactionEdit.edtExcludeWaiver.Text := 'W';
                      frmInventoryTransactionEdit.chkWaiver.Checked := True;
                      frmInventoryTransactionEdit.chkExclude.Checked := False;
                     end;

                     if grdInventoryTransactionDetail.Cells[12,1] = 'COMMERCIAL'  then
                          frmInventoryTransactionEdit.edtSource.Text := 'C';

                     if grdInventoryTransactionDetail.Cells[12,1] = 'VA'  then
                          frmInventoryTransactionEdit.edtSource.Text := 'V';

                     if grdInventoryTransactionDetail.Cells[41,1] = 'I'  then
                     begin
                          frmInventoryTransactionEdit.edtTypeOfTransaction.Text := 'I';
                          frmInventoryTransactionEdit.rgrpTypeOfTransaction.ItemIndex := 0;
                     end;

                     if grdInventoryTransactionDetail.Cells[41,1] = 'X'  then
                     begin
                          frmInventoryTransactionEdit.edtSource.Text := 'X';
                          frmInventoryTransactionEdit.rgrpTypeOfTransaction.ItemIndex := 1;
                     end;

    frmInventoryTransactionEdit.ShowModal;
   end
  else
   ShowMessage('Sorry, this record has been deleted.');
  end
  else
   ShowMessage('Sorry, the CURRENT STATUS of this record must be COMPLETE before editing.');
end;

procedure TfrmInventoryTransactionDetail.btnDeleteHistoryClick(Sender: TObject);
begin
grdInventoryTransactionDetail.Row := 1; //moves cursor to top rec - for reference

  if grdInventoryTransactionDetail.Cells[0,1] = 'COMPLETE' then

  begin

 if grdInventoryTransactionDetail.Cells[35,1] <> '' then
  begin
    if MessageDlg('Are you sure you want to delete this Record?',mtConfirmation,[mbNo,mbYes],0) = mrYes then
      begin
        frmMenu.brkrRPC.RemoteProcedure := 'RMPR INV 2319 DELETE';
        frmMenu.brkrRPC.Param[1].Value := grdInventoryTransactionDetail.Cells[35,1];    //Selected Consult IENs
        frmMenu.brkrRPC.Param[1].PType := literal;

     Try
     //
      frmMenu.brkrRPC.Call;

     except
      on E:EBrokerError do
        begin
        Showmessage('Broker Error: '+ E.Message);
        end;
      on E:EAccessViolation do
        ShowMessage(E.Message);
      else
        raise;
      end;

        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
           MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);

        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then  //Ok
           begin
            MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
            btnDisplay.Click;
           end;
    end;
   end
  else
   ShowMessage('Sorry, this record has already been deleted');
  end
  else
   ShowMessage('Sorry, the CURRENT STATUS of this record must be COMPLETE before deleting.');
end;


procedure TfrmInventoryTransactionDetail.btnEditErrorClick(Sender: TObject);
begin
 if grdInventoryTransactionErrorLog.Cells[9,grdInventoryTransactionErrorLog.Row] <> '' then
  begin
    Application.CreateForm(TfrmInventoryTransactionErrorResolve, frmInventoryTransactionErrorResolve);
        frmInventoryTransactionErrorResolve.edtErrorIEN666.Text := edtinventoryTransactionIEN.Text;
     frmInventoryTransactionErrorResolve.edtErrorIEN666_09.Text := grdInventoryTransactionErrorLog.Cells[9,grdInventoryTransactionErrorLog.Row];
      frmInventoryTransactionErrorResolve.lblBannerName.Caption := lblBannerName.Caption;
      frmInventoryTransactionErrorResolve.Caption := 'Inventory Transaction Error Resolution  '+ lblBannerName.Caption;
          frmInventoryTransactionErrorResolve.edtErrorCode.Text := grdInventoryTransactionErrorLog.Cells[2,grdInventoryTransactionErrorLog.Row];
   frmInventoryTransactionErrorResolve.edtErrorDescription.Text := grdInventoryTransactionErrorLog.Cells[3,grdInventoryTransactionErrorLog.Row];
      frmInventoryTransactionErrorResolve.edtErrorSeverity.Text := grdInventoryTransactionErrorLog.Cells[4,grdInventoryTransactionErrorLog.Row];
       frmInventoryTransactionErrorResolve.edtErrorRemarks.Text := grdInventoryTransactionErrorLog.Cells[8,grdInventoryTransactionErrorLog.Row];

   frmInventoryTransactionErrorResolve.ShowModal;

  end
else
 ShowMessage('There is no Error Record or the selected record has a missing IEN'); 
end;

procedure TfrmInventoryTransactionDetail.btnClearClick(Sender: TObject);
var
  i : integer;

begin

  for i :=1 to grdInventoryTransactionDetail.RowCount -1 do   //If selected will clear the grid
    grdInventoryTransactionDetail.Rows[i].Clear;

 grdInventoryTransactionDetail.Row := 1;
 grdInventoryTransactionDetail.Cells[0,1] :='';
 edtDateTime.Visible := False;
 edtNumberOfTotalRecords.Text := '0';
end;


procedure TfrmInventoryTransactionDetail.btnCloseClick(Sender: TObject);
begin
Close;
end;

procedure TfrmInventoryTransactionDetail.btnDisplayClick(Sender: TObject);
var
  i : integer;
  ani: TAnimationThread;
  r: TRect;

begin
    edtNumberOfTotalRecords.Text := '0'; // For display
    btnClear.Click;

    frmMenu.brkrRPC.RemoteProcedure := 'RMPR INV MON DETAIL';
    frmMenu.brkrRPC.Param[1].Value := edtInventoryTransactionIEN.Text;
    frmMenu.brkrRPC.Param[1].Ptype := literal;


 TRY
  begin
  edtDateTime.Visible := False;
  pnlProgressBar.Visible := true;
  r := pnlProgressBar.clientrect;
  InflateRect( r, - pnlProgressBar.bevelwidth, - pnlProgressBar.bevelwidth );

  //Start progress bar in thread
  ani := TanimationThread.Create( pnlProgressBar, r, pnlProgressBar.color, clWindowText, 25 );

  Application.ProcessMessages;
      frmMenu.brkrRPC.Call;//Sleep( 1000 );  {replace with query.Open or such}

  //Stop progress bar
  pnlProgressBar.Visible := False;
  ani.Terminate;
  end;
 Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
  END;

 btnDisplay.Caption := 'Display / Refresh';

 if frmMenu.brkrRPC.Results.Count > 0 then    // checks for null return
 begin

 edtNumberOfTotalRecords.Text := IntToStr(frmMenu.brkrRPC.Results.Count);//

 if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then
    begin //b2
      MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
      lblBannerName.Caption := Piece(frmMenu.brkrRPC.Results[0],'^',2);
      edtNumberOfTotalRecords.Text := '0';

    end  //b2
 else

 begin  //b3

    edtDateTime.Text := DateTimeToStr(now); //Displays D&T of call
    edtDateTime.Visible := True;

    for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do
    begin  //b4 // Getting data from the broker call
     with grdInventoryTransactionDetail do
      begin
         Cells[0,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',5);  // Current Status        5
         Cells[1,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',34); // Action Type           34
         Cells[2,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',6);  // TRANSACTION DATE      6
         Cells[3,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',9); // TYPE OF TRANSACTION   9
         Cells[4,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',8);  // USER NAME             8
         Cells[5,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',1);  // Pt Name               1
         Cells[6,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',2);  // Pt SSN                2
         Cells[7,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',23); // PSAS HCPCS            23
         Cells[8,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',12); // ITEM CODE             12
         Cells[9,i+1]  := Piece(frmMenu.brkrRPC.Results[i],'^',13); // ItemDesc              13
         Cells[10,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',22 ); // QUANTITY              22
         Cells[11,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',21 ); // ITEM COST             21
         Cells[12,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',18 ); // SOURCE                18
         Cells[13,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',17 ); // EXTERNAL STATION      17
         Cells[14,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',16 ); // STOREROOM             16
         Cells[15,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',25 ); // SERIAL NBR            25
         Cells[16,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',26 ); // LOT NUMBER            26
         Cells[17,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',27 ); // EXCLUDE/WAIVER        27
         Cells[18,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',15 ); // VENDOR                15
         Cells[19,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',20 ); // CONTRACT #            20
         Cells[20,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',19 ); // DATE OF RECEIPT       19
         Cells[21,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',14 ); // ITEM EXPIRATION DATE  14
         Cells[22,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',30 ); // PATIENT CATEGORY      30
         Cells[23,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',32 ); // REMARKS               32

     //    Cells[24,i+1] :=
     //    Cells[25,i+1] :=
     //    Cells[26,i+1] :=
     //    Cells[27,i+1] :=
     //    Cells[28,i+1] :=
     //    Cells[29,i+1] :=

         Cells[30,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',28);  // BARCODE HCPCS       28
         Cells[31,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',29);  // HCPCS VERSION DATE  29
         Cells[32,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',35 ); // Qty Sent            35
         Cells[33,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',11 ); // Ext Lot #           11
         Cells[34,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',10 ); // HL7 MESSAGE ID      10
         Cells[35,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',7 );  // IEN 660             7
         Cells[36,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',36 ); // IEN 668             36
         Cells[37,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',33 ); // IEN 666.10          33
         Cells[38,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3 );  // PSAS Ref #          3
         Cells[39,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4 );  // External Ref #      4
         Cells[40,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',31 ); // Pt Catagory Code
         Cells[41,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',37 ); // Internal Type of Tran
         Cells[42,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',24 ); // HCPCS IEN


//       grdInventoryManager.Cells[,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^', );  //
       end;


(*
1  Patient Name
2  SSN in the form NNN-NN-NNNN
3  PSAS REFERENCE NUMBER
4  EXTERNAL REFERENCE NUMBER
5  CURRENT STATUS
6  TRANSACTION DATE
7  2319 RECORD
8  USER NAME
9  TYPE OF TRANSACTION
10 HL7 MESSAGE ID
11 EXTERNAL MESSAGE RESULT
12 ITEM CODE
13 ITEM DESCRIPTION
14 ITEM EXPIRATION DATE
15 VENDOR
16 STOREROOM
17 EXTERNAL STATION
18 SOURCE
19 DATE OF RECEIPT
20 CONTRACT #
21 ITEM COST
22 QUANTITY
23 PSAS HCPCS
24 SERIAL NBR
25 LOT NUMBER
26 EXCLUDE/WAIVER
27 BARCODE HCPCS
28 HCPCS VERSION DATE
29 PATIENT CATEGORY
30 REMARKS


*)
   end;
  end;
      if grdInventoryTransactionDetail.Cells[1,1] <> ''  then
      begin
        grdInventoryTransactionDetail.RowCount := frmMenu.brkrRPC.Results.Count +1;// - 3; //Sizes grid to match results
        lblBannerName.Caption := grdInventoryTransactionDetail.Cells[5,1] +' '+ grdInventoryTransactionDetail.Cells[6,1];

            edtItemDescriptionDisplay.Text := grdInventoryTransactionDetail.Cells[9,1];
              edtCurrentStatusDisplay.Text := grdInventoryTransactionDetail.Cells[0,1];
                              edtQty.Value := StrToInt(grdInventoryTransactionDetail.Cells[10,1]);
                     edtVendorDisplay.Text := grdInventoryTransactionDetail.Cells[18,1];
                  edtBarcodeItemCost.Value := StrToFloat(grdInventoryTransactionDetail.Cells[11,1]);
                        edtTotalCost.Value := (edtQty.Value * edtBarCodeItemCost.Value);
               edtBarCodeHCPCSDisplay.Text := grdInventoryTransactionDetail.Cells[30,1];
           edtHCPCSVersionDateDisplay.Text := grdInventoryTransactionDetail.Cells[31,1];
           edtTypeOfTranactionDisplay.Text := grdInventoryTransactionDetail.Cells[3,1];
                     edtActionDisplay.Text := grdInventoryTransactionDetail.Cells[1,1];
                     edtSourceDisplay.Text := grdInventoryTransactionDetail.Cells[12,1];
             edtExpirationDateDisplay.Text := grdInventoryTransactionDetail.Cells[21,1];
              edtDateOfReceiptDisplay.Text := grdInventoryTransactionDetail.Cells[20,1];
             edtContractNumberDisplay.Text := grdInventoryTransactionDetail.Cells[19,1];
                    edtStationDisplay.Text := grdInventoryTransactionDetail.Cells[13,1];
                  edtStoreroomDisplay.Text := grdInventoryTransactionDetail.Cells[14,1];
               edtSerialNumberDisplay.Text := grdInventoryTransactionDetail.Cells[15,1];
                  edtLotNumberDisplay.Text := grdInventoryTransactionDetail.Cells[16,1];
              edtExcludeWaiverDisplay.Text := grdInventoryTransactionDetail.Cells[17,1];
                 edtItemNumberDisplay.Text := grdInventoryTransactionDetail.Cells[8,1];
             edtLastActionDateDisplay.Text := grdInventoryTransactionDetail.Cells[2,1];
                            IMDetailIEN668 := grdInventoryTransactionDetail.Cells[36,1];

      end;
      btnDisplayErrorLog.Click;
  end
   else grdInventoryTransactionDetail.RowCount := 2;

end;

procedure TfrmInventoryTransactionDetail.FormActivate(Sender: TObject);
begin
 frmInventoryTransactionDetail.WindowState := wsMaximized; //open as full window
end;



procedure TfrmInventoryTransactionDetail.FormClose(Sender: TObject;
  var Action: TCloseAction);
var
   RowToFind : integer;
begin
//frmInventoryTransactionMonitor.btnDisplay.Click; //Refreshes for latest records
RowToFind := frmInventoryTransactionMonitor.grdInventoryTransactionMonitor.FindRow
            (38,edtInventoryTransactionIEN.Text); //Searches for row with IEN of DETAIL DISPLAY
frmInventoryTransactionMonitor.grdInventoryTransactionMonitor.Row := RowToFind;  //Goes to that row

release;
end;



procedure TfrmInventoryTransactionDetail.FormCreate(Sender: TObject);
begin
with grdInventoryTransactionDetail do
 begin
      Cells[0,0] := 'Status';                      
      ColWidths[0] := 75;                          
                                                   
      Cells[1,0] := 'Action Type';                 
      ColWidths[1] := 100;                         
                                                   
      Cells[2,0] := 'Action Date';                 
      ColWidths[2] := 150;                         
                                                   
      Cells[3,0] := 'Type of Trans';               
      ColWidths[3] := 100;                         
                                                   
      Cells[4,0] := 'User Name';
      ColWidths[4] := 125;

      Cells[5,0] := 'Patient Name';
      ColWidths[5] := 125;

      Cells[6,0] := 'SSN';
      ColWidths[6] := 75;

      Cells[7,0] := 'HCPCS';
      ColWidths[7] := 50;

      Cells[8,0] := 'Item Code';
      ColWidths[8] := 75;

      Cells[9,0] := 'Item Description';  
      ColWidths[9] := 100;               
                                         
      Cells[10,0] := 'Qty';              
      ColWidths[10] := 30;               
                                         
      Cells[11,0] := 'Item Cost';        
      ColWidths[11] := 75;               
                                         
      Cells[12,0] := 'Source';           
      ColWidths[12] := 100;              
                                         
      Cells[13,0] := 'Station';
      ColWidths[13] := 50;

      Cells[14,0] := 'Storeroom';
      ColWidths[14] := 60;

      Cells[15,0] := 'Serial #';
      ColWidths[15] := 100;

      Cells[16,0] := 'Lot #';
      ColWidths[16] := 100;

      Cells[17,0] := 'Exc/Wav';
      ColWidths[17] := 100;

      Cells[18,0] := 'Vendor';
      ColWidths[18] := 100;

      Cells[19,0] := 'Contract #';
      ColWidths[19] := 125;

      Cells[20,0] := 'Date of Receipt';
      ColWidths[20] := 100;

      Cells[21,0] := 'Expiration';
      ColWidths[21] := 100;

      Cells[22,0] := 'Pt Cat';
      ColWidths[22] := 100;

      Cells[23,0] := 'Remarks';
      ColWidths[23] := 200;

      Cells[24,0] := '';
      ColWidths[24] := -1;

      Cells[25,0] := '';
      ColWidths[25] := -1;

      Cells[26,0] := '';
      ColWidths[26] := -1;

      Cells[27,0] := '';
      ColWidths[27] := -1;

      Cells[28,0] := '';
      ColWidths[28] := -1;

      Cells[29,0] := '';
      ColWidths[29] := -1;



      Cells[30,0] := 'Barcode HCPCS';
      ColWidths[30] := 100;

      Cells[31,0] := 'HCPCS Date';
      ColWidths[31] := 100;

      Cells[32,0] := 'Qty Sent';
      ColWidths[32] := 40;

      Cells[33,0] := 'Ext Lot';
      ColWidths[33] := 100;

      Cells[34,0] := 'HL7 ID';
      ColWidths[34] := 100;

      Cells[35,0] := 'IEN 660';
      ColWidths[35] := 75;

      Cells[36,0] := 'IEN 668';
      ColWidths[36] := 75;

      Cells[37,0] := 'IEN 666.10';
      ColWidths[37] := 75;

      Cells[38,0] := 'Vista Ref';
      ColWidths[38] := 100;

      Cells[39,0] := 'External Ref';
      ColWidths[39] := 100;

      Cells[40,0] := 'Pt Cat Code';
      ColWidths[40] := 50;

      Cells[41,0] := 'Trans Type Code';
      ColWidths[41] := 50;

      Cells[42,0] := 'HCPCS IEN';
      ColWidths[42] := 50;


  end;


 with grdInventoryTransactionErrorLog do
 begin
      Cells[0,0] := 'Resolved?';
      ColWidths[0] := 75;

      Cells[1,0] := 'Source';
      ColWidths[1] := 75;

      Cells[2,0] := 'Error Code';
      ColWidths[2] := 75;

      Cells[3,0] := 'Error Description';
      ColWidths[3] := 350;

      Cells[4,0] := 'Severity';
      ColWidths[4] := 75;

      Cells[5,0] := 'User';
      ColWidths[5] := 150;

      Cells[6,0] := 'Date Resolved';
      ColWidths[6] := 125;

      Cells[7,0] := 'Transaction IEN';
      ColWidths[7] := 75;

      Cells[8,0] := 'Remarks';
      ColWidths[8] := 250;

      Cells[9,0] := 'IEN 669.09';
      ColWidths[9] := 75;

  end;



end;

procedure TfrmInventoryTransactionDetail.FormShow(Sender: TObject);
begin
//btnDisplay.Click;
//btnDisplayErrorLog.Click;
end;

procedure TfrmInventoryTransactionDetail.grdInventoryTransactionDetailDrawCell(
  Sender: TObject; ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
var
    i : integer;
begin
  with grdInventoryTransactionDetail do
  begin
     if {(ACol = 0) or} (ARow = 0) then
        Canvas.Brush.Color := clBtnFace
       else
      begin

(*    case ACol of

        0: for i := 0 to grdInventoryTransactionDetail.RowCount do//sets cell color
            begin
             if (ARow = i) and (Cells[0,i] = 'ERROR') then
             begin
               Canvas.Font.Style := [fsBold];
               Canvas.Font.Color := clWhite;
               Canvas.Brush.Color := clRed;
             end;
            end;


        6: for i := 0 to grdInventoryTransactionDetail.RowCount do//sets cell color
            begin
             if (ARow = i) and (Cells[6,i] = 'ERROR') then
             begin
               Canvas.Font.Style := [fsBold];
               Canvas.Font.Color := clWhite;
               Canvas.Brush.Color := clYellow;
             end;
            end;

    end;
  *)
// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;

  end;

//Final draw of grid

        Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
        Canvas.FrameRect(Rect);

      end;
  end;
end;

end.
