unit uPROS_DLLCommon;
{
================================================================================
*
*       Application:  Vitals
*       Revision:     $Revision: 1 $  $Modtime: 8/27/09 12:56p $
*       Developer:    andrey.andriyevskiy@domain.ext
*       Site:         Hines OIFO
*
*       Description:  Common DLL handling functions.
*
*       Notes:
*
================================================================================
*       $Archive: /PROS/Prosthetics Vista Suite/Source/Menu/uPROS_DLLCommon.pas $
*
* $History: uPROS_DLLCommon.pas $
 * 
 * *****************  Version 1  *****************
 * User: Vhaishnelsok Date: 1/07/11    Time: 12:07p
 * Created in $/PROS/Prosthetics Vista Suite/Source/Menu
 * 
 * *****************  Version 1  *****************
 * User: Vhaishnelsok Date: 11/13/09   Time: 2:03p
 * Created in $/PROS/Prosthetics Vista Suite V4/Source/Menu
 * 
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 7/17/07    Time: 2:30p
 * Updated in $/Vitals GUI 2007/Vitals-5-0-18/VITALSUTILS
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 5/14/07    Time: 10:30a
 * Created in $/Vitals GUI 2007/Vitals-5-0-18/VITALSUTILS
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 5/16/06    Time: 5:44p
 * Created in $/Vitals/VITALS-5-0-18/VitalsUtils
 * GUI v. 5.0.18 updates the default vital type IENs with the local
 * values.
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 5/16/06    Time: 5:33p
 * Created in $/Vitals/Vitals-5-0-18/VITALS-5-0-18/VitalsUtils
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/25/06    Time: 8:57a
 * Created in $/Vitals/Vitals 5.0.3/DLL-Common
 * 060125 test
 *

 ================================================================================
}
interface

uses
  Forms,Windows,Dialogs;

  procedure FindModule(const aLibrary: String; const aModule:String;var H:THandle;var P: Pointer);
  function RunDLLDialog(aLibrary,aFunction:String): Integer;

implementation

// Note: Don't forget to free memory if H is not 0!
procedure FindModule(const aLibrary: String; const aModule:String;var H:THandle;var P: Pointer);
var
  DLLHandle: THandle;
begin
  P := nil;
//  DLLHandle:= 0;
  try
    DLLHandle := LoadLibrary(PChar(aLibrary));
    if DLLHandle <> 0 then
      begin
        H := DLLHandle;
        P := nil;
        P := GetProcAddress(DLLHandle,PChar(aModule));
        if not Assigned(P) then
         ShowMessage('Error: Failure loaging function <'+aModule+'>');
      end
    else
      ShowMessage('Error: Failure loaging library <'+PChar(aLibrary)+'>');
  except
    H := 0;
    P := nil;
  end;
end;

function RunDLLDialog(aLibrary,aFunction:String): Integer;
type
  TFuncSign = function:Integer;
var
  FuncSign : TFuncSign;
  DLLHandle : THandle;
  P: Pointer;
  i: Integer;
begin
  i := -1;
  FindModule(aLibrary,aFunction,DLLHandle,P);
  if Assigned(P) then
    begin
      @FuncSign := P;
      i := FuncSign;
    end;
  @FuncSign := nil;
  FreeLibrary(DLLHandle);
  Result := i;
end;

end.
