(*******************************************

Package: RMPR - RMPR*3*75 - OWL
Date Created: August 28, 2006
Site Name: Hines OI Field Office
Developers: Sam Spencer, Ken Nelson
Description: Orthotic Work order and Lab (OWL) program add HCPCS.

*******************************************)

unit uPROS_OWL_AddHCPCS;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Diaccess, Fmcmpnts, StdCtrls, Fmcntrls, Buttons, NumEdit,
  ExtCtrls, Trpcb, CurrEdit, MFunstr;

type
  TfrmOWLAddHCPCS = class(TForm)
    btnOWLHCPCSUpdate: TBitBtn;
    btnOWLHCPCSAdd: TBitBtn;
    btnOWLHCPCSDelete: TBitBtn;
    rgrpOWLAddHCPCSEligibility: TFMRadioGroup;
    edtOWLAddHCPCSEligibility: TFMEdit;
    btnUpdate664_1: TBitBtn;
    grpOWLBaseCode: TGroupBox;
    lblOWLAddHCPCSBillingItem: TFMLabel;
    cbxOWLAddHCPCSBillingItem: TFMComboBoxLookUp;
    lblOWLAddHCPCS_HCPCS: TFMLabel;
    lblOWLAddHCPCSQty: TFMLabel;
    lblOWLAddHCPCSUnitOfIssue: TFMLabel;
    lblOWLAddHCPCSVendor: TFMLabel;
    edtOWLAddHCPCSBillingItemIEN: TFMEdit;
    edtOWLAddHCPCSQty: TIntEdit;
    cbxOWLAddHCPCSUnitOfIssue: TFMComboBoxLookUp;
    edtOWLAddHCPCSUnitOfIssueIEN: TFMEdit;
    cbxOWLAddHCPCSVendor: TFMComboBoxLookUp;
    edtOWLAddHCPCSVendorIEN: TFMEdit;
    dbsLister420_5: TFMLister;
    dbsLister440: TFMLister;
    dbsLister661: TFMLister;
    cbxOWLAddHCPCS_HCPCS: TFMComboBoxLookUp;
    edtOWLAddHCPCS_HCPCSIEN: TFMEdit;
    dbsLister661_1: TFMLister;
    rgrpOWLAddHCPCSCPTModifier: TFMRadioGroup;
    edtOWLAddHCPCSCPTModifier: TFMEdit;
    rgrpOWLAddHCPCSTypeOfTransaction: TFMRadioGroup;
    edtOWLAddHCPCSTypeOfTransaction: TFMEdit;
    edtOWLAddHCPCSSerialNumber: TFMEdit;
    lblOWLAddHCPCSSerialNumber: TFMLabel;
    edtOWLAddHCPCSTotalCost: TCurrencyEdit;
    lblTotalCost: TFMLabel;
    btnClose: TBitBtn;
    edtOWLAddHCPCSBriefDescription: TFMEdit;
    lblOWLAddHCPCSBriefDescription: TFMLabel;
    chkOWLAddHCPCSHiTechItem: TFMCheckBox;
    edtOWLAddHCPCSHiTechItem: TFMEdit;
    memOWLAddHCPCSExtendedDescription: TFMMemo;
    lblOWLAddHCPCSExtendedDescription: TFMLabel;
    lblOWLAddHCPCSPrimaryItem: TFMLabel;
    lblOWLHCPCSEditType: TFMLabel;
    edtOWLAddHCPCSUnitOfIssue: TFMEdit;
    edtOWLAddHCPCSBillingItem: TFMEdit;
    edtOWLAddHCPCS_HCPCS: TFMEdit;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnOWLAddHCPCSExtendedDescriptionClick(Sender: TObject);
    procedure btnOWLHCPCSAddClick(Sender: TObject);
    procedure btnUpdate664_1Click(Sender: TObject);
    procedure cbxOWLAddHCPCSVendorSelect(Sender: TObject);
    procedure cbxOWLAddHCPCSBillingItemSelect(Sender: TObject);
    procedure rgrpOWLAddHCPCSCPTModifierClick(Sender: TObject);
    procedure cbxOWLAddHCPCS_HCPCSSelect(Sender: TObject);
    procedure cbxOWLAddHCPCSUnitOfIssueSelect(Sender: TObject);
    procedure rgrpOWLAddHCPCSEligibilityClick(Sender: TObject);
    procedure rgrpOWLAddHCPCSTypeOfTransactionClick(Sender: TObject);
    procedure btnOWLHCPCSUpdateClick(Sender: TObject);
    procedure btnOWLHCPCSDeleteClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure chkOWLAddHCPCSHiTechItemClick(Sender: TObject);
    procedure cbxOWLAddHCPCSBillingItemExit(Sender: TObject);
    procedure cbxOWLAddHCPCS_HCPCSExit(Sender: TObject);
    procedure cbxOWLAddHCPCSVendorExit(Sender: TObject);
    procedure cbxOWLAddHCPCSUnitOfIssueExit(Sender: TObject);
    procedure edtOWLAddHCPCSBriefDescriptionKeyPress(Sender: TObject;
      var Key: Char);
    procedure edtOWLAddHCPCSSerialNumberKeyPress(Sender: TObject;
      var Key: Char);
    procedure edtOWLAddHCPCSQtyKeyPress(Sender: TObject; var Key: Char);
    procedure edtOWLAddHCPCSQtyExit(Sender: TObject);
    procedure edtOWLAddHCPCSBriefDescriptionExit(Sender: TObject);
    procedure edtOWLAddHCPCSSerialNumberExit(Sender: TObject);
    procedure cbxOWLAddHCPCSBillingItemDropDown(Sender: TObject);
    procedure cbxOWLAddHCPCS_HCPCSDropDown(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOWLAddHCPCS: TfrmOWLAddHCPCS;
  AddHCPCSIEN664_1, AddHCPCSIEN664_2, AddHCPCSIEN669_9,
  AddHCPCSIEN664_16, HCPCSRecordFilingType : string;

implementation

uses Pros_Menu,uPROS_OWL, uPROS_OWL_ExtDesc;

{$R *.dfm}

procedure TfrmOWLAddHCPCS.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 Release;
end;

procedure TfrmOWLAddHCPCS.btnOWLAddHCPCSExtendedDescriptionClick(Sender: TObject);
begin
Application.CreateForm(TfrmOWLExtDesc, frmOWLExtDesc);
frmOWLExtDesc.ShowModal;   //OWL Extended Description memo
end;

procedure TfrmOWLAddHCPCS.btnOWLHCPCSAddClick(Sender: TObject);
begin
HCPCSRecordFilingType := 'A';
AddHCPCSIEN664_16 := ''; //Must be null for add to work
btnUpdate664_1.Click;
end;

procedure TfrmOWLAddHCPCS.btnUpdate664_1Click(Sender: TObject);
var
            r : integer;
  OrgIEN664_1 : String;
begin
    begin
      if (edtOWLAddHCPCSBillingItemIEN.Text = '') then
      MessageDlg('Please select a Billing Item',mtInformation, [mbOk],0)
    else
    begin
      if (edtOWLAddHCPCS_HCPCSIEN.Text = '') then
      MessageDlg('Please select a HCPCS Item',mtInformation, [mbOk],0)
    else
//    begin
//      if (Length(edtOWLAddHCPCSBriefDescription.Text) < 3) then
//      MessageDlg('Please enter at least 3 characters in the Brief Description',mtInformation, [mbOk],0)
//    else
    begin
      if (edtOWLAddHCPCSQty.Value < 1) then
      MessageDlg('Please select Quantity',mtInformation, [mbOk],0)
    else
    begin
      if (edtOWLAddHCPCSUnitOfIssueIEN.Text = '') then
      MessageDlg('Please select a Unit Of Issue',mtInformation, [mbOk],0)
    else
//    begin //per user - no vendor needed here
//      if (edtOWLAddHCPCSVendorIEN.Text = '') then
//      MessageDlg('Please select a Vendor',mtInformation, [mbOk],0)
//    else

  begin
  // Send

        frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL ENTER/EDIT HCPCS CODE';
        frmMenu.brkrRPC.Param[1].Value := HCPCSRecordFilingType;    //A-Add(Edit) D-Delete
        frmMenu.brkrRPC.Param[1].PType := literal;
        frmMenu.brkrRPC.Param[2].Value := AddHCPCSIEN669_9;  //Add On File
        frmMenu.brkrRPC.Param[2].PType := literal;
        frmMenu.brkrRPC.Param[3].Value := AddHCPCSIEN664_1;   //Base Codes
        frmMenu.brkrRPC.Param[3].PType := literal;
        frmMenu.brkrRPC.Param[4].Value := AddHCPCSIEN664_16; //Add On Multiple (Null if add)
        frmMenu.brkrRPC.Param[4].PType := literal;
        frmMenu.brkrRPC.Param[5].Value := edtOWLAddHCPCSBillingItemIEN.Text;//Billing Item IEN661
        frmMenu.brkrRPC.Param[5].PType := literal;
        frmMenu.brkrRPC.Param[6].Value := IntToStr(edtOWLAddHCPCSQty.Value);// Qty
        frmMenu.brkrRPC.Param[6].PType := literal;
        frmMenu.brkrRPC.Param[7].Value := edtOWLAddHCPCSUnitOfIssueIEN.Text;// UoI
        frmMenu.brkrRPC.Param[7].PType := literal;
        frmMenu.brkrRPC.Param[8].Value := edtOWLAddHCPCSTypeOfTransaction.Text;//Type of transaction
        frmMenu.brkrRPC.Param[8].PType := literal;
        frmMenu.brkrRPC.Param[9].Value := edtOWLAddHCPCSEligibility.Text;//Patient Category
        frmMenu.brkrRPC.Param[9].PType := literal;
        frmMenu.brkrRPC.Param[10].Value := edtOWLAddHCPCSSerialNumber.Text;//Serial Number
        frmMenu.brkrRPC.Param[10].PType := literal;
        frmMenu.brkrRPC.Param[11].Value := edtOWLAddHCPCS_HCPCSIEN.Text ;//IEN 661.1  -  PSAS HCPCS
        frmMenu.brkrRPC.Param[11].PType := literal;
        frmMenu.brkrRPC.Param[12].Value := edtOWLAddHCPCSCPTModifier.Text;//CPT Modifier
        frmMenu.brkrRPC.Param[12].PType := literal;
        frmMenu.brkrRPC.Param[13].Value := '';// edtOWLAddHCPCSVendorIEN.Text;//Vendor
        frmMenu.brkrRPC.Param[13].PType := literal;
        frmMenu.brkrRPC.Param[14].Value := edtOWLAddHCPCSBriefDescription.Text;//Brief Description
        frmMenu.brkrRPC.Param[14].PType := literal;
        frmMenu.brkrRPC.Param[15].Value := edtOWLAddHCPCSHiTechItem.Text;//Brief Description
        frmMenu.brkrRPC.Param[15].PType := literal;
        frmMenu.brkrRPC.Param[16].Mult.Assign (memOWLAddHCPCSExtendedDescription.Lines);  //Extended Description
        frmMenu.brkrRPC.Param[16].PType := list;
        frmMenu.brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?


    Try
    //
  frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;


 if frmMenu.brkrRPC.Results.Count > 0 then    // checks for null return
   begin
     if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then
      begin //b2
       MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
      end;
   end;

// If no tech assigned auto assign stuffs user DUZ as tech, refreshes OWL
 if frmOWL.grdOWLWorkOrders.Cells[4,frmOWL.grdOWLWorkOrders.Row] = '' then //not assigned yet
    begin
    OrgIEN664_1 := IEN664_1;
    if frmOwl.chkAssigned.Checked = false then
       ShowMessage('NOTICE: You are currently not viewing work orders with the Status of "ASSIGNED".'+#13+
                   ''+#13+
                   'Because this work order now has a Status of "ASSIGNED" it has been removed from the list.'+#13+
                   ''+#13+
                   'Check the Status "ASSIGNED" then click Refresh to continue with this Work Order.');
    frmOWL.btnDisplay.Click;

  //If ASSIGNED is cheked for display, finds record and selects
   for r := 1 to frmOWL.grdOWLWorkOrders.RowCount -1  do
     begin
       if frmOWL.grdOWLWorkOrders.Cells[12,r] = OrgIEN664_1 then
          frmOWL.grdOWLWorkOrders.Row := r;
     end;
    end
//**************************    
  else
   begin
   frmOWL.btnRefreshItemListGrid.Click;
     if HCPCSRecordFilingType = 'U' then
       frmOWL.grdOWLItemList.Row := OWLItemListEditRowID; //Select current row after refersh
    frmOWL.btnRefreshMaterialListGrid.Click;
   frmOWL.btnRefreshLaborListGrid.Click;
  end;

 Close;
     end;
    end;
   end;
  end;
 end;
end;

procedure TfrmOWLAddHCPCS.cbxOWLAddHCPCSVendorSelect(Sender: TObject);
begin
if cbxOWLAddHCPCSVendor.ItemIndex >= 0 then
   begin
    edtOWLAddHCPCSVendorIEN.Text := cbxOWLAddHCPCSVendor.GetSelectedRecord.IEN;
   end;
end;

procedure TfrmOWLAddHCPCS.cbxOWLAddHCPCSBillingItemSelect(
  Sender: TObject);
begin
if cbxOWLAddHCPCSBillingItem.ItemIndex >= 0 then
   begin
    cbxOWLAddHCPCSBillingItem.Perform(EM_SCROLLCARET,0,0);
    edtOWLAddHCPCSBillingItemIEN.Text := cbxOWLAddHCPCSBillingItem.GetSelectedRecord.IEN;
   end;
end;

procedure TfrmOWLAddHCPCS.rgrpOWLAddHCPCSCPTModifierClick(Sender: TObject);
begin
 edtOWLAddHCPCSCPTModifier.Text
  := rgrpOWLAddHCPCSCPTModifier.FMInternalCodes.Strings[rgrpOWLAddHCPCSCPTModifier.ItemIndex];
end;

procedure TfrmOWLAddHCPCS.cbxOWLAddHCPCS_HCPCSSelect(Sender: TObject);
begin
if cbxOWLAddHCPCS_HCPCS.ItemIndex >= 0 then
   begin
    cbxOWLAddHCPCS_HCPCS.Perform(EM_SCROLLCARET,0,0);
    edtOWLAddHCPCS_HCPCSIEN.Text := cbxOWLAddHCPCS_HCPCS.GetSelectedRecord.IEN;
   end;
end;

procedure TfrmOWLAddHCPCS.cbxOWLAddHCPCSUnitOfIssueSelect(
  Sender: TObject);
begin
if cbxOWLAddHCPCSUnitOfIssue.ItemIndex >= 0 then
   begin
    cbxOWLAddHCPCSUnitOfIssue.Perform(EM_SCROLLCARET,0,0);
    edtOWLAddHCPCSUnitOfIssueIEN.Text := cbxOWLAddHCPCSUnitOfIssue.GetSelectedRecord.IEN;
   end;
end;

procedure TfrmOWLAddHCPCS.rgrpOWLAddHCPCSEligibilityClick(
  Sender: TObject);
begin
 edtOWLAddHCPCSEligibility.Text
  := rgrpOWLAddHCPCSEligibility.FMInternalCodes.Strings[rgrpOWLAddHCPCSEligibility.ItemIndex];
end;

procedure TfrmOWLAddHCPCS.rgrpOWLAddHCPCSTypeOfTransactionClick(
  Sender: TObject);
begin
 edtOWLAddHCPCSTypeOfTransaction.Text
  := rgrpOWLAddHCPCSTypeOfTransaction.FMInternalCodes.Strings[rgrpOWLAddHCPCSTypeOfTransaction.ItemIndex];
end;

procedure TfrmOWLAddHCPCS.btnOWLHCPCSUpdateClick(Sender: TObject);
begin
HCPCSRecordFilingType := 'A';
btnUpdate664_1.Click;
end;

procedure TfrmOWLAddHCPCS.btnOWLHCPCSDeleteClick(Sender: TObject);
begin
if MessageDlg('Confirm delete?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
   HCPCSRecordFilingType := 'D';
   btnUpdate664_1.Click;
  end;
end;

procedure TfrmOWLAddHCPCS.btnCloseClick(Sender: TObject);
begin
if MessageDlg('Any changes will be discarded.',
    mtInformation, [mbOk], 0) = mrOk then
Close;
end;

procedure TfrmOWLAddHCPCS.chkOWLAddHCPCSHiTechItemClick(Sender: TObject);
begin
if chkOWLAddHCPCSHiTechItem.Checked = True then
     edtOWLAddHCPCSHiTechItem.Text := '1'
    else
     edtOWLAddHCPCSHiTechItem.Text := '0';
end;

procedure TfrmOWLAddHCPCS.cbxOWLAddHCPCSBillingItemExit(Sender: TObject);
begin
edtOWLAddHCPCSBillingItemIEN.Text := '';

if cbxOWLAddHCPCSBillingItem.ItemIndex >= 0 then
   begin
    cbxOWLAddHCPCSBillingItem.Perform(EM_SCROLLCARET,0,0);
    edtOWLAddHCPCSBillingItemIEN.Text := cbxOWLAddHCPCSBillingItem.GetSelectedRecord.IEN;
   end;
end;

procedure TfrmOWLAddHCPCS.cbxOWLAddHCPCS_HCPCSExit(Sender: TObject);
begin
edtOWLAddHCPCS_HCPCSIEN.Text := '';

if cbxOWLAddHCPCS_HCPCS.ItemIndex >= 0 then
   begin
    cbxOWLAddHCPCS_HCPCS.Perform(EM_SCROLLCARET,0,0);
    edtOWLAddHCPCS_HCPCSIEN.Text := cbxOWLAddHCPCS_HCPCS.GetSelectedRecord.IEN;
   end;

end;

procedure TfrmOWLAddHCPCS.cbxOWLAddHCPCSVendorExit(Sender: TObject);
begin
edtOWLAddHCPCSVendorIEN.Text := '';

if cbxOWLAddHCPCSVendor.ItemIndex >= 0 then
   begin
    cbxOWLAddHCPCSVendor.Perform(EM_SCROLLCARET,0,0);
    edtOWLAddHCPCSVendorIEN.Text := cbxOWLAddHCPCSVendor.GetSelectedRecord.IEN;
   end;
end;

procedure TfrmOWLAddHCPCS.cbxOWLAddHCPCSUnitOfIssueExit(Sender: TObject);
begin
edtOWLAddHCPCSUnitOfIssueIEN.Text := '';

if cbxOWLAddHCPCSUnitOfIssue.ItemIndex >= 0 then
   begin
    cbxOWLAddHCPCSUnitOfIssue.Perform(EM_SCROLLCARET,0,0);
    edtOWLAddHCPCSUnitOfIssueIEN.Text := cbxOWLAddHCPCSUnitOfIssue.GetSelectedRecord.IEN;
   end;
end;

procedure TfrmOWLAddHCPCS.edtOWLAddHCPCSBriefDescriptionKeyPress(
  Sender: TObject; var Key: Char);
begin
if edtOWLAddHCPCSBriefDescription.GetTextLen > 70 then
 begin
   ShowMessage('You have exceded the 70 character maximum');
   Key := #8; //Backspace
 end;
end;

procedure TfrmOWLAddHCPCS.edtOWLAddHCPCSSerialNumberKeyPress(
  Sender: TObject; var Key: Char);
begin
if edtOWLAddHCPCSSerialNumber.GetTextLen > 30 then      //KLN Needs to set min at 3
  begin
   ShowMessage('You have exceded the 30 character maximum');
   Key := #8; //Backspace
  end;
end;

procedure TfrmOWLAddHCPCS.edtOWLAddHCPCSQtyKeyPress(Sender: TObject;
  var Key: Char);
begin
 if edtOWLAddHCPCSQty.Value > 9999 then
  begin
  ShowMessage('Please enter a QUANTITY less that 9,999');
  Key := #8; //Backspace
  end;
end;

procedure TfrmOWLAddHCPCS.edtOWLAddHCPCSQtyExit(Sender: TObject);
begin
if ((edtOWLAddHCPCSQty.Value > 9999) or (edtOWLAddHCPCSQty.Value < 0)) then
 begin
  ShowMessage('Please enter a valid QUANTITY less that 9,999');
  edtOWLAddHCPCSQty.SetFocus;
 end;
if edtOWLAddHCPCSQty.Text = '' then
   edtOWLAddHCPCSQty.Value := 0;
end;

procedure TfrmOWLAddHCPCS.edtOWLAddHCPCSBriefDescriptionExit(
  Sender: TObject);
begin
 if edtOWLAddHCPCSBriefDescription.Text <> '' then
  begin
   if ((edtOWLAddHCPCSBriefDescription.GetTextLen < 3) or (edtOWLAddHCPCSBriefDescription.GetTextLen > 60)) then
    begin
     ShowMessage('The text entered must be between 3 and 60 characters');
     edtOWLAddHCPCSBriefDescription.SetFocus;
    end;
  end;
end;

procedure TfrmOWLAddHCPCS.edtOWLAddHCPCSSerialNumberExit(Sender: TObject);
begin
 if edtOWLAddHCPCSSerialNumber.Text <> '' then
   begin
    if Length(edtOWLAddHCPCSSerialNumber.Text) < 3 then
       begin
       ShowMessage('Please enter a minimum of 3 charactors or EMPTY');
       edtOWLAddHCPCSSerialNumber.SetFocus;
       end;
    if Length(edtOWLAddHCPCSSerialNumber.Text) > 20 then
       begin
       ShowMessage('The text entered exceeds the permited length of 20 characters');
       edtOWLAddHCPCSSerialNumber.SetFocus;
       end;
   end;
end;

procedure TfrmOWLAddHCPCS.cbxOWLAddHCPCSBillingItemDropDown(
  Sender: TObject);
begin
cbxOWLAddHCPCSBillingItem.Perform(CB_SETDROPPEDWIDTH, 350, 0);
end;

procedure TfrmOWLAddHCPCS.cbxOWLAddHCPCS_HCPCSDropDown(Sender: TObject);
begin
cbxOWLAddHCPCS_HCPCS.Perform(CB_SETDROPPEDWIDTH, 350, 0);
end;

procedure TfrmOWLAddHCPCS.FormKeyPress(Sender: TObject; var Key: Char);
begin
if Key = #27 then Close;
end;

end.
