(*******************************************

Package: RMPR - RMPR*3*75 - OWL
Date Created: August 28, 2006
Site Name: Hines OI Field Office
Developers: Sam Spencer, Ken Nelson
Description: Orthotic Work order and Lab (OWL) program add labor.

*******************************************)

unit uPROS_OWL_AddLabor;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Fmcntrls, StdCtrls, CurrEdit, ComCtrls, NumEdit, Diaccess,
  Fmcmpnts, Buttons, Trpcb, MFunstr, ESBDates ;

type
  TfrmOWLAddLabor = class(TForm)
    btnOWLLaborUpdate: TBitBtn;
    btnOWLLaborAdd: TBitBtn;
    btnOWLLaborDelete: TBitBtn;
    btnOWLLaborClose: TBitBtn;
    cbxOWLLaborTechnician: TFMComboBoxLookUp;
    dbsLister200: TFMLister;
    edtOWLLaborHours: TFloatEdit;
    dtpOWLLaborDate: TDateTimePicker;
    edtOWLLaborRate: TCurrencyEdit;
    edtOWLLaborTechnicianIEN: TFMEdit;
    btnUpdate664_3: TBitBtn;
    lblOWLAddLaborTechnician: TFMLabel;
    lblOWLAddLaborDate: TFMLabel;
    lblOWLAddLaborHours: TFMLabel;
    lblOWLLaborRate: TFMLabel;
    edtOWLLaborTechnician: TFMEdit;
    edtOWLLaborDate: TFMEdit;
    procedure btnOWLLaborCloseClick(Sender: TObject);
    procedure cbxOWLLaborTechnicianSelect(Sender: TObject);
    procedure btnOWLLaborAddClick(Sender: TObject);
    procedure btnOWLLaborUpdateClick(Sender: TObject);
    procedure btnOWLLaborDeleteClick(Sender: TObject);
    procedure btnUpdate664_3Click(Sender: TObject);
    procedure edtOWLLaborHoursExit(Sender: TObject);
    procedure cbxOWLLaborTechnicianExit(Sender: TObject);
    procedure edtOWLLaborRateExit(Sender: TObject);
    procedure edtOWLLaborRateEnter(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOWLAddLabor: TfrmOWLAddLabor;
  AddLaborIEN664_1, AddLaborIEN664_2, AddLaborIEN664_3, AddLaborIEN664_33,
  LaborRecordFilingType : string;

implementation

uses Pros_Menu, uPROS_OWL;

{$R *.dfm}

procedure TfrmOWLAddLabor.btnOWLLaborCloseClick(Sender: TObject);
begin
if MessageDlg('Any changes will be discarded.',
    mtInformation, [mbOk], 0) = mrOk then
Close;
end;

procedure TfrmOWLAddLabor.cbxOWLLaborTechnicianSelect(Sender: TObject);
begin
if cbxOWLLaborTechnician.ItemIndex >= 0 then
   begin
    cbxOWLLaborTechnician.Perform(EM_SCROLLCARET,0,0);
    edtOWLLaborTechnicianIEN.Text := cbxOWLLaborTechnician.GetSelectedRecord.IEN;
   end;
end;

procedure TfrmOWLAddLabor.btnOWLLaborAddClick(Sender: TObject);
begin
LaborRecordFilingType := 'A';
btnUpdate664_3.Click;
end;

procedure TfrmOWLAddLabor.btnOWLLaborUpdateClick(Sender: TObject);
begin
LaborRecordFilingType := 'E';
btnUpdate664_3.Click;
end;

procedure TfrmOWLAddLabor.btnOWLLaborDeleteClick(Sender: TObject);
begin
if MessageDlg('Confirm delete?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
  begin
   LaborRecordFilingType := 'D';
   btnUpdate664_3.Click;
  end;
end;

procedure TfrmOWLAddLabor.btnUpdate664_3Click(Sender: TObject);
var
   r : integer;
  OrgIEN664_1 : string;
begin
   begin
     if (edtOWLLaborTechnicianIEN.Text = '') then
     MessageDlg('Please select a Technician',
       mtInformation, [mbOk],0)
   else
   begin
      if (DaysApart(ConsultDate,dtpOWLLaborDate.Date)) < 0  then
//        if ((DaysApart(dtpOWLLaborDate.Date, Now)) > 0) then
      MessageDlg('    Please select a date between the'+#13+
                   'date of the CONSULT and TODAY''S date.', mtInformation, [mbOk],0)
   else
   begin
      if (DaysApart(date,dtpOWLLaborDate.Date)) > 0 then
      MessageDlg('    Please select a date between the'+#13+
                   'date of the CONSULT and TODAY''S date.', mtInformation, [mbOk],0)
   else
   begin
     if (edtOWLLaborHours.Value <= 0)
//       or if ((Piece(edtOWLLaborHours.Text,'.',2) <> '')
//        and (Piece(edtOWLLaborHours.Text,'.',2) <> '25')
//        and (Piece(edtOWLLaborHours.Text,'.',2) <> '5')
//        and (Piece(edtOWLLaborHours.Text,'.',2) <> '75'))
     then
      MessageDlg('Please enter hours in 1/4 increments',mtInformation, [mbOk],0)
   else
   begin
     if (edtOWLLaborRate.Value <= 0) then
     MessageDlg('Please enter a labor rate', mtInformation, [mbOk],0)
   else

   begin
        frmMenu.brkrRPC.RemoteProcedure := 'RMPR OWL ENTER/EDIT HRS/RATE';

        frmMenu.brkrRPC.Param[1].Value := LaborRecordFilingType;    //A-Add(Edit) D-Delete
        frmMenu.brkrRPC.Param[1].PType := literal;
        frmMenu.brkrRPC.Param[2].Value := AddLaborIEN664_1;
        frmMenu.brkrRPC.Param[2].PType := literal;
        frmMenu.brkrRPC.Param[3].Value := AddLaborIEN664_2;
        frmMenu.brkrRPC.Param[3].PType := literal;
        frmMenu.brkrRPC.Param[4].Value := DateToStr(dtpOWLLaborDate.Date);
        frmMenu.brkrRPC.Param[4].PType := literal;
        frmMenu.brkrRPC.Param[5].Value := edtOWLLaborHours.Text;
        frmMenu.brkrRPC.Param[5].PType := literal;
        frmMenu.brkrRPC.Param[6].Value := FormatCurr('0.00',edtOWLLaborRate.Value);
        frmMenu.brkrRPC.Param[6].PType := literal;
        frmMenu.brkrRPC.Param[7].Value := edtOWLLaborTechnicianIEN.Text;
        frmMenu.brkrRPC.Param[7].PType := literal;
        frmMenu.brkrRPC.Param[8].Value := AddLaborIEN664_3;
        frmMenu.brkrRPC.Param[8].PType := literal;
        frmMenu.brkrRPC.Param[9].Value := AddLaborIEN664_33;
        frmMenu.brkrRPC.Param[9].PType := literal;


        frmMenu.brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?

    Try
    //
  frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;


 if frmMenu.brkrRPC.Results.Count > 0 then    // checks for null return
   begin
     if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then
      begin //b2
       MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
      end;
   end;

// If no tech assigned auto assign stuffs user DUZ as tech, refreshes OWL
  if frmOWL.grdOWLWorkOrders.Cells[4,frmOWL.grdOWLWorkOrders.Row] = '' then //not assigned yet
   begin
    OrgIEN664_1 := IEN664_1;
    if frmOwl.chkAssigned.Checked = false then
       ShowMessage('NOTICE: You are currently not viewing work orders with the Status of "ASSIGNED".'+#13+
                   ''+#13+
                   'Because this work order now has a Status of "ASSIGNED" it has been removed from the list.'+#13+
                   ''+#13+
                   'Check the Status "ASSIGNED" then click Refresh to continue with this Work Order.');
    frmOWL.btnDisplay.Click;

  //If ASSIGNED is cheked for display, finds record and selects
   for r := 1 to frmOWL.grdOWLWorkOrders.RowCount -1  do
     begin
       if frmOWL.grdOWLWorkOrders.Cells[12,r] = OrgIEN664_1 then
          frmOWL.grdOWLWorkOrders.Row := r;
     end;
    end
//****************
  else
   begin
    frmOWL.btnRefreshItemListGrid.Click;
    frmOWL.grdOWLItemList.Row := OWLItemListEditRowID; //Select current row after refersh

    frmOWL.btnRefreshLaborListGrid.Click;
    if LaborRecordFilingType <> 'D' then
      frmOWL.grdOWLLaborList.Row := OWLLaborListEditRowID;//Select current row after refersh
   end;

   Close;
      end;
     end;
    end;
   end;
  end;
 end;
end;


procedure TfrmOWLAddLabor.edtOWLLaborHoursExit(Sender: TObject);
begin
 if edtOWLLaborHours.Text = '' then edtOWLLaborHours.Text := '0.00';
 if StrToFloat(edtOWLLaborHours.Text) < 24 then
   begin
    if ((Piece(edtOWLLaborHours.Text,'.',2) <> '')
     and (Piece(edtOWLLaborHours.Text,'.',2) <> '25')
     and (Piece(edtOWLLaborHours.Text,'.',2) <> '5')
     and (Piece(edtOWLLaborHours.Text,'.',2) <> '75'))
    then
     begin
      ShowMessage('Please enter hours in 1/4 increments');
      edtOWLLaborHours.SetFocus;
     end;
    end
    else
     begin
      ShowMessage('Please enter less than 24 hours');
      edtOWLLaborHours.SetFocus;
     end;
 if edtOWLLaborHours.Text = '' then edtOWLLaborHours.Text := '0';
end;

procedure TfrmOWLAddLabor.cbxOWLLaborTechnicianExit(Sender: TObject);
begin
 if cbxOWLLaborTechnician.Text <> '' then
 begin
  if cbxOWLLaborTechnician.ItemIndex >= 0 then
   begin
    cbxOWLLaborTechnician.Perform(EM_SCROLLCARET,0,0);
    edtOWLLaborTechnicianIEN.Text := cbxOWLLaborTechnician.GetSelectedRecord.IEN;
   end
   else
    edtOWLLaborTechnicianIEN.Text := '';
  end;
end;

procedure TfrmOWLAddLabor.edtOWLLaborRateExit(Sender: TObject);
begin
 if ((edtOWLLaborRate.Value > 99999.99) or (edtOWLLaborRate.Value < 0)) then
  begin
  ShowMessage('Please enter a valid COST less than $99,999.99');
  edtOWLLaborRate.SetFocus;
  end;
 if edtOWLLaborRate.Text = '' then
    edtOWLLaborRate.Value := 0.00;
end;

procedure TfrmOWLAddLabor.edtOWLLaborRateEnter(Sender: TObject);
begin
edtOWLLaborRate.SelectAll;
end;

procedure TfrmOWLAddLabor.FormKeyPress(Sender: TObject; var Key: Char);
begin
if Key = #27 then Close;
end;

procedure TfrmOWLAddLabor.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Release;
end;

end.





