(*******************************************

Package: RMPR - RMPR*3*75 - OWL
Date Created: August 28, 2006
Site Name: Hines OI Field Office
Developers: Sam Spencer, Ken Nelson
Description: Orthotic Work order and Lab (OWL) program assign technician.

*******************************************)

unit uPROS_OWL_AssignTechnician;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Fmcntrls, Diaccess, Fmcmpnts, ESBDates;

type
  TfrmOWLAssignTechnician = class(TForm)
    dbsLister200: TFMLister;
    cbxOWLAssignTechnician: TFMComboBoxLookUp;
    edtOWLAssignTechnicianIEN: TFMEdit;
    btnOWLAssignTechnician: TBitBtn;
    btnClose: TBitBtn;
    edtOWLAssignTechnicianStatus: TFMEdit;
    edtOWLAssignTechnicianDate: TFMEdit;
    dbsFiler664_1: TFMFiler;
    dbsValidator664_1: TFMValidator;
    procedure cbxOWLAssignTechnicianExit(Sender: TObject);
    procedure cbxOWLAssignTechnicianSelect(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure btnOWLAssignTechnicianClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOWLAssignTechnician: TfrmOWLAssignTechnician;

implementation

uses Pros_Menu,uPROS_OWL;


{$R *.dfm}

procedure TfrmOWLAssignTechnician.cbxOWLAssignTechnicianExit(
  Sender: TObject);
begin
if cbxOWLAssignTechnician.Text <> '' then
 begin

   if cbxOWLAssignTechnician.ItemIndex >= 0 then
      begin
       cbxOWLAssignTechnician.Perform(EM_SCROLLCARET,0,0);// to set display Lft Just
       edtOWLAssignTechnicianIEN.Text := cbxOWLAssignTechnician.GetSelectedRecord.IEN;
      end;
  end
  else
  edtOWLAssignTechnicianIEN.Text := '';
end;

procedure TfrmOWLAssignTechnician.cbxOWLAssignTechnicianSelect(
  Sender: TObject);
begin
if cbxOWLAssignTechnician.ItemIndex >= 0 then
   begin
    cbxOWLAssignTechnician.Perform(EM_SCROLLCARET,0,0);// to set display Lft Just
    edtOWLAssignTechnicianIEN.Text := cbxOWLAssignTechnician.GetSelectedRecord.IEN;
   end;
end;

procedure TfrmOWLAssignTechnician.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Release;
end;

procedure TfrmOWLAssignTechnician.FormCreate(Sender: TObject);
var
d : TDateTime;
d1,d2,d3,d4 : string;         //Gets the user input from the calendar
begin
    edtOWLAssignTechnicianDate.Text := '';
    d := Now;
    
      if (Date2Year(d) < 1900) then  //Checks century
    d1 := '1';
      if (Date2Year(d) >= 1900) and
         (Date2Year(d) < 2000) then
    d1 := '2';
      if (Date2Year(d) >= 2000) then
    d1 := '3';

    d2 := Copy(IntToStr(Date2Year(d)),3,2); //Gets year

      if Date2Month(d) < 10 then //Pad month with 0 if needed
    d3:= '0'+ IntToStr(Date2Month(d))
       else
    d3 := IntToStr(Date2Month(d));

     if Date2Day(d) < 10 then  //Pad day with 0 if needed
    d4:= '0'+ IntToStr(Date2Day(d))
       else
    d4 := IntToStr(Date2Day(d));

edtOWLAssignTechnicianDate.Text := d1 + d2+ d3 + d4;
end;

procedure TfrmOWLAssignTechnician.btnOWLAssignTechnicianClick(
  Sender: TObject);
var
 r : integer;
 OrgIEN664_1 : String;
begin
   begin
    if (edtOWLAssignTechnicianIEN.Text = '') then
    MessageDlg('Please select a Technician',
      mtInformation, [mbOk],0)
   else
   begin
    if (edtOWLAssignTechnicianDate.Text = '') then
    MessageDlg('An error has occured obtaining the computer date',
    mtInformation, [mbOk],0)
   else

  begin
     dbsFiler664_1.AddFDA('664.1',IEN664_1,'15',edtOWLAssignTechnicianIEN.Text);  //Technician
     dbsFiler664_1.AddFDA('664.1',IEN664_1,'16',edtOWLAssignTechnicianStatus.Text);  //Status
     dbsFiler664_1.AddFDA('664.1',IEN664_1,'19',edtOWLAssignTechnicianDate.Text);  //Date
     dbsFiler664_1.AddFDA('664.1',IEN664_1,'27',UserDUZ);  //Assigned By - DUZ

  if not dbsFiler664_1.Update then
     dbsFiler664_1.DisplayErrors
   else
   OrgIEN664_1 := IEN664_1;
//   frmOWL.btnClear.Click; //Clear the OWL grid first
   frmOWL.btnDisplay.Click;


//If ASSIGNED is NOT cheked for display
    if frmOwl.chkAssigned.Checked = false then
       ShowMessage('NOTICE: You are currently not viewing work orders with the Status of "ASSIGNED".'+#13+
                   ''+#13+
                   'Because this work order now has a Status of "ASSIGNED" it has been removed from the list.'+#13+
                   ''+#13+
                   'Check the Status "ASSIGNED" then click Refresh to continue with this Work Order.');

//If ASSIGNED is cheked for display, finds record and selects
   for r := 1 to frmOWL.grdOWLWorkOrders.RowCount -1  do
     begin
       if frmOWL.grdOWLWorkOrders.Cells[12,r] = OrgIEN664_1 then
          frmOWL.grdOWLWorkOrders.Row := r;
     end;

//   frmOWL.grdOWLWorkOrders.Row := OWLEditRowID; //Return to old edit row

   frmOWL.btnClearItemListGrid.Click; //Clear HCPCS grid
   frmOWL.btnRefreshItemListGrid.Click;

   frmOWL.btnClearMaterialListGrid.Click; //Clear Material grid
   frmOWL.btnRefreshMaterialListGrid.Click;

   frmOWL.btnClearLaborListGrid.Click; //Clear Labor grid
   frmOWL.btnRefreshLaborListGrid.Click;

   Close;
   end;
  end;
 end;
end;

procedure TfrmOWLAssignTechnician.btnCloseClick(Sender: TObject);
begin
if MessageDlg('Any changes will be discarded.',
    mtInformation, [mbOk], 0) = mrOk then
Close;
end;

end.
