(*******************************************

Package: RMPR - RMPR*3*75 - OWL
Date Created: August 28, 2006
Site Name: Hines OI Field Office
Developers: Sam Spencer, Ken Nelson
Description: Orthotic Work order and Lab (OWL) program detail display.

*******************************************)

unit uPROS_OWL_WorkOrderDetail;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Fmcntrls, ComCtrls, ExtCtrls, MyGrids, SortGrid,
  Buttons, Trpcb, MFunstr;

type
  TfrmOWLWorkOrderDetail = class(TForm)
    lblWorkOrderNumber: TFMLabel;
    edtDate: TFMEdit;
    edtOWLTechnician: TFMEdit;
    edtOWLNPPDStation: TFMEdit;
    edtOWLReceivingStation: TFMEdit;
    edtOWLRequestingStation: TFMEdit;
    lblPatientName: TFMLabel;
    lblPatientSSN: TFMLabel;
    lblWorkOrderNumberData: TFMLabel;
    lblPatientNameData: TFMLabel;
    lblPatientSSNData: TFMLabel;
    lblDateOwlCreated: TFMLabel;
    lblTechnician: TFMLabel;
    lblNPPDStation: TFMLabel;
    lblReceivingStation: TFMLabel;
    lblRequestingStation: TFMLabel;
    stsbrWorkOrderDetail: TStatusBar;
    edtOWLSourceOfProcurment: TFMEdit;
    edtOWLEligibility: TFMEdit;
    edtOWLPhysicianExtension: TFMEdit;
    lblSourceOfProcurment: TFMLabel;
    edtOWLWardLocation: TFMEdit;
    edtOWLPhysician: TFMEdit;
    edtOWLDiagnosis: TFMEdit;
    edtOWLTreatingSpeciality: TFMEdit;
    lblWardLocation: TFMLabel;
    lblPhysician: TFMLabel;
    rgrpOWLEligibility: TFMRadioGroup;
    grdMiniDis: TSortGrid;
    rgrpOWLTransactionType: TFMRadioGroup;
    lblDiagnosis: TFMLabel;
    lblTreatingSpeciality: TFMLabel;
    lblPhysicianExtention: TFMLabel;
    edtOWLRequestingOfficial: TFMEdit;
    edtOWLRequestorDate: TFMEdit;
    edtOWLApprovingOffcial: TFMEdit;
    edtOWLApprovalDate: TFMEdit;
    edtOWLDateAssigned: TFMEdit;
    edtOWLDateDelivered: TFMEdit;
    edtOWLInspectingOfficial: TFMEdit;
    lblRequestingOfficial: TFMLabel;
    lblApprovingOfficial: TFMLabel;
    lblRequestorDate: TFMLabel;
    lblApprovalDate: TFMLabel;
    edtOWLCompletedBy: TFMEdit;
    edtOWLCLoseOutDate: TFMEdit;
    lblDateAssigned: TFMLabel;
    lblDateDelivered: TFMLabel;
    lblInspectingOfficial: TFMLabel;
    lblCompletedBy: TFMLabel;
    lblCloseOutDate: TFMLabel;
    pnlCancel: TPanel;
    lblOWLCancelledBY: TFMLabel;
    edtOWLCancelledBy: TFMEdit;
    lblCancelledDate: TFMLabel;
    btnCancelledRemarks: TBitBtn;
    edtOWLCancelledDate: TFMEdit;
    edtOWLDateRequired: TFMEdit;
    lbOWLDateRequired: TFMLabel;
    edtOWLTransactionType: TFMEdit;
    edtOWLStatus: TFMEdit;
    lblWorkOrderStatus: TFMLabel;
    btnClose: TBitBtn;
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmOWLWorkOrderDetail: TfrmOWLWorkOrderDetail;

implementation

uses uPROS_OWL, Pros_Menu;

{$R *.dfm}

procedure TfrmOWLWorkOrderDetail.FormShow(Sender: TObject);
begin
  lblWorkOrderNumberData.Caption := frmOWL.grdOWLWorkOrders.Cells[0,frmOWL.grdOWLWorkOrders.Row];
  frmOWL.dbsGets664_1.IENS := IEN664_1;
  frmOWL.dbsGets664_1.GetData;
//    frmOWL.dbGets664_1.GetAndFill;
 lblPatientNameData.Caption := frmOWL.dbsGets664_1.GetField('.02').FMDBExternal;//Patient;
  lblPatientSSNData.Caption :=  OWLPatientSSN;

               edtDate.Text := frmOWL.dbsGets664_1.GetField('.01').FMDBExternal;//Date
//     edtOWLPatientName.Text := frmOWL.dbGets664_1.GetField('.02').FMDBExternal;//Patient
        edtOWLNPPDStation.Text := frmOWL.dbsGets664_1.GetField('.03').FMDBExternal;//Station
  edtOWLRequestingStation.Text := frmOWL.dbsGets664_1.GetField('.04').FMDBExternal;//Req Station
//     edtOWLPatientName.Text := frmOWL.dbGets664_1.GetField('.05').FMDBExternal;//IEN 668

       edtOWLEligibility.Text := frmOWL.dbsGets664_1.GetField('.06').FMDBInternal;//Eligibility
       if edtOWLEligibility.Text = '2' then
          rgrpOWLEligibility.ItemIndex := 0;
       if edtOWLEligibility.Text = '3' then
          rgrpOWLEligibility.ItemIndex := 1;

//  edtRequestingStation.Text := frmOWL.dbGets664_1.GetField('.07').FMDBExternal;//Spec Catgry
   edtOWLDateRequired.Text := frmOWL.dbsGets664_1.GetField('.09').FMDBExternal;//Date Req
   edtOWLReceivingStation.Text := frmOWL.dbsGets664_1.GetField('.11').FMDBExternal;//Recv Station

    edtOWLTransactionType.Text := frmOWL.dbsGets664_1.GetField('1').FMDBInternal;//Transaction Type
       if edtOWLTransactionType.Text = 'I' then
          rgrpOWLTransactionType.ItemIndex := 0;
       if edtOWLTransactionType.Text = 'X' then
          rgrpOWLTransactionType.ItemIndex := 1;



 edtOWLSourceOfProcurment.Text := frmOWL.dbsGets664_1.GetField('2').FMDBExternal;//Source of Procurment
//     edtRequestingStation.Text := frmOWL.dbGets664_1.GetField('4').FMDBExternal;//Work Order Number

        edtOWLCancelledBy.Text := frmOWL.dbsGets664_1.GetField('7').FMDBExternal;//Cancelled By
      edtOWLCancelledDate.Text := frmOWL.dbsGets664_1.GetField('8').FMDBExternal;//Cancelled Date
//        edtOWLReturnedBy.Text := frmOWL.dbGets664_1.GetField('9').FMDBExternal;//Returned By
//      edtOWLReturnedDate.Text := frmOWL.dbGets664_1.GetField('10').FMDBExternal;//Return Date
//     edtReceivingStation.Text := frmOWL.dbGets664_1.GetField('').FMDBExternal;
       edtOWLWardLocation.Text := frmOWL.dbsGets664_1.GetField('12').FMDBExternal;//Ward Location
          edtOWLPhysician.Text := frmOWL.dbsGets664_1.GetField('12.1').FMDBExternal;//Physician
          edtOWLDiagnosis.Text := frmOWL.dbsGets664_1.GetField('12.2').FMDBExternal;//Diagnosis
 edtOWLTreatingSpeciality.Text := frmOWL.dbsGets664_1.GetField('12.3').FMDBExternal;//Treating Spclty
 edtOWLPhysicianExtension.Text := frmOWL.dbsGets664_1.GetField('12.4').FMDBExternal;//Phys Extension
 edtOWLrequestingOfficial.Text := frmOWL.dbsGets664_1.GetField('13').FMDBExternal;//Req Official
   edtOWLApprovingOffcial.Text := frmOWL.dbsGets664_1.GetField('14').FMDBExternal;//Apprv Oficial
         edtOWLTechnician.Text := frmOWL.dbsGets664_1.GetField('15').FMDBExternal;//Technician
             edtOWLStatus.Text := frmOWL.dbsGets664_1.GetField('16').FMDBExternal;//Status
      edtOWLRequestorDate.Text := frmOWL.dbsGets664_1.GetField('17').FMDBExternal;//Requestor Date
       edtOWLApprovalDate.Text := frmOWL.dbsGets664_1.GetField('18').FMDBExternal;//Apprv Date
       edtOWLDateAssigned.Text := frmOWL.dbsGets664_1.GetField('19').FMDBExternal;//Date Assigned
      edtOWLDateDelivered.Text := frmOWL.dbsGets664_1.GetField('20').FMDBExternal;//Date Delivered
 edtOWLInspectingOfficial.Text := frmOWL.dbsGets664_1.GetField('21').FMDBExternal;//Inspecting Offcl
        edtOWLCompletedBy.Text := frmOWL.dbsGets664_1.GetField('22').FMDBExternal;//Completed By
       edtOWLCloseOutDate.Text := frmOWL.dbsGets664_1.GetField('23').FMDBExternal;//Close-Out Date
//     edtRequestingStation.Text := frmOWL.dbGets664_1.GetField('24').FMDBExternal;//Delivery Status
//      edtReceivingStation.Text := frmOWL.dbGets664_1.GetField('25').FMDBExternal;//Tot Material Cost
//        edtOWLPatientName.Text := frmOWL.dbGets664_1.GetField('26').FMDBExternal;//Tot Cost
//           edtNPPDStation.Text := frmOWL.dbGets664_1.GetField('27').FMDBExternal;//Assigned By
//     edtRequestingStation.Text := frmOWL.dbGets664_1.GetField('28').FMDBExternal;//No Admin Count

//      edtReceivingStation.Text := frmOWL.dbGets664_1.GetField('30').FMDBExternal;//Job # Count
//        edtOWLPatientName.Text := frmOWL.dbGets664_1.GetField('31').FMDBExternal;//AMIS Grouper
//           edtNPPDStation.Text := frmOWL.dbGets664_1.GetField('32').FMDBExternal;//No Job Count
//     edtRequestingStation.Text := frmOWL.dbGets664_1.GetField('33').FMDBExternal;//Date Item Rec
//      edtReceivingStation.Text := frmOWL.dbGets664_1.GetField('34').FMDBExternal;//No Count Work Order

end;

procedure TfrmOWLWorkOrderDetail.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Release;
end;

procedure TfrmOWLWorkOrderDetail.FormActivate(Sender: TObject);
var
 i : integer;
begin

with grdMiniDis do       // Grid header
  begin
      Cells[0,0] := 'Disability';
      Cells[1,0] := ' %';
      Cells[2,0] := 'SC';
 end;

begin
   TRY
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR DIS LIST';
    frmMenu.brkrRPC.Param[0].Value := OWL_IEN668;
    frmMenu.brkrRPC.Param[0].PType := literal;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;


 grdMiniDis.RowCount := frmMenu.brkrRPC.Results.Count +1;//Sizes grid to match results

 for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do  //Tab 4
   begin
    with grdMiniDis do
      begin
         Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);//Disab
         Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);//% Disab
         Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);// SC YES/NO

      end; // with do
    end;
   Except
  end;//Try
 end;
end;

procedure TfrmOWLWorkOrderDetail.btnCloseClick(Sender: TObject);
begin
Close;
end;

end.
