unit uPROS_PatientLookup;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Rpcconf1, MFunStr, Trpcb, Buttons, Fmcntrls,
  Diaccess, Fmcmpnts, ComCtrls, Grids, VA508AccessibilityManager;

type
  TfrmPatientLookup = class(TForm)
    edtSearchString: TEdit;
    edtDFN: TEdit;
    btnSearch: TBitBtn;
    grdSelectPatient: TStringGrid;
    btnSelectPatient: TBitBtn;
    btnClearList: TBitBtn;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    VA508ComponentAccessibility1: TVA508ComponentAccessibility;
    btnCancel: TBitBtn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnSearchClick(Sender: TObject);
    procedure ListView1Click(Sender: TObject);
    procedure ListView1SelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure ListView1Change(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure grdSelectPatientClick(Sender: TObject);
    procedure btnSelectPatientClick(Sender: TObject);
    procedure edtSearchStringKeyPress(Sender: TObject; var Key: Char);
    procedure btnClearListClick(Sender: TObject);
    procedure grdSelectPatientKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    { Private declarations }
    procedure PatientSearch;

  public
    { Public declarations }
  end;

var
  frmPatientLookup: TfrmPatientLookup;

implementation

uses
 PROS_Menu
 ,PROS_POC_PurOrderConsult;

{$R *.dfm}

procedure TfrmPatientLookup.PatientSearch;
var
 i : integer;
begin
 if length(edtSearchString.Text) > 1 then
  begin
  btnClearList.Click;

  frmMenu.brkrRPC.CreateContext('RMPR PURCHASE ORDER GUI');
  frmMenu.brkrRPC.RemoteProcedure := 'RMPR PATIENT LOOKUP';//'RMPR USER LOOKUP';
  frmMenu.brkrRPC.Param[0].Value := edtSearchString.Text;
  frmMenu.brkrRPC.Param[0].PType := literal;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

    if frmMenu.brkrRPC.Results.Count > 0 then
        grdSelectPatient.RowCount := frmMenu.brkrRPC.Results.Count +1;

    for i:= 0 to frmMenu.brkrRPC.Results.Count -1  do  //Tab 4


    with grdSelectPatient do
    begin
      Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);
      Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4);
      Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',5);
      Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);
    end;

    grdSelectPatient.SetFocus;
    edtDFN.text := grdSelectPatient.cells[3,grdSelectPatient.Row];  //Sets first DFN
   end
  else
   ShowMessage('Please enter at least 2 characters.');
end;

procedure TfrmPatientLookup.btnSearchClick(Sender: TObject);
begin
PatientSearch;
end;


procedure TfrmPatientLookup.btnSelectPatientClick(Sender: TObject);
begin
PatLookupIEN := edtDFN.Text;

if PatLookupIEN <>'' then
 begin
 frmSuspenseProcessing.btnSinglePatient.Click;
 Close;
 end
else
 ShowMessage('An ERROR has occured - No Patient has been selected.');
end;

procedure TfrmPatientLookup.btnCancelClick(Sender: TObject);
begin
Close;
end;

procedure TfrmPatientLookup.btnClearListClick(Sender: TObject);
var
  i : integer;
begin
  begin
   for i :=1 to grdSelectPatient.RowCount -1 do   //If selected will clear the grid
       grdSelectPatient.Rows[i].Clear;
       grdSelectPatient.Row := 1;
       grdSelectPatient.Cells[0,1] :='';
  end;
 edtDFN.text := '';
end;

procedure TfrmPatientLookup.edtSearchStringKeyPress(Sender: TObject;
  var Key: Char);
begin
 if Key = char(VK_RETURN)
    then PatientSearch;
end;


procedure TfrmPatientLookup.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
release;
end;

procedure TfrmPatientLookup.FormCreate(Sender: TObject);
begin

with grdSelectPatient do               // Sets column headers
 begin
      Cells[0,0] := 'Name';
        ColWidths[0] := 270;

      Cells[1,0] := 'SSN';
        ColWidths[1] := 100;

      Cells[2,0] := 'D.O.B';
        ColWidths[2] := 75;

      Cells[3,0] := 'Pt DFN';
        ColWidths[3] := -1;


 end;
end;


procedure TfrmPatientLookup.ListView1Change(Sender: TObject; Item: TListItem;
  Change: TItemChange);
begin
//edit1.Text := listview1.Selected.SubItems[2];
end;

procedure TfrmPatientLookup.ListView1Click(Sender: TObject);
begin
//edit1.Text := listview1.Selected.SubItems[2];
end;

procedure TfrmPatientLookup.ListView1SelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
// edit1.Text := listview1.Selected.SubItems[2];
end;

procedure TfrmPatientLookup.grdSelectPatientClick(Sender: TObject);
begin
edtDFN.text := grdSelectPatient.cells[3,grdSelectPatient.Row];
end;

procedure TfrmPatientLookup.grdSelectPatientKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = char(VK_RETURN)
  then btnSelectPatient.Click;

  if Key = char(VK_Escape) then
  begin
  btnClearList.Click;
  edtSearchString.SetFocus;
  edtSearchString.SelStart := Length(edtSearchString.Text); // set caret after the last character
  end;

  if Key = char(VK_Back) then
  begin
  edtSearchString.SetFocus;
  edtSearchString.SelStart := length(edtSearchString.Text); // set caret after the last character
  edtSearchString.Perform(WM_CHAR, VK_BACK, 1);

  end;
end;

end.
