unit uPROS_InventoryIssueScanBarcode;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, CurrEdit, StrUtils, Fmcntrls, ExtCtrls, Trpcb, MFunStr,
  NumEdit, ProsUtils, Buttons, ESBDates;

type
  TfrmInventoryIssueScanBarcode = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    Label7: TLabel;
    Label9: TLabel;
    edtItemNumber: TEdit;
    edtVendor: TEdit;
    edtStoreRoom: TEdit;
    edtBarCodeHCPCS: TEdit;
    edtSource: TEdit;
    edtStationNumber: TEdit;
    edtDateOfReceipt: TEdit;
    edtItemDescription: TEdit;
    edtBarCodeItemCost: TCurrencyEdit;
    edtExpirationDate: TEdit;
    edtHCPCSVersionDate: TEdit;
    edtExternalLotID: TEdit;
    edtContractNumber: TEdit;
    edtBarcodeData: TEdit;
    edtHCPCSVersionDateDisplay: TEdit;
    edtVendorIEN: TEdit;
    btnScanBarcodeNOk: TBitBtn;
    btnScanBarcodeOk: TBitBtn;
    Panel1: TPanel;
    lblPatientName: TLabel;
    lblPatientSSN: TLabel;
    edtExpirationDateDisplay: TEdit;
    edtDateOfReceiptDisplay: TEdit;
    edtIssuedHCPCSIEN: TEdit;
    btnReadBarCode1: TBitBtn;
    btnReadBarCode2: TBitBtn;
    btnReadBarCode3: TBitBtn;
    btnReadBarCode4: TBitBtn;
    btnReadBarCode5: TBitBtn;
    btnReadCarCode6: TBitBtn;
    btnCancel: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    procedure edtBarcodeDataKeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnScanBarcodeNOkClick(Sender: TObject);
    procedure btnScanBarcodeOkClick(Sender: TObject);
    procedure btnReadBarCode1Click(Sender: TObject);
    procedure edtBarcodeDataChange(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure btnReadBarCode2Click(Sender: TObject);
    procedure btnReadBarCode3Click(Sender: TObject);
    procedure btnReadBarCode4Click(Sender: TObject);
    procedure btnReadBarCode5Click(Sender: TObject);
    procedure btnReadCarCode6Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure BitBtn7Click(Sender: TObject);
  private
    { Private declarations }
    procedure BarcodeDataCheck;

  public
    { Public declarations }
  end;

var
  frmInventoryIssueScanBarcode: TfrmInventoryIssueScanBarcode;

implementation
uses
   PROS_Menu
  ,PROS_POC_PurOrderConsult, uPROS_InventoryIssue;

{$R *.dfm}

procedure TfrmInventoryIssueScanBarcode.BarcodeDataCheck;

 begin
    frmMenu.brkrRPC.RemoteProcedure := 'RMPR INV BARCODE DATA CHECK';
    frmMenu.brkrRPC.Param[1].Value := edtBarCodeHCPCS.Text;
    frmMenu.brkrRPC.Param[1].Ptype := literal;
    frmMenu.brkrRPC.Param[2].Value := edtHCPCSVersionDate.Text;
    frmMenu.brkrRPC.Param[2].Ptype := literal;
    frmMenu.brkrRPC.Param[3].Value := edtStationNumber.Text;
    frmMenu.brkrRPC.Param[3].Ptype := literal;

  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
  End;

        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
           begin
          // Application.CreateForm(TfrmSelHCPCS, frmSelHCPCS);
          // frmSelHCPCS.lblHCPCSErrorMsg.Caption := Piece(frmMenu.brkrRPC.Results[0],'^',2);
//           frmSelHCPCS.ShowModal;
            MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);
            btnScanBarcodeNOk.SetFocus;
           end;

        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then  //Ok
           begin
            edtIssuedHCPCSIEN.Text := Piece(frmMenu.brkrRPC.Results[0],'^',2);
            frmInventoryIssue.edtIssuedHCPCSIEN.Text := edtIssuedHCPCSIEN.Text; //From RPC - BC Data Check
            frmInventoryIssue.ShowModal; //show Inventory Issue window only if check ok
            frmInventoryIssueScanBarcode.Close;  //no longer needed
           end;

end;


procedure TfrmInventoryIssueScanBarcode.btnCancelClick(Sender: TObject);
begin
frmInventoryIssue.Close;
Close;
end;

procedure TfrmInventoryIssueScanBarcode.BitBtn2Click(Sender: TObject);
var
 s: string;
begin

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

   btnScanBarcodeOk.Enabled := false;
   btnScanBarcodeNOk.Enabled := false;

   edtBarcodeData.Enabled := true;
   edtBarcodeData.Text := '';
   s := '|50023|CRUTCHES,CANE TYPE,CHROME/STL,ADULT,FOREARM,CUSHION GRIPS|PROS|201007200847|E0111|20100707|INVACARE|695|VA797P-0147|C|19.01|A5|20101231|';

  edtBarcodeData.Text := s;
  panel1.Caption := 'Press ENTER to see data . . .';

    edtBarcodeData.SetFocus;

end;


procedure TfrmInventoryIssueScanBarcode.BitBtn3Click(Sender: TObject);
var
 s: string;
begin

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

   btnScanBarcodeOk.Enabled := false;
   btnScanBarcodeNOk.Enabled := false;

   edtBarcodeData.Enabled := true;
   edtBarcodeData.Text := '';
   s := '|50024|WALKER,FOLDING,ADJ HT,DUAL RELEASE PADDLE,ALUMINUM,ADULT|PROS|201007200847|E0135|20100707|INVACARE|695|VA797P-0147|C|23.84|A6|20101231|';

  edtBarcodeData.Text := s;
  panel1.Caption := 'Press ENTER to see data . . .';

    edtBarcodeData.SetFocus;

end;


procedure TfrmInventoryIssueScanBarcode.BitBtn4Click(Sender: TObject);
var
 s: string;
begin

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

   btnScanBarcodeOk.Enabled := false;
   btnScanBarcodeNOk.Enabled := false;

   edtBarcodeData.Enabled := true;
   edtBarcodeData.Text := '';
   s := '|50001|SLEEVE,ELBOW,PULL-ON,MED,INNER PAD,BILAT,BEIGE|PROS|201007200847|A4466|20100707|DEROYAL|695||C|9.56|||';

  edtBarcodeData.Text := s;
  panel1.Caption := 'Press ENTER to see data . . .';

    edtBarcodeData.SetFocus;

end;


procedure TfrmInventoryIssueScanBarcode.BitBtn5Click(Sender: TObject);
var
 s: string;
begin

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

   btnScanBarcodeOk.Enabled := false;
   btnScanBarcodeNOk.Enabled := false;

   edtBarcodeData.Enabled := true;
   edtBarcodeData.Text := '';
   s := '|50013|SHOEHORN,ASSISTIVE,24IN,VINYL HANDLE,SS,CVD HOOK|PROS|201007200847|DL186|20100707|NORTH COAST MEDICAL|695||C|6.65|A1|20101231|';

  edtBarcodeData.Text := s;
  panel1.Caption := 'Press ENTER to see data . . .';

    edtBarcodeData.SetFocus;

end;


procedure TfrmInventoryIssueScanBarcode.BitBtn6Click(Sender: TObject);
var
 s: string;
begin

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

   btnScanBarcodeOk.Enabled := false;
   btnScanBarcodeNOk.Enabled := false;

   edtBarcodeData.Enabled := true;
   edtBarcodeData.Text := '';
   s := '|50034|TENS UNIT,DUAL CHANNEL,ADJ PULSE RATE,3 MODES,ANALOG|PROS|201007200847|E0730|20100707|PAIN MANAGEMENT TECHNOLOGIES|695||C|24.68|||';

  edtBarcodeData.Text := s;
  panel1.Caption := 'Press ENTER to see data . . .';

    edtBarcodeData.SetFocus;

end;


procedure TfrmInventoryIssueScanBarcode.BitBtn7Click(Sender: TObject);
var
 s: string;
begin

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

   btnScanBarcodeOk.Enabled := false;
   btnScanBarcodeNOk.Enabled := false;

   edtBarcodeData.Enabled := true;
   edtBarcodeData.Text := '';
   s := '|50034|TENS UNIT,DUAL CHANNEL,ADJ PULSE RATE,3 MODES,ANALOG|PROS|201007200847|E0730|20100707|PAIN MANAGEMENT TECHNOLOGIES|695||C|24.68|||';

  edtBarcodeData.Text := s;
  panel1.Caption := 'Press ENTER to see data . . .';

    edtBarcodeData.SetFocus;

end;


procedure TfrmInventoryIssueScanBarcode.btnReadBarCode1Click(Sender: TObject);
var
 s: string;
begin

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

   btnScanBarcodeOk.Enabled := false;
   btnScanBarcodeNOk.Enabled := false;

   edtBarcodeData.Enabled := true;
   edtBarcodeData.Text := '';
   s := '|123456789|Wheelchair - Standard|B16R212|200910311313|K0001|20100707|Acme Labs|552|10-2383|C|5.99|B56355|20100401||';

  edtBarcodeData.Text := s;
  panel1.Caption := 'Press ENTER to see data . . .';

    edtBarcodeData.SetFocus;

end;

procedure TfrmInventoryIssueScanBarcode.btnReadBarCode2Click(Sender: TObject);
var
 s: string;
begin

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

   btnScanBarcodeOk.Enabled := false;
   btnScanBarcodeNOk.Enabled := false;

   edtBarcodeData.Enabled := true;
   edtBarcodeData.Text := '';
   s := '|4564923789|Clock/Watches - Braille/Talking|B16R212|200902141045|BA200|20100707|Invacare|552|0011920|C|24.55|D3422||';



  edtBarcodeData.Text := s;
  panel1.Caption := 'Press ENTER to see data . . .';

    edtBarcodeData.SetFocus;

end;

procedure TfrmInventoryIssueScanBarcode.btnReadBarCode3Click(Sender: TObject);
var
 s: string;
begin

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

   btnScanBarcodeOk.Enabled := false;
   btnScanBarcodeNOk.Enabled := false;

   edtBarcodeData.Enabled := true;
   edtBarcodeData.Text := '';
   s := '|5578388|Cane Adjust/Fixed with tip|B16R212|201001120805|E0100|20100707|Baxter Hospital Supply|552||C|14.25|B83422|20121226|';


  edtBarcodeData.Text := s;
  panel1.Caption := 'Press ENTER to see data . . .';

    edtBarcodeData.SetFocus;

end;

procedure TfrmInventoryIssueScanBarcode.btnReadBarCode4Click(Sender: TObject);
var
 s: string;
begin

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

   btnScanBarcodeOk.Enabled := false;
   btnScanBarcodeNOk.Enabled := false;

   edtBarcodeData.Enabled := true;
   edtBarcodeData.Text := '';
   s := '|58733622|Tray, W/C|B16R212|201002110847|E0950|20100707|Everest and Jennings|552|09-433VA33|C|39.00|F438||';



  edtBarcodeData.Text := s;
  panel1.Caption := 'Press ENTER to see data . . .';

    edtBarcodeData.SetFocus;

end;

procedure TfrmInventoryIssueScanBarcode.btnReadBarCode5Click(Sender: TObject);
var
 s: string;
begin

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

   btnScanBarcodeOk.Enabled := false;
   btnScanBarcodeNOk.Enabled := false;

   edtBarcodeData.Enabled := true;
   edtBarcodeData.Text := '';
   s := '|1899452|Eye Patch Occlusive|B16R212|201002010858|A6412|20100707|Abbott Labs|552|67299|C|2.25|B276||';


  edtBarcodeData.Text := s;
  panel1.Caption := 'Press ENTER to see data . . .';

    edtBarcodeData.SetFocus;

end;

procedure TfrmInventoryIssueScanBarcode.btnReadCarCode6Click(Sender: TObject);
var
 s: string;
begin

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

   btnScanBarcodeOk.Enabled := false;
   btnScanBarcodeNOk.Enabled := false;

   edtBarcodeData.Enabled := true;
   edtBarcodeData.Text := '';
   s := '|757873388|Stump Sock Single Below Knee|B16R212|201002110847|L8470|20100707|DePuy|552||C|9.50|H7823|20141031|';



  edtBarcodeData.Text := s;
  panel1.Caption := 'Press ENTER to see data . . .';

    edtBarcodeData.SetFocus;

end;

procedure TfrmInventoryIssueScanBarcode.btnScanBarcodeNOkClick(Sender: TObject);
begin
       btnScanBarcodeOk.Enabled := false;
       btnScanBarcodeNOk.Enabled := false;
       panel1.Caption := 'Scan Barcode Now . . .';

             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

edtBarcodeData.Enabled := true;
edtBarcodeData.SetFocus;

end;

procedure TfrmInventoryIssueScanBarcode.btnScanBarcodeOkClick(Sender: TObject);
begin

 begin //load data before showing Inventory Issue window

             frmInventoryIssue.edtItemNumber.Text := edtItemNumber.Text;
        frmInventoryIssue.edtItemDescription.Text := edtItemDescription.Text;
              frmInventoryIssue.edtStoreroom.Text := edtStoreroom.Text;

          frmInventoryIssue.edtDateOfReceipt.Text := edtDateOfReceipt.Text;
   frmInventoryIssue.edtDateOfReceiptDisplay.Text := edtDateOfReceiptDisplay.Text;

           frmInventoryIssue.edtBarCodeHCPCS.Text := edtBarCodeHCPCS.Text;
            frmInventoryIssue.edtIssuedHCPCS.Text := edtBarCodeHCPCS.Text;  //Using the same for now


        frmInventoryIssue.edtHCPCSVersionDate.Text := edtHCPCSVersionDate.Text;
 frmInventoryIssue.edtHCPCSVersionDateDisplay.Text := edtHCPCSVersionDateDisplay.Text;

                 frmInventoryIssue.edtVendor.Text := edtVendor.Text;
          frmInventoryIssue.edtStationNumber.Text := edtStationNumber.Text;
         frmInventoryIssue.edtContractNumber.Text := edtContractNumber.Text;
                 frmInventoryIssue.edtSource.Text := edtSource.Text;
       frmInventoryIssue.edtBarCodeItemCost.Value := edtBarCodeItemCost.Value;
             frmInventoryIssue.edtTotalCost.Value := edtBarCodeItemCost.Value;
          frmInventoryIssue.edtExternalLotID.Text := edtExternalLotID.Text;

         frmInventoryIssue.edtExpirationDate.Text := edtExpirationDate.Text;
  frmInventoryIssue.edtExpirationDateDisplay.Text := edtExpirationDateDisplay.Text;

 end;

   begin
    if edtExpirationDate.text <> '' then
      begin
       if DaysApart(StrToDate(edtExpirationDateDisplay.Text),Now) > 0 then
        begin
         if Dialogs.MessageDlg('The Expiration Date for this item has passed. Continue?',
         mtWarning, [mbYes, mbNo], 0, mbNo) = mrYes then
         BarcodeDataCheck;
        end
        else
         BarcodeDataCheck; //Expr date ok
     end
    else
    BarcodeDataCheck; // No expr date on barcode
   end;
end;

procedure TfrmInventoryIssueScanBarcode.edtBarcodeDataChange(Sender: TObject);
begin
//  edtBarcodeData.SetFocus;
//  edtBarcodeData.perform(wm_keydown,vk_return,0);
//  edtBarcodeData.perform(wm_keyup,vk_return,0);
//  btnReadBarCode1.SetFocus;
end;

procedure TfrmInventoryIssueScanBarcode.edtBarcodeDataKeyPress(Sender: TObject;
  var Key: Char);
begin
             edtItemNumber.Text := '';
        edtItemDescription.Text := '';
              edtStoreroom.Text := '';
          edtDateOfReceipt.Text := '';
   edtDateOfReceiptDisplay.Text := '';
           edtBarCodeHCPCS.Text := '';
        edtHCPCSVersionDate.Text := '';
 edtHCPCSVersionDateDisplay.Text := '';
                 edtVendor.Text := '';
          edtStationNumber.Text := '';
         edtContractNumber.Text := '';
                 edtSource.Text := '';
       edtBarCodeItemCost.Value := 0.00;
          edtExternalLotID.Text := '';
         edtExpirationDate.Text := '';
  edtExpirationDateDisplay.Text := '';

if Key = #13  then
 begin
  if edtBarcodeData.Text <> '' then
   begin
     if copy(edtBarcodeData.Text,0,1) = '|' then
      begin
             edtItemNumber.Text := piece(edtBarcodeData.Text,'|',2);
        edtItemDescription.Text := piece(edtBarcodeData.Text,'|',3);
              edtStoreroom.Text := piece(edtBarcodeData.Text,'|',4);

          edtDateOfReceipt.Text := piece(edtBarcodeData.Text,'|',5);
   edtDateOfReceiptDisplay.Text := DateTimeStr2StrDateTime(edtDateOfReceipt.Text);

           edtBarCodeHCPCS.Text := piece(edtBarcodeData.Text,'|',6);

        edtHCPCSVersionDate.Text := piece(edtBarcodeData.Text,'|',7);
 edtHCPCSVersionDateDisplay.Text := DateStr2StrDate(edtHCPCSVersionDate.Text);

                 edtVendor.Text := piece(edtBarcodeData.Text,'|',8);
          edtStationNumber.Text := piece(edtBarcodeData.Text,'|',9);
         edtContractNumber.Text := piece(edtBarcodeData.Text,'|',10);
                 edtSource.Text := piece(edtBarcodeData.Text,'|',11);

      try
       edtBarCodeItemCost.Value := StrToFloat(piece(edtBarcodeData.Text,'|',12));
      except
        on Exception : EConvertError do
        begin
         ShowMessage ('Not a valid barcode.');
        end;
       end;

          edtExternalLotID.Text := piece(edtBarcodeData.Text,'|',13);

         edtExpirationDate.Text := piece(edtBarcodeData.Text,'|',14);
  edtExpirationDateDisplay.Text := DateStr2StrDate(edtExpirationDate.Text);

      edtBarcodeData.Clear;
      edtBarcodeData.Enabled := false;
      begin

      end;

      panel1.Caption := 'Is the Barcode Correct?';
      btnScanBarcodeNOk.Enabled := true;
      btnScanBarcodeOk.Enabled := true;
      btnScanBarcodeNOk.SetFocus;
      end
    else
      begin
      ShowMessage('Not a valid barcode . . . Try Again');
      edtBarcodeData.Clear;
      panel1.Caption := 'Scan Barcode Now . . .';
      edtBarcodeData.Enabled := True;
      edtBarcodeData.SetFocus;
//      edtBarcodeData.SetFocus;
      end;
     end;




 end;
//      edtBarcodeData.Clear;
//      edtBarcodeData.Enabled := false;
//      btnScanBarcode.Caption := 'Scan NEW Barcode';
//      btnScanBarcode.SetFocus;

end;


procedure TfrmInventoryIssueScanBarcode.FormClose(Sender: TObject; var Action: TCloseAction);
begin
release;
end;

end.
