unit uPROS_SelectHCPCS;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, Rpcconf1, Trpcb, MFunStr, Buttons;

type
  TfrmSelHCPCS = class(TForm)
    lblHCPCSTopMessage: TLabel;
    lblHCPCSErrorMsg: TLabel;
    lblSelectHCPC: TLabel;
    edtHCPCSSearchString: TEdit;
    grdSelectHCPCS: TStringGrid;
    btnClearList: TButton;
    btnSearch: TBitBtn;
    edtHCPCSIEN: TEdit;
    btnSelectHCPCS: TBitBtn;
    procedure edtHCPCSSearchStringKeyPress(Sender: TObject; var Key: Char);
    procedure btnSearchClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure grdSelectHCPCSKeyPress(Sender: TObject; var Key: Char);
    procedure btnSelectHCPCSClick(Sender: TObject);
    procedure btnClearListClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure grdSelectHCPCSDblClick(Sender: TObject);
  private
    { Private declarations }
    procedure HCPCSSearch;
  public
    { Public declarations }
  end;

var
  frmSelHCPCS: TfrmSelHCPCS;

implementation

uses
PROS_Menu
,uPROS_InventoryTransactionEdit;

{$R *.dfm}


procedure TfrmSelHCPCS.HCPCSSearch;
var
 i : integer;
begin
 if length(edtHCPCSSearchString.Text) > 1 then
  begin
  btnClearList.Click;

  frmMenu.brkrRPC.CreateContext('RMPR PURCHASE ORDER GUI');
  frmMenu.brkrRPC.RemoteProcedure := 'RMPR HCPCS LOOKUP';
  frmMenu.brkrRPC.Param[0].Value := edtHCPCSSearchString.Text;
  frmMenu.brkrRPC.Param[0].PType := literal;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

    if frmMenu.brkrRPC.Results.Count > 0 then
        grdSelectHCPCS.RowCount := frmMenu.brkrRPC.Results.Count +1;

    for i:= 0 to frmMenu.brkrRPC.Results.Count -1  do  //Tab 4


    with grdSelectHCPCS do
    begin
      Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);
      Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3);
      Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',5);
      Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);
    end;

    grdSelectHCPCS.SetFocus;
//    edtHCPCSIEN.Text := grdSelectHCPCS.cells[3,grdSelectHCPCS.Row];  //Sets first DFN
   end
  else
   ShowMessage('Please enter at least 2 characters.');
end;

procedure TfrmSelHCPCS.btnClearListClick(Sender: TObject);
var
 i : integer;
begin
  begin
   for i :=1 to grdSelectHCPCS.RowCount -1 do   //If selected will clear the grid
       grdSelectHCPCS.Rows[i].Clear;
       grdSelectHCPCS.Row := 1;
       grdSelectHCPCS.Cells[0,1] :='';
  end;
 edtHCPCSIEN.text := '';
end;

procedure TfrmSelHCPCS.btnSearchClick(Sender: TObject);
begin
HCPCSSearch;
end;

procedure TfrmSelHCPCS.btnSelectHCPCSClick(Sender: TObject);
begin
   frmInventoryTransactionEdit.edtIssuedHCPCSIEN.Text := grdSelectHCPCS.cells[3,grdSelectHCPCS.Row];
   frmInventoryTransactionEdit.edtIssuedHCPCS.Text := grdSelectHCPCS.cells[0,grdSelectHCPCS.Row];
Close;
end;

procedure TfrmSelHCPCS.edtHCPCSSearchStringKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = char(VK_RETURN)
    then HCPCSSearch;
end;

procedure TfrmSelHCPCS.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 release;
end;

procedure TfrmSelHCPCS.FormCreate(Sender: TObject);
begin
with grdSelectHCPCS do               // Sets column headers
 begin
      Cells[0,0] := 'HCPCS';
        ColWidths[0] := 50;

      Cells[1,0] := 'Description';
        ColWidths[1] := 500;

      Cells[2,0] := 'IEN 661.1';
        ColWidths[2] := -1;
 end;
end;


procedure TfrmSelHCPCS.grdSelectHCPCSDblClick(Sender: TObject);
begin
btnSelectHCPCS.Click;
end;

procedure TfrmSelHCPCS.grdSelectHCPCSKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = char(VK_RETURN)
  then btnSelectHCPCS.Click;

  if Key = char(VK_Escape) then
  begin
  btnClearList.Click;
  edtHCPCSSearchString.SetFocus;
  edtHCPCSSearchString.SelStart := Length(edtHCPCSSearchString.Text); // set caret after the last character
  end;

  if Key = char(VK_Back) then
  begin
  edtHCPCSSearchString.SetFocus;
  edtHCPCSSearchString.SelStart := length(edtHCPCSSearchString.Text); // set caret after the last character
  edtHCPCSSearchString.Perform(WM_CHAR, VK_BACK, 1);

  end;
end;

end.
