unit PROS_POC_PolicyIFCAP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons,Trpcb, MFunStr;

type
  TfrmPolicyIFCAP = class(TForm)
    btnSelSite: TBitBtn;
    btnSelCommonNumberSeries: TBitBtn;
    btnSelVendor: TBitBtn;
    btnSelPCard: TBitBtn;
    btnCreatePO: TBitBtn;
    btnSelCostCenter: TBitBtn;
    btnAddItem: TBitBtn;
    btnSelBOC: TBitBtn;
    chkSelSite: TCheckBox;
    chkCreatePO: TCheckBox;
    chkSelVendor: TCheckBox;
    chkSelCommonNumberSeries: TCheckBox;
    chkSelPCard: TCheckBox;
    chkSelCostCenter: TCheckBox;
    chkSelBOC: TCheckBox;
    chkAddItem: TCheckBox;
    Label1: TLabel;
    btnSendPO: TBitBtn;
    btnCloseConsult: TBitBtn;
    CheckBox1: TCheckBox;
    procedure btnSelSiteClick(Sender: TObject);
    procedure btnSelCommonNumberSeriesClick(Sender: TObject);
    procedure btnSelVendorClick(Sender: TObject);
    procedure btnSelPCardClick(Sender: TObject);
    procedure btnCreatePOClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnSelCostCenterClick(Sender: TObject);
    procedure btnSendPOClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPolicyIFCAP: TfrmPolicyIFCAP;

implementation

uses PROS_POC_SelSite, PROS_POC_SelCommonNumberSeries, PROS_POC_SelVendor,
  PROS_POC_SelPurchaseCard, PROS_POC_Consult, PROS_POC_PurOrder,
  PROS_POC_SelCostCenter, PROS_POC_ElectronicSig;

{$R *.DFM}

procedure TfrmPolicyIFCAP.btnSelSiteClick(Sender: TObject);
begin
Application.CreateForm(TfrmSelSiteID, frmSelSiteID);
frmSelSiteID.ShowModal;
end;

procedure TfrmPolicyIFCAP.btnSelCommonNumberSeriesClick(Sender: TObject);
begin
Application.CreateForm(TfrmSelCommonNumberSeries, frmSelCommonNumberSeries);
frmSelCommonNumberSeries.ShowModal;

end;

procedure TfrmPolicyIFCAP.btnSelVendorClick(Sender: TObject);
begin
Application.CreateForm(TfrmSelVendor, frmSelVendor);
frmSelVendor.ShowModal;
end;

procedure TfrmPolicyIFCAP.btnSelPCardClick(Sender: TObject);
begin
Application.CreateForm(TfrmSelPurchaseCard, frmSelPurchaseCard);
frmSelPurchaseCard.ShowModal;
end;

procedure TfrmPolicyIFCAP.btnCreatePOClick(Sender: TObject);
var
PONumberIEN : String;

begin

if ((frmPolicyIFCAP.chkSelSite.Checked) and
    (frmPolicyIFCAP.chkSelVendor.Checked) and
    (frmPolicyIFCAP.chkSelCommonNumberSeries.Checked) and
    (frmPolicyIFCAP.chkSelPCard.Checked) and
    (frmPolicyIFCAP.chkSelCostCenter.Checked) and
    (frmPolicyIFCAP.chkSelBOC.Checked)) then
    begin


// Get IFCAP PO number

    frmConsult.brkrRPC.RemoteProcedure := 'RMPR CREATE PO'; //IFCAP call for PO number
    frmConsult.brkrRPC.Param[1].Value := CommonNumberSeries;
    frmConsult.brkrRPC.Param[1].PType := literal;
    frmConsult.brkrRPC.Param[2].Value := PurchasingAgentID; //DUZ
    frmConsult.brkrRPC.Param[2].PType := literal;
    frmConsult.brkrRPC.Param[3].Value := StationNumber; //IEN 669.9
    frmConsult.brkrRPC.Param[3].PType := literal;
    frmConsult.brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?

    frmConsult.brkrRPC.Call;

    PONumberIEN := Piece(frmConsult.brkrRPC.Results[0],'^',1);//IEN 442
       IFCAPNum := Piece(frmConsult.brkrRPC.Results[0],'^',2);//PO Number

    frmConsult.brkrRPC.RemoteProcedure := 'RMPR FILE CREATE 664'; //Create IFCAP storage file
    frmConsult.brkrRPC.Param[1].Value := PurchasingAgentID;
    frmConsult.brkrRPC.Param[1].PType := literal;
    frmConsult.brkrRPC.Param[2].Value := SelectedPatient;  //IEN of 668
    frmConsult.brkrRPC.Param[2].PType := literal;
    frmConsult.brkrRPC.Param[3].Value := VendorNumber;//Vendor Number
    frmConsult.brkrRPC.Param[3].PType := literal;
    frmConsult.brkrRPC.Param[4].Value := PurchaseCardNumber;
    frmConsult.brkrRPC.Param[4].PType := literal;
    frmConsult.brkrRPC.Param[5].Value := CostCenter;
    frmConsult.brkrRPC.Param[5].PType := literal;
    frmConsult.brkrRPC.Param[6].Value := BOC;
    frmConsult.brkrRPC.Param[6].PType := literal;
    frmConsult.brkrRPC.Param[7].Value := PONumberIEN; //IEN 442
    frmConsult.brkrRPC.Param[7].PType := literal;
    frmConsult.brkrRPC.Param[8].Value := IFCAPNum; //PO Number
    frmConsult.brkrRPC.Param[8].PType := literal;
    frmConsult.brkrRPC.Param[9].Value := StationNumber; //IEN 669.9
    frmConsult.brkrRPC.Param[9].PType := literal;

    frmConsult.brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?

    frmConsult.brkrRPC.Call;

    frmPurOrder.Caption := 'Purchase Order Number:  '+IFCAPNum; //PO Number
  end;
end;

procedure TfrmPolicyIFCAP.FormActivate(Sender: TObject);
begin
  begin
     if ((chkSelSite.Checked) and
         (chkSelVendor.Checked) and
         (chkSelCommonNumberSeries.Checked) and
         (chkSelPCard.Checked) and
         (chkSelCostCenter.Checked) and
         (chkSelBOC.Checked)) then
      begin
         btnCreatePO.Enabled := True;
         chkCreatePO.Enabled := True;
      end;
  end;

end;

procedure TfrmPolicyIFCAP.btnSelCostCenterClick(Sender: TObject);
begin
Application.CreateForm(TfrmSelCostCenter, frmSelCostCenter);
frmSelCostCenter.ShowModal;
end;

procedure TfrmPolicyIFCAP.btnSendPOClick(Sender: TObject);
begin
frmElectronicSignature.Show;
end;

end.
