unit PROS_POC_CloseSuspense;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Diaccess, Fmcmpnts, Fmcntrls, RpcConf1,
  Trpcb, MFunStr;

type
  TfrmCloseSuspense = class(TForm)
    memPostNoteToCPRS: TMemo;
    chkPostComplete: TCheckBox;
    chkPostInitial: TCheckBox;
    chkPostOther: TCheckBox;
    memSendMulti: TMemo;
    lblPostCompleteNotice: TLabel;
    btnCancel: TBitBtn;
    btnPostNote: TBitBtn;
    procedure chkPostCompleteClick(Sender: TObject);
    procedure chkPostInitialClick(Sender: TObject);
    procedure chkPostOtherClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btnPostNoteClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmCloseSuspense: TfrmCloseSuspense;

implementation

uses PROS_POC_PurOrderConsult, PROS_POC_PurOrder, Pros_Menu;

{$R *.dfm}

procedure TfrmCloseSuspense.chkPostCompleteClick(Sender: TObject);
begin
  if chkPostComplete.Checked = True then
     begin
       chkPostInitial.Checked := False;
       chkPostOther.Checked := False;
       lblPostCompleteNotice.Visible := True;
       memPostNoteToCPRS.SetFocus;
     end
     else
       lblPostCompleteNotice.Visible := False;

end;

procedure TfrmCloseSuspense.chkPostInitialClick(Sender: TObject);
begin
  if chkPostInitial.Checked = True then
     begin
       chkPostComplete.Checked := False;
       chkPostOther.Checked := False;
       memPostNoteToCPRS.SetFocus;
     end;

end;

procedure TfrmCloseSuspense.chkPostOtherClick(Sender: TObject);
begin
  if chkPostOther.Checked = True then
     begin
       chkPostComplete.Checked := False;
       chkPostInitial.Checked := False;
       memPostNoteToCPRS.SetFocus;
     end;

end;

procedure TfrmCloseSuspense.btnCancelClick(Sender: TObject);
begin
Close;
end;

procedure TfrmCloseSuspense.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Release;
end;

procedure TfrmCloseSuspense.btnPostNoteClick(Sender: TObject);
var
Status, StatusFlag,s : string;
CMaskTemp : String[15];
  Mult1: TMult;
  i,j,k : integer;
begin
  begin
   StatusFlag := '';
   memSendMulti.Lines.Clear;
   if chkPostComplete.Checked = True then StatusFlag := '1';
   if chkPostComplete.Checked = True then Status := 'CLOSED';
   if chkPostInitial.Checked = True then StatusFlag := '0';
   if chkPostInitial.Checked = True then Status := 'PENDING';
   if chkPostOther.Checked = True then StatusFlag := '2';
   if chkPostOther.Checked = True then Status := 'PENDING';
  end;

  if StatusFlag = '' then
      begin
       MessageDlg('Please select the TYPE of posting for this NOTE',mtInformation, [mbOk],0);

      end
  else

 if memPostNoteToCPRS.Lines.Count < 1 then
       MessageDlg('Please enter the NOTE to be posted', mtInformation,[mbOk], 0)
  else

     begin
         for k:=0 to memPostNoteToCPRS.Lines.Count -1 do
         begin
          memSendMulti.Lines.Add(memPostNoteToCPRS.Lines[k]);
         end;


  // Send

        frmMenu.brkrRPC.RemoteProcedure := 'RMPR SUSPENSE ACTIONS';
        frmMenu.brkrRPC.Param[1].Value := IEN668;    //Selected Consult IENs
        frmMenu.brkrRPC.Param[1].PType := literal;
        frmMenu.brkrRPC.Param[2].Value := PurchasingAgentID;  //P.A.'s DUZ
        frmMenu.brkrRPC.Param[2].PType := literal;
        frmMenu.brkrRPC.Param[3].Value := StatusFlag;
        frmMenu.brkrRPC.Param[3].PType := literal;
        frmMenu.brkrRPC.Param[4].Value := Piece(IEN664,',',1);// IEN 664
        frmMenu.brkrRPC.Param[4].PType := literal;
        frmMenu.brkrRPC.Param[5].Mult.Assign (memSendMulti.Lines);    //
        frmMenu.brkrRPC.Param[5].PType := list;
        frmMenu.brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
     end;




        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
           MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);

        if  Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then
         begin
          ShowMessage(Piece(frmMenu.brkrRPC.Results[0],'^',2));

           begin
            CMaskTemp := '';
            CMaskTemp := CompletionMask;
            Delete (CMaskTemp,4,1);
            Insert('0',CMaskTemp,4); //Allow closing of all purchase order
            CompletionMask := CMaskTemp;
            CMaskTemp := '';
           end;

          frmPurOrderConsult.grdConsult.Cells[8,RowID] := Status; //Update STATUS in grid

          frmCloseSuspense.Close;
          frmPurOrder.Close;
         end;
                  //   frmCloseSuspense.Visible := True;  //Keeps Close Suspense screen active
    end;

// Close;

end;

procedure TfrmCloseSuspense.FormCreate(Sender: TObject);
begin
   if Sec508 = '1' then    //if registry entry is 1 then change colors
   begin
    frmCloseSuspense.Brush.Color := clBtnFace;
    frmCloseSuspense.Font.Color := clBlack;
    chkPostComplete.Brush.Color := clBtnFace;
    chkPostComplete.Font.Color := clBlack;
    chkPostInitial.Brush.Color := clBtnFace;
    chkPostInitial.Font.Color := clBlack;
    chkPostOther.Brush.Color := clBtnFace;
    chkPostOther.Font.Color := clBlack;
    lblPostCompleteNotice.Font.Color := clBlack;
   end;

  if Copy(CompletionMask,11,1) = '1' then  //Lab Order
    begin
     chkPostComplete.Enabled := False;
     lblPostCompleteNotice.Caption := 'LAB ORDER - Post Complete not available';
    end;
end;

procedure TfrmCloseSuspense.FormActivate(Sender: TObject);
begin
Application.HelpFile := 'PROS_POC_HELPFILE.HLP'; //Needed here
end;

end.
