unit PROS_POC_SelConsult;     //Selected Patient Grid

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, MyGrids, SortGrid, Grids, SRGrad, MFunStr, Trpcb;

type
  TfrmSelConsult = class(TForm)
    BitBtn2: TBitBtn;
    StringGrid4: TSortGrid;
    SRGradient1: TSRGradient;
    BitBtn1: TBitBtn;
    ListBox1: TListBox;
    procedure BitBtn2Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure StringGrid4DblClick(Sender: TObject);
    procedure StringGrid4DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure BitBtn1Click(Sender: TObject);
    procedure StringGrid4Click(Sender: TObject);
  private
    { Private declarations }
    procedure WMWindowPosChanging(var Msg : TMessage) ; //Prevent moving
               message WM_WINDOWPOSCHANGING ;
  public
    { Public declarations }
  end;

var
  frmSelConsult: TfrmSelConsult;

implementation

uses  PROS_POC_AddEdit, PROS_POC_View2319,
  PROS_POC_ExtDesc, PROS_POC_DeliverTo, PROS_POC_OtherDelLoc,
  PROS_POC_PurOrderConsult;


{$R *.DFM}

//*********
procedure TfrmSelConsult.WMWindowPosChanging(var Msg : TMessage) ;
begin
     { do not allow user to move or resize the window }
//     with PWindowPos(Msg.LParam)^ do
//        Flags := Flags or SWP_NOMOVE or SWP_NOSIZE ;
end;



procedure TfrmSelConsult.BitBtn2Click(Sender: TObject);
begin
frmAddEdit.Close;     //Closes both forms at same time;
Close;
end;

procedure TfrmSelConsult.FormActivate(Sender: TObject);
var
i,j : integer;
SelPat : array of string;
begin
 j:=0;
 ListBox1.Items.Clear;

 StringGrid4.Cells[0,0] := 'Patient';
 StringGrid4.Cells[1,0] := 'SSN';
 StringGrid4.Cells[2,0] := 'Description';
 for i:= 0 to frmPurOrderConsult.grdConsult.RowCount  do
   begin
    SetLength(SelPat,i);
   if frmPurOrderConsult.grdConsult.Cells[0,i] = 'Yes' then  //Get frmPurOrderConsult YES records
     begin
     inc(j);
     StringGrid4.Cells[0,j] := frmPurOrderConsult.grdConsult.Cells[5,i];//Patient
     StringGrid4.Cells[1,j] := Piece(frmPurOrderConsult.grdConsult.Cells[6,i],'-',3);//SSN
     StringGrid4.Cells[2,j] := frmPurOrderConsult.grdConsult.Cells[7,i];//Desc
     StringGrid4.Cells[3,j] := frmPurOrderConsult.grdConsult.Cells[9,i];//IEN
     ListBox1.Items.Add(StringGrid4.Cells[3,j]);

     end;
    end;
    StringGrid4.RowCount := j +1; //Remove excess rows from grid



 end;


//Sends data to the Item Edit screen as defaults
procedure TfrmSelConsult.StringGrid4DblClick(Sender: TObject);
begin

//frmAddEdit.lblPtName.Caption := StringGrid4.Cells[0,StringGrid4.Row];//Displays Patient info
//frmAddEdit.lblPtSSN.Caption := StringGrid4.Cells[1,StringGrid4.Row];//Displays SSN
//frmAddEdit.Edit3.Text := StringGrid4.Cells[3,StringGrid4.Row];//IEN668
//frmAddEdit.edtBriefDesc.Text := StringGrid4.Cells[2,StringGrid4.Row];//Gets Brief Desc
end;

procedure TfrmSelConsult.StringGrid4DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
 begin
  with StringGrid4 do
  begin

  // Draw the Bands with alternating colors
     if ARow mod 2 = 0 then
        Canvas.Brush.Color := $CFFFFF//$00E1FFF9
      else
        Canvas.Brush.Color := $FFFFFF;//$00FFEBDF;

  // Don't change color for first Column, first row
    if {(ACol = 0) or} (ARow = 0) then
      Canvas.Brush.Color := clBtnFace
    else
    begin

// Set color for selected row
  if gdSelected in State then
  begin
    Canvas.Brush.Color := clActiveCaption;
    Canvas.Font.Color  := clCaptionText;
  end;


//Final draw of grid
      Canvas.TextRect(Rect, Rect.Left + 2, Rect.Top + 2, cells[acol, arow]);
      Canvas.FrameRect(Rect);
   end;
 end;
end;


procedure TfrmSelConsult.BitBtn1Click(Sender: TObject);
begin
frmView2319.ShowModal;
end;

procedure TfrmSelConsult.StringGrid4Click(Sender: TObject);
var
  i : integer;
begin
//clear Add/Edit Values
   frmAddEdit.rgrpPatientCatagory.ItemIndex := 0;
//   frmAddEdit.rgrpDelivery.ItemIndex := 0;
   frmAddEdit.edtItemNumber.Text := '';
   frmAddEdit.edtContractNumber.Text := '';
   frmAddEdit.edtBriefDesc.Text := '';
   frmAddEdit.cbxItem.Text := '';
   frmAddEdit.cbxHCPCS.Text := '';
   frmAddEdit.edtQty.Text := '0';
   frmAddEdit.cbxUnitOfIssue.Text := 'EA';
   frmAddEdit.edtUnitCost.Value := 0.00;
//   frmAddEdit.edtPerDiscount.Value := 0.00;
//   frmAddEdit.edtshipping.Value := 0.00;
//   frmAddEdit.edtSubTotal.Value := 0.00;
//   frmAddEdit.edtDolDiscount.Value := 0.00;
//   frmExtDesc.Memo1.Clear;
//   frmDeliverTo.edtNoteToReceiver.Text := '';
   //frmOtherDelLoc.Memo1.Clear;

//Done

  PatName := StringGrid4.Cells[0,StringGrid4.Row] //For display in other forms
        +'     SSN: '+StringGrid4.Cells[1,StringGrid4.Row];
        //+'     DOB: ';
  IEN668  := StringGrid4.Cells[3,StringGrid4.Row]; //For display in other forms

  frmAddEdit.lblPtName.Caption := StringGrid4.Cells[0,StringGrid4.Row];//Displays Patient info
  frmAddEdit.lblPtSSN.Caption := StringGrid4.Cells[1,StringGrid4.Row];//Displays SSN
//  frmAddEdit.edtContractNumber.Text := StringGrid4.Cells[3,StringGrid4.Row];//IEN668
  frmAddEdit.edtBriefDesc.Text := StringGrid4.Cells[2,StringGrid4.Row];//Gets Brief Desc


//***************************
begin  //Mini Dis Grid

  TRY
    frmPurOrderConsult.brkrRPC.RemoteProcedure := 'RMPR DIS LIST';
    frmPurOrderConsult.brkrRPC.Param[0].Value := IEN668;
    frmPurOrderConsult.brkrRPC.Param[0].PType := literal;
    frmPurOrderConsult.brkrRPC.Call; //Removed for CoreFLS

    //grdMiniDis.Clear;
   if  frmPurOrderConsult.brkrRPC.Results.Count < 2 then frmAddEdit.grdMiniDis.RowCount := 2
   else
  frmAddEdit.grdMiniDis.RowCount := frmPurOrderConsult.brkrRPC.Results.Count +1;//Sizes grid to match results

 for i:= 0 to frmPurOrderConsult.brkrRPC.Results.Count -1 do
   begin   //Pulled for CoreFLS
   frmAddEdit.grdMiniDis.Cells[0,i+1] := Piece(frmPurOrderConsult.brkrRPC.Results[i],'^',1);//Disab
   frmAddEdit.grdMiniDis.Cells[1,i+1] := Piece(frmPurOrderConsult.brkrRPC.Results[i],'^',2);//% Disab
   frmAddEdit.grdMiniDis.Cells[2,i+1] := Piece(frmPurOrderConsult.brkrRPC.Results[i],'^',3);//SC Y/N
      if Piece(frmPurOrderConsult.brkrRPC.Results[i],'^',1) = 'NOTHING FOUND' then
      frmAddEdit.grdMiniDis.Cells[2,i+1] := '';
   end;
  Except
 end;

end;   //Mini Dis Grid
//***************************




end;


end.
