unit PROS_POC_SelCostCenter;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Fmcntrls, Trpcb, MFunStr, ExtCtrls;
type
  TfrmSelCostCenter = class(TForm)
    cbxSelCostCenter: TFMComboBoxLookUp;
    btnOk: TBitBtn;
    Image1: TImage;
    procedure cbxSelCostCenterDropDown(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure cbxSelCostCenterEnter(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmSelCostCenter: TfrmSelCostCenter;

implementation

uses PROS_POC_PurOrderConsult, PROS_POC_PurOrder, Pros_Menu;

{$R *.DFM}

procedure TfrmSelCostCenter.cbxSelCostCenterDropDown(Sender: TObject);
var
  i : integer;
  StringList: TStrings;
begin

   StringList := TStringList.Create;

    frmMenu.brkrRPC.RemoteProcedure := 'RMPR LIST COST CENTER';
    frmMenu.brkrRPC.Param[1].Value := FundControlPoint; //or 2737
    frmMenu.brkrRPC.Param[1].Ptype := literal;
    frmMenu.brkrRPC.Param[2].Value := SiteIEN;
    frmMenu.brkrRPC.Param[2].PType := literal;


  TRY
    frmMenu.brkrRPC.Call;
  Except
   on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage('E.Message');
     else
       raise;
  END;



  try
    with StringList do begin
       for i:= 0 to frmMenu.brkrRPC.Results.Count -1 do
         begin
          Add (Piece(frmMenu.brkrRPC.Results[i],'^',1)+'  '+//Cost Center
               Piece(frmMenu.brkrRPC.Results[i],'^',2));    //IEN 420.1
              //Add('It is the easiest way to add strings');
        end;
    end;

    with cbxSelCostCenter do begin

      //Width := 210;
      Items.Assign(StringList);
      ItemIndex := 0;
    end;
  finally
    StringList.free;
  end;

end;

procedure TfrmSelCostCenter.btnOkClick(Sender: TObject);
begin
 if cbxSelCostCenter.Text <> '' then
  begin
    frmPurOrder.edtCostCenter.Text := Piece(cbxSelCostCenter.Text,'  ',1);
    CostCenterIEN := Piece(cbxSelCostCenter.Text,'  ',2);
    frmPurOrder.edtCostCenterIEN.Text := CostCenterIEN;
//    frmPurOrder.btnSelCostCenter.Font.Color := clGreen;
//    frmPurOrder.imgSelCostCenter.Visible := True;
    frmPurOrder.btnSelVendor.Enabled := True;
    frmPurOrder.btnSelVendor.Font.Color := clRed;
    Insert('1',CompletionMask,7); //Cost Center is set
//       frmPolicyCoreFLS.btnSelBOC.Enabled := True;
    end
   else
    begin
     frmPurOrder.edtCostCenter.Text := ''; //Clears Cost Center text
     CostCenterIEN := '';
     frmPurOrder.edtCostCenterIEN.Text := '';
//     frmPurOrder.btnSelCostCenter.Font.Color := clRed;
//     frmPurOrder.imgSelCostCenter.Visible := False;
     Insert('0',CompletionMask,7); //Cost Center not set
     frmPurOrder.btnSelVendor.Enabled := False;
     frmPurOrder.btnSelVendor.Font.Color := clRed;
//       frmPolicyCoreFLS.btnSelBOC.Enabled := False;
    end;
 Release;
end;

procedure TfrmSelCostCenter.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Release;
end;

procedure TfrmSelCostCenter.cbxSelCostCenterEnter(Sender: TObject);
begin
cbxSelCostCenter.Perform(CB_SETDROPPEDWIDTH, 500, 0);
end;

end.
