unit PROS_POC_Shipping;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, CurrEdit, NumEdit, ExtCtrls;

type
  TfrmShipping = class(TForm)
    edtShipping: TCurrencyEdit;
    btnShippingOk: TBitBtn;
    edtPerDiscount: TFloatEdit;
    lblPerDiscount: TLabel;
    lblShipping: TLabel;
    imgArrow: TImage;
    procedure btnShippingOkClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure edtPerDiscountEnter(Sender: TObject);
    procedure edtShippingEnter(Sender: TObject);
    procedure edtPerDiscountMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure edtShippingMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure edtShippingExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmShipping: TfrmShipping;


implementation

uses PROS_POC_PurOrderConsult, PROS_POC_PurOrder;

{$R *.dfm}

procedure TfrmShipping.btnShippingOkClick(Sender: TObject);
begin
 if edtShipping.Value < 0 then  //check for a positive value
   begin
    ShowMessage('Please enter a valid shipping charge.');
    edtShipping.SelectAll;
   end
  else
  begin
   frmPurOrder.edtPerDiscount.Value := edtPerDiscount.Value;
   frmPurOrder.edtShipping.Value := edtShipping.Value;
   if (edtPerDiscount.Value = 0) or (edtShipping.Value = 0) then
      frmPurOrder.imgShipping.Visible := True
    else
      frmPurOrder.imgShipping.Visible := False;
   frmPurOrder.CalcPOTotal;
   Release;
 end;
end;

procedure TfrmShipping.FormActivate(Sender: TObject);
begin
Application.HelpFile := 'PROS_POC_HELPFILE.HLP'; //Needed here

edtPerDiscount.Value := frmPurOrder.edtPerDiscount.Value;
edtShipping.Value := frmPurOrder.edtShipping.Value;
end;

procedure TfrmShipping.edtPerDiscountEnter(Sender: TObject);
begin
edtPerDiscount.Value := 0;
edtPerDiscount.SelectAll;
end;

procedure TfrmShipping.edtShippingEnter(Sender: TObject);
begin
edtShipping.Value := 0;
edtShipping.SelectAll;
end;

procedure TfrmShipping.edtPerDiscountMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
edtPerDiscount.SelectAll;
end;

procedure TfrmShipping.edtShippingMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
edtShipping.SelectAll;
end;

procedure TfrmShipping.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
Release;
end;

procedure TfrmShipping.FormCreate(Sender: TObject);
begin
   if Sec508 = '1' then    //if registry entry is 1 then change colors
   begin
    frmShipping.Brush.Color := clBtnFace;
    frmShipping.Font.Color := clBlack;
    lblPerDiscount.Font.Color := clBlack;
    lblShipping.Font.Color := clBlack;
   end;
end;

procedure TfrmShipping.edtShippingExit(Sender: TObject);
begin
 if ((edtShipping.Value > 99999) or (edtShipping.Value < 0)) then
  begin
  ShowMessage('Please enter a valid COST less than $99999.00');
  edtShipping.SetFocus;
  end;
if edtShipping.Value < 0 then
 begin
  ShowMessage('Please enter a valid shipping charge. Must be a postive number.');
  edtShipping.Value := 0;
  edtShipping.SelectAll;
 end;
end;

end.
