unit uPROS_CreateManual;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Diaccess, Fmcmpnts, ComCtrls, Fmcntrls, ESBDates,
  Trpcb, MFunStr, grids, ExtCtrls, VA508AccessibilityManager;

type
  TfrmCreateManual = class(TForm)
    btnCreateManual: TBitBtn;
    calSelSuspenseDate: TDateTimePicker;
    edtRequesterIEN: TEdit;
    memCreateManual: TMemo;
    edtSuspenseDate: TEdit;
    edtSiteIEN: TEdit;
    grdSelectUser: TStringGrid;
    edtRequesterSearchString: TEdit;
    btnClearList: TBitBtn;
    edtSiteSearchString: TEdit;
    grdSelectSite: TStringGrid;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Panel1: TPanel;
    pnlPatientNameSSN: TPanel;
    edtManualPtIEN: TEdit;
    edtSenderWindow: TEdit;
    btnCancel: TBitBtn;
    rgpUrgency: TFMRadioGroup;
    edtUrgency: TEdit;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    VA508ComponentAccessibility1: TVA508ComponentAccessibility;
    VA508ComponentAccessibility2: TVA508ComponentAccessibility;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure calSelSuspenseDateCloseUp(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnCreateManualClick(Sender: TObject);
    procedure btnClearListClick(Sender: TObject);
    procedure edtRequesterSearchStringKeyPress(Sender: TObject; var Key: Char);
    procedure grdSelectUserKeyPress(Sender: TObject; var Key: Char);
    procedure grdSelectUserDblClick(Sender: TObject);
    procedure grdSelectUserClick(Sender: TObject);
    procedure edtSiteSearchStringKeyPress(Sender: TObject; var Key: Char);
    procedure grdSelectSiteKeyPress(Sender: TObject; var Key: Char);
    procedure grdSelectSiteClick(Sender: TObject);
    procedure grdSelectSiteDblClick(Sender: TObject);
    procedure calSelSuspenseDateChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
    procedure rgpUrgencyClick(Sender: TObject);
  private
    { Private declarations }
    procedure UserSearch;
    procedure SiteSearch;
    procedure CreateManual;
  public
    { Public declarations }
  end;

var
  frmCreateManual: TfrmCreateManual;

implementation

uses
PROS_Menu
,PROS_POC_PurOrderConsult
,uPROS_POC_SuspenseProcessingSingle;

{$R *.dfm}

procedure TfrmCreateManual.UserSearch;
var
 i : integer;
begin
 if length(edtRequesterSearchString.Text) > 1 then
  begin
 // btnClearList.Click;

  frmMenu.brkrRPC.CreateContext('RMPR PURCHASE ORDER GUI');
  frmMenu.brkrRPC.RemoteProcedure := 'RMPR USER LOOKUP';
  frmMenu.brkrRPC.Param[0].Value := edtRequesterSearchString.Text;
  frmMenu.brkrRPC.Param[0].PType := literal;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

    if frmMenu.brkrRPC.Results.Count > 0 then
        grdSelectUser.RowCount := frmMenu.brkrRPC.Results.Count +1;

    for i:= 0 to frmMenu.brkrRPC.Results.Count -1  do  //Tab 4


    with grdSelectUser do
    begin
      Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2);
      Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1);
    end;
    grdSelectUser.Visible := True;
    grdSelectUser.SetFocus;
    edtRequesterIEN.text := grdSelectUser.cells[1,grdSelectUser.Row];  //Sets first DFN
   end
  else
   ShowMessage('Please enter at least 2 characters.');
end;


procedure TfrmCreateManual.SiteSearch;
var
 i : integer;
begin
 if length(edtSiteSearchString.Text) > -1 then
  begin
//  btnClearList.Click;

  frmMenu.brkrRPC.CreateContext('RMPR PURCHASE ORDER GUI');
  frmMenu.brkrRPC.RemoteProcedure := 'RMPR SITE PARAMETER LOOKUP';
  frmMenu.brkrRPC.Param[0].Value := edtSiteSearchString.Text;
  frmMenu.brkrRPC.Param[0].PType := literal;

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

    if frmMenu.brkrRPC.Results.Count > 0 then
        grdSelectSite.RowCount := frmMenu.brkrRPC.Results.Count +1;

    for i:= 0 to frmMenu.brkrRPC.Results.Count -1  do  //Tab 4


    with grdSelectSite do
    begin
      Cells[0,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',2); //Site Name
      Cells[1,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',3); //Site Number
      Cells[2,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',1); //IEN 669.9
      Cells[3,i+1] := Piece(frmMenu.brkrRPC.Results[i],'^',4); //IEN 4
    end;
    grdSelectSite.Visible := True;
    grdSelectSite.SetFocus;
    edtSiteIEN.text := grdSelectSite.cells[3,grdSelectSite.Row];  //Sets first DFN
   end
  else
   ShowMessage('Please enter at least 2 characters.');
end;


procedure TfrmCreateManual.CreateManual;

begin // data check
  if edtSuspenseDate.Text = '' then
    begin
    ShowMessage('Please enter a valid date');
    calSelSuspenseDate.SetFocus;
//    Exit;
    end
   else
  if edtSiteIEN.Text = '' then
    begin
    ShowMessage('Please select a SITE');
    edtSiteSearchString.SetFocus;
//    Exit;
    end
   else
  if edtRequesterSearchString.Text = '' then
    begin
    ShowMessage('Please enter a valid REQUESTER');
    edtRequesterSearchString.SetFocus;
//    Exit;
    end
   else
  if edtManualPtIEN.Text = '' then
    begin
    ShowMessage('An ERROR has occured with the Patient''s IEN Record - Closing');
    Close;
    end
   else

begin
        frmMenu.brkrRPC.RemoteProcedure := 'RMPR CREATE MANUAL';
        frmMenu.brkrRPC.Param[1].Value := edtSuspenseDate.Text;    //Selected Consult IENs
        frmMenu.brkrRPC.Param[1].PType := literal;
        frmMenu.brkrRPC.Param[2].Value := edtSiteIEN.text;
        frmMenu.brkrRPC.Param[2].PType := literal;
        frmMenu.brkrRPC.Param[3].Value := edtRequesterIEN.text;   //P.A.'s DUZ
        frmMenu.brkrRPC.Param[3].PType := literal;
        frmMenu.brkrRPC.Param[4].Value := edtManualPtIEN.Text;
        frmMenu.brkrRPC.Param[4].PType := literal;
        frmMenu.brkrRPC.Param[5].Value := '5'; //Type of request 5 = Manual Non CPRS
        frmMenu.brkrRPC.Param[5].PType := literal;
        frmMenu.brkrRPC.Param[6].Value := edtUrgency.text;
        frmMenu.brkrRPC.Param[6].PType := literal;
        frmMenu.brkrRPC.Param[7].Mult.Assign (memCreateManual.Lines);    //
        frmMenu.brkrRPC.Param[7].PType := list;
        frmMenu.brkrRPC.RPCTimeLimit := 600;    //10 Min ?!?

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       ShowMessage(E.Message);
     else
       raise;
     end;


        if Piece(frmMenu.brkrRPC.Results[0],'^',1) = '1' then  //error
           MessageDlg(Piece(frmMenu.brkrRPC.Results[0],'^',2),mtInformation,[mbOk],0);

        if  Piece(frmMenu.brkrRPC.Results[0],'^',1) = '0' then
         begin
          ShowMessage(Piece(frmMenu.brkrRPC.Results[0],'^',2));
          Close;
   end;
  end;
// end; // Data Check Date
// end; // Site
// end; // Requester
// end; // Data Check Pat IEN
end;

procedure TfrmCreateManual.edtSiteSearchStringKeyPress(Sender: TObject; var Key: Char);
begin
 if Key = char(VK_RETURN)
    then SiteSearch;
end;

procedure TfrmCreateManual.edtRequesterSearchStringKeyPress(Sender: TObject;
  var Key: Char);
begin
 if Key = char(VK_RETURN)
    then UserSearch;
end;

procedure TfrmCreateManual.btnCancelClick(Sender: TObject);
begin
Close;
end;

procedure TfrmCreateManual.btnClearListClick(Sender: TObject);
var
  i : integer;
begin
  begin
   for i :=1 to grdSelectUser.RowCount -1 do   //If selected will clear the grid
       grdSelectUser.Rows[i].Clear;
       grdSelectUser.Row := 1;
       grdSelectUser.Cells[0,1] :='';
  end;
  begin
   for i :=1 to grdSelectSite.RowCount -1 do   //If selected will clear the grid
       grdSelectSite.Rows[i].Clear;
       grdSelectSite.Row := 1;
       grdSelectSite.Cells[0,1] :='';
  end;
// edtRequesterIEN.text := '';
// edtSiteIEN.Text := '';
end;

procedure TfrmCreateManual.btnCreateManualClick(Sender: TObject);
begin
CreateManual;
if edtSenderWindow.Text = 'SuspenseProcessing' then
 frmSuspenseProcessing.btnDisplay.Click; //refreshes calling grid

if edtSenderWindow.Text = 'SuspenseProcessingSingle' then
 frmSuspenseProcessingSingle.btnDisplay.Click; //refreshes calling grid

Close;
end;

procedure TfrmCreateManual.calSelSuspenseDateChange(Sender: TObject);
begin
  edtSuspenseDate.Text := DateToStr(calSelSuspenseDate.Date);
end;

procedure TfrmCreateManual.calSelSuspenseDateCloseUp(Sender: TObject);
begin
 if (DaysApart(Now,calSelSuspenseDate.Date)) > 0 then
  begin
   edtSuspenseDate.Text := '';
   ShowMessage('Please select TODAY''S date or a date in the past');
   calSelSuspenseDate.Date := Now;
//   calSelSuspenseDate.SetFocus;

   end
 else
 begin
  edtSuspenseDate.Text := DateToStr(calSelSuspenseDate.Date);
  edtRequesterSearchString.SetFocus;  //Movin' on
//  frmCreateManual.Close;
 end;
end;

procedure TfrmCreateManual.FormActivate(Sender: TObject);
begin
    if edtSenderWindow.Text = 'SuspenseProcessingSingle' then
      pnlPatientNameSSN.Caption := SglPatName +'  '+SglPatSSN
     else
    pnlPatientNameSSN.Caption := PatName +'  '+PatSSN; //From Consult grid

end;

procedure TfrmCreateManual.FormClose(Sender: TObject; var Action: TCloseAction);
begin
// frmSuspenseProcessingSingle.btnDisplay.Click; //refreshes the grid
 release;
end;

procedure TfrmCreateManual.FormCreate(Sender: TObject);
var
  l: DWORD;
begin
 btnCreateManual.Caption := 'Create'+#13#10+'&Manual';
  begin
   l := GetWindowLong(Self.Handle, GWL_STYLE); //Hide Min Max btns
   l := l and not (WS_MINIMIZEBOX);
   l := l and not (WS_MAXIMIZEBOX);
   l := SetWindowLong(Self.Handle, GWL_STYLE, l);
  end;


 calSelSuspenseDate.Date := Now;
 edtSuspenseDate.Text := DateToStr(calSelSuspenseDate.Date);


with grdSelectUser do               // Sets column headers
 begin
    Cells[0,0] := 'Requester Name';
    //  ColWidths[0] := 270;
 end;

 with grdSelectSite do               // Sets column headers
 begin
    Cells[0,0] := 'Site Name';
    Cells[1,0] := 'Site #';
    //  ColWidths[0] := 270;
 end;



end;

procedure TfrmCreateManual.grdSelectSiteClick(Sender: TObject);
begin
  edtSiteIEN.text := grdSelectSite.cells[3,grdSelectSite.Row];
  edtSiteSearchString.Text := grdSelectSite.Cells[0,grdSelectSite.row];
end;

procedure TfrmCreateManual.grdSelectSiteDblClick(Sender: TObject);
begin
  edtSiteIEN.text := grdSelectSite.cells[3,grdSelectSite.Row];
  edtSiteSearchString.Text := grdSelectSite.Cells[0,grdSelectSite.row];
  grdSelectSite.Visible := False;
  memCreateManual.SetFocus;
end;

procedure TfrmCreateManual.grdSelectSiteKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = char(VK_RETURN) then
  begin
   edtSiteIEN.text := grdSelectSite.cells[3,grdSelectSite.Row];
   edtSiteSearchString.Text := grdSelectSite.Cells[0,grdSelectSite.row];
   grdSelectSite.Visible := False;
   memCreateManual.SetFocus;
  end;

  if Key = char(VK_Escape) then
  begin
   btnClearList.Click;
   grdSelectSite.Visible := False;
   edtSiteSearchString.SetFocus;
   edtSiteSearchString.SelStart := Length(edtSiteSearchString.Text); // set caret after the last character
  end;

  if Key = char(VK_Back) then
  begin
   grdSelectSite.Visible := False;
   edtSiteSearchString.SetFocus;
   edtSiteSearchString.SelStart := length(edtSiteSearchString.Text); // set caret after the last character
   edtSiteSearchString.Perform(WM_CHAR, VK_BACK, 1);
  end;
end;


procedure TfrmCreateManual.grdSelectUserClick(Sender: TObject);
begin
  edtRequesterIEN.text := grdSelectUser.cells[1,grdSelectUser.Row];
  edtRequesterSearchString.Text := grdSelectUser.Cells[0,grdSelectUser.row];
end;

procedure TfrmCreateManual.grdSelectUserDblClick(Sender: TObject);
begin
  edtRequesterIEN.text := grdSelectUser.cells[1,grdSelectUser.Row];
  edtRequesterSearchString.Text := grdSelectUser.Cells[0,grdSelectUser.row];
  grdSelectUser.Visible := False;
  edtSiteSearchString.SetFocus; //Next . . .
end;

procedure TfrmCreateManual.grdSelectUserKeyPress(Sender: TObject;
  var Key: Char);
begin
  if Key = char(VK_RETURN) then
  begin
   edtRequesterIEN.text := grdSelectUser.cells[1,grdSelectUser.Row];
   edtRequesterSearchString.Text := grdSelectUser.Cells[0,grdSelectUser.row];
   grdSelectUser.Visible := False;
   edtSiteSearchString.SetFocus; //Next . . .
//   memCreateManual.SetFocus;
  end;

  if Key = char(VK_Escape) then
  begin
   btnClearList.Click;
   grdSelectUser.Visible := False;
   edtRequesterSearchString.SetFocus;
   edtRequesterSearchString.SelStart := Length(edtRequesterSearchString.Text); // set caret after the last character
  end;

  if Key = char(VK_Back) then
  begin
   grdSelectUser.Visible := False;
   edtRequesterSearchString.SetFocus;
   edtRequesterSearchString.SelStart := length(edtRequesterSearchString.Text); // set caret after the last character
   edtRequesterSearchString.Perform(WM_CHAR, VK_BACK, 1);
  end;
end;

procedure TfrmCreateManual.rgpUrgencyClick(Sender: TObject);
begin
edtUrgency.text := rgpUrgency.FMInternalCodes.Strings[rgpUrgency.ItemIndex];
end;

end.
