unit uPROS_POC_CloneReason;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Fmcntrls, Buttons, Trpcb,
  VA508AccessibilityManager;

type
  TfrmCloneReason = class(TForm)
    FMEdit1: TFMEdit;
    FMEdit2: TFMEdit;
    FMEdit3: TFMEdit;
    FMEdit4: TFMEdit;
    edtReasonRemarks: TFMEdit;
    lblCloneRemarks: TFMLabel;
    btnCreateClone: TBitBtn;
    btnCloneCancel: TBitBtn;
    edtReasonCode: TFMEdit;
    edtCloneIEN668: TFMEdit;
    rgpCloneReason: TFMRadioGroup;
    rgpUrgency: TFMRadioGroup;
    edtUrgency: TFMEdit;
    VA508AccessibilityManager1: TVA508AccessibilityManager;
    VA508ComponentAccessibility1: TVA508ComponentAccessibility;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure btnCloneCancelClick(Sender: TObject);
    procedure btnCreateCloneClick(Sender: TObject);
    procedure rgpCloneReasonClick(Sender: TObject);
    procedure edtReasonRemarksExit(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rgpUrgencyClick(Sender: TObject);
  private
    { Private declarations }
    OldItemIndex : Integer;
  public
    { Public declarations }
  end;

var
  frmCloneReason: TfrmCloneReason;

implementation

uses PROS_Menu, PROS_POC_PurOrderConsult;

{$R *.dfm}

procedure TfrmCloneReason.btnCreateCloneClick(Sender: TObject);
begin
  if edtReasonCode.Text = '' then
     begin
//       rgpCloneReason.ItemIndex := 1;
       ShowMessage('Please select a Reason from the list');
       rgpCloneReason.SetFocus;
     end
     else

  if (lblCloneRemarks.Caption = 'Remarks (Mandatory):') and
     (edtReasonRemarks.GetTextLen <3) then
    begin
     edtReasonRemarks.SetFocus;
     ShowMessage('Remarks are mandatory for this Reason for the Clone');
     end

   else

begin
  frmMenu.brkrRPC.CreateContext('RMPR PURCHASE ORDER GUI');
  frmMenu.brkrRPC.RemoteProcedure := 'RMPR SUSPENSE CLONE';
  frmMenu.brkrRPC.Param[0].Value := edtCloneIEN668.Text;
  frmMenu.brkrRPC.Param[0].PType := literal;
  frmMenu.brkrRPC.Param[1].Value := edtReasonCode.text;
  frmMenu.brkrRPC.Param[1].PType := literal;
  frmMenu.brkrRPC.Param[2].Value := edtReasonRemarks.text;
  frmMenu.brkrRPC.Param[2].PType := literal;
  frmMenu.brkrRPC.Param[3].Value := edtUrgency.text;
  frmMenu.brkrRPC.Param[3].PType := literal;

//RMPR SUSPENSE ACTIONS  //SATUSCODE = 2
//For Posting to CPRS

    Try
    //
     frmMenu.brkrRPC.Call;

    except
     on E:EBrokerError do
       begin
       Showmessage('Broker Error: '+ E.Message);
       end;
     on E:EAccessViolation do
       Showmessage(E.Message);
     else
       raise;
     end;

    ShowMessage (frmMenu.brkrRPC.Results[0]); //Cloning result message
    frmSuspenseProcessing.btnDisplay.Click; //Refresh grid with new rec
    Close;

 end;
end;

procedure TfrmCloneReason.btnCloneCancelClick(Sender: TObject);
begin
Close;
end;

procedure TfrmCloneReason.edtReasonRemarksExit(Sender: TObject);
begin
 if edtReasonRemarks.Text <> '' then
  begin
   if ((edtReasonRemarks.GetTextLen < 3) or (edtReasonRemarks.GetTextLen > 60)) then
    begin
     ShowMessage('The text entered must be between 3 and 60 characters');
     edtReasonRemarks.SetFocus;
    end;
  end;
end;

procedure TfrmCloneReason.rgpCloneReasonClick(Sender: TObject);
begin
 edtReasonCode.text := rgpCloneReason.FMInternalCodes.Strings[rgpCloneReason.ItemIndex];

begin
  with rgpCloneReason do begin
                                {if there was a previously set item, change it back to the
     default appearance first.}
    if (OldItemIndex > -1) then
      with (Components[OldItemIndex] as TRadioButton) do begin
        Color   := clBtnFace;
        Font.Color := clBtnFace;
        Font.Style := [];
      end;

                                {Now with the currently selected item, change its appearance.}
    with (Components[ItemIndex] as TRadioButton) do begin
//      Color := clBlue;
//      Font.Color := clWhite;
      Font.Style := [fsBold];
      OldItemIndex := ItemIndex;
    end;
   end;
  end;
   if ((rgpCloneReason.ItemIndex = 5)   or   //if OTHER selected
      (rgpCloneReason.ItemIndex = 12)   or
      (rgpCloneReason.ItemIndex = 19))  then
     begin
      lblCloneRemarks.Caption := 'Remarks (Mandatory):';
      edtReasonRemarks.SetFocus;
      Showmessage('Remarks are mandatory for this Reason for the Clone');
      end
     else
      lblCloneRemarks.Caption := 'Remarks (Optional):';

end;

procedure TfrmCloneReason.rgpUrgencyClick(Sender: TObject);
begin
 edtUrgency.text := rgpUrgency.FMInternalCodes.Strings[rgpUrgency.ItemIndex];
end;

procedure TfrmCloneReason.FormActivate(Sender: TObject);
begin
   OldItemIndex := -1;
   rgpCloneReason.Controls[0].Hide;    //hides for format appearance
   rgpCloneReason.Controls[6].Hide;
   rgpCloneReason.Controls[7].Hide;
   rgpCloneReason.Controls[13].Hide;
   rgpCloneReason.Controls[14].Hide;
   rgpCloneReason.Controls[20].Hide;
   rgpCloneReason.Controls[21].Hide;
  end;


procedure TfrmCloneReason.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Release;
end;

procedure TfrmCloneReason.FormCreate(Sender: TObject);
var
  l: DWORD;
begin
  l := GetWindowLong(Self.Handle, GWL_STYLE);
  l := l and not (WS_MINIMIZEBOX);
  l := l and not (WS_MAXIMIZEBOX);
  l := SetWindowLong(Self.Handle, GWL_STYLE, l);
end;

end.
